//	--------------------------------------------------------------------
//	Copyright(C) 2006~2020 NetEase Games. All rights reserved.
//	This file is a part of the project Messiah.
//	Messiah Engine, Technology Department of NetEase Games.
//	Contact : gzwangyingqiao@corp.netease.com
//	Author: gzwangyingqiao
//	$(reservedDeclaration)
//	--------------------------------------------------------------------
///	@file	<AffiliatedToMain.fx>
///	@path	~/System/Shader/
///	@date	2019/10/17
///	@brief	Affiliated To Main

#pragma shader draw
#pragma shader category("Screen")

#include "Constants.fxh"
#include "Common.fxh"

///////////////// samplers //////////////////
// Backbuffer target.
texture2D tAffiliatedMap : AffiliatedMapA : layout(t0);
sampler sAffiliatedSampler : layout(s0)
{
	Texture = tAffiliatedMap;
	Filter = Point;
	Address = Clamp;
	MaxMipLevel = 0;
};

///////////////// io signatures //////////////////
struct a2v 
{
	float4 Position : POSITION; //in object space
	float2 BaseTC   : TEXCOORD0;
};

struct v2f
{
	float4 HPosition : SV_Position;
	float2 TC	: TEXCOORD0;
};

/////////////////// HDRSampleLumInitial ////////////////////
v2f ScreenVS( a2v IN )
{
	v2f OUT;
	float3 vPos = IN.Position.xyz;
	vPos.y = 1-vPos.y;
	OUT.HPosition = float4(vPos.xy*2-1, vPos.z, 1.0);
	OUT.TC = IN.BaseTC;

	[@_GLSL]
	OUT.TC.y = 1 - OUT.TC.y;
	return OUT;
}

float4 AffiliatedToMainPS(v2f IN) : SV_Target
{
	half3 Source = SampleColorMap(tAffiliatedMap, sAffiliatedSampler, IN.TC.xy).rgb;
	return float4(Source, 1.0);
}

technique AffiliatedToMainTech
{
	VertexShader = ScreenVS();
	PixelShader = AffiliatedToMainPS();
}


