//	--------------------------------------------------------------------
//	Copyright(C) 2006~2019 NetEase. All rights reserved.
//	This file is a part of the project Messiah.
//	Messiah Engine, Technology Department of NetEase Games.
//	Contact : gzsunjing@corp.netease.com
//	Author: gzsunjing
//	$(reservedDeclaration)
//	--------------------------------------------------------------------
///	@file	<ClearAttachment.fx>
///	@path	~/System/Shader/
///	@date	2019/07/31
///	@brief	clear render target through postprocess.

#pragma shader draw
#pragma shader category("Screen")

#include "Constants.fxh"
#include "Common.fxh"

///////////////// const buffer //////////////////
cbuffer Batch
{
	float4      cClearColor		;
};

/// Screen only texcoord.
struct VertexAssembleScreen
{
	float4		Position		: POSITION;
};

/// Screen output.
struct VertexScreenOutput
{
	float4		HPosition		: SV_Position;
};

VertexScreenOutput ScreenVS(in VertexAssembleScreen IN)
{
	VertexScreenOutput OUT;
	float3 vPos = IN.Position;
	vPos.y = 1 - vPos.y;
	OUT.HPosition = float4(vPos.xy * 2 - 1, vPos.z, 1.0);
	return OUT;
}

float4 ClearPS(VertexScreenOutput IN) : SV_Target
{
    return cClearColor;
}

technique ClearAttachmentTech
{
	VertexShader = ScreenVS();
	PixelShader = ClearPS();
}
