
#pragma shader draw
#pragma shader category("Screen")

//#include "Constants.fxh"
//#include "Common.fxh"


/// Screen only texcoord.
struct VertexAssembleScreen
{
	float4		Position		: POSITION;
	float2		BaseTC			: TEXCOORD0;
};

/// Screen output.
struct VertexScreenOutput
{
	float4		HPosition		: SV_Position;
	float2		TC				: TEXCOORD0;
};

/// Pixel output.
struct PixelOutput
{
	float4		Color			: SV_Target;
};

VertexScreenOutput ScreenVS(in VertexAssembleScreen IN)
{
	VertexScreenOutput OUT;
	float3 vPos = IN.Position.xyz;
	vPos.y = 1 - vPos.y;
	OUT.HPosition = float4(vPos.xy * 2 - 1, vPos.z, 1.0);
	OUT.TC = IN.BaseTC;
	return OUT;
}


PixelOutput GPUPhysicsDebugTechPS(in VertexScreenOutput IN)
{
    PixelOutput OUT;
    OUT.Color = float4(1.0, 0.0, 0.0, 0.0);
    return OUT;
}

technique GPUPhysicsDebugTech
{
	VertexShader = ScreenVS();
	PixelShader = GPUPhysicsDebugTechPS();
}
