//	--------------------------------------------------------------------
//	Copyright(C) 2006~2019 NetEase. All rights reserved.
//	This file is a part of the project Messiah.
//	Messiah Engine, Technology Department of NetEase Games.
//	Contact : liwenyao@corp.netease.com
//	Author: liwenyao
//	$(reservedDeclaration)
//	--------------------------------------------------------------------
///	@file	<ShadingMode.fxh>
///	@path	Shader/
///	@date	2019/06/27
///	@brief	shading models definition

#ifndef __FILE_DEFINITIONS_FXH__
#define __FILE_DEFINITIONS_FXH__

#ifndef IS_DEFERRED_LIGHTTING
#define	IS_DEFERRED_LIGHTTING					    	0
#endif

#ifndef MATERIAL_SHADINGMODEL_UNLIT
#define	MATERIAL_SHADINGMODEL_UNLIT						0
#endif

#ifndef MATERIAL_SHADINGMODEL_DEFAULT_LIT
#define MATERIAL_SHADINGMODEL_DEFAULT_LIT				0
#endif

#ifndef MATERIAL_SHADINGMODEL_LOD_LIT
#define MATERIAL_SHADINGMODEL_LOD_LIT				    0
#endif

#ifndef MATERIAL_SHADINGMODEL_IMP_LIT
#define MATERIAL_SHADINGMODEL_IMP_LIT				    0
#endif


#ifndef MATERIAL_SHADINGMODEL_CLOTH
#define MATERIAL_SHADINGMODEL_CLOTH				        0
#endif

#ifndef MATERIAL_SHADINGMODEL_PREINTEGRATED_SKIN
#define MATERIAL_SHADINGMODEL_PREINTEGRATED_SKIN		0
#endif

#ifndef MATERIAL_SHADINGMODEL_SSS
#define MATERIAL_SHADINGMODEL_SSS               		0
#endif

#ifndef MATERIAL_SHADINGMODEL_CLEAR_COAT
#define MATERIAL_SHADINGMODEL_CLEAR_COAT		        0
#endif

#ifndef MATERIAL_SHADINGMODEL_TWOSIDED_FOLIAGE
#define MATERIAL_SHADINGMODEL_TWOSIDED_FOLIAGE          0
#endif

#ifndef IS_TERRAIN
#define IS_TERRAIN                                      0
#endif

#ifndef IS_WATER
#define IS_WATER                                        0
#endif

#ifndef IS_FOLIAGE
#define IS_FOLIAGE                                      0
#endif

#ifndef IS_HEIGHTMAP
#define IS_HEIGHTMAP                                    0
#endif

#ifndef DOUBLE_REFLECTCOLOR
#define DOUBLE_REFLECTCOLOR                             0
#endif

#ifndef VIRTUAL_LIT
#define VIRTUAL_LIT                                     0
#endif

#ifndef RTM_REFLECTION
#define RTM_REFLECTION                                  0
#endif

// #ifndef NO_LIGHT_MAP_UV_TRANSFORM
// #define NO_LIGHT_MAP_UV_TRANSFORM                       0
// #endif

#ifndef NO_LIGHT_MAP_SCALE
#define NO_LIGHT_MAP_SCALE                              0
#endif

#ifndef USE_LIGHTMAP_CONST
#define USE_LIGHTMAP_CONST                              0
#endif

#ifndef USE_LIGHTMAP
#define USE_LIGHTMAP                                    0
#endif

#ifndef USE_TESSELLATION
#define USE_TESSELLATION                                0
#endif

#ifndef USE_GRAY
#define USE_GRAY                                        0
#endif

#ifndef USE_UNIDIRECTIONAL_DISSOLVE
#define USE_UNIDIRECTIONAL_DISSOLVE                     0
#endif

#if USE_LIGHTMAP
#if USE_LIGHTMAP_CONST
#define LIGHTMAP_ENABLE (!@_DEBUG && (@_LightMapEnable || @_LightmapConstEnable))
#else
#define LIGHTMAP_ENABLE (!@_DEBUG && @_LightMapEnable)
#endif
#else
#define LIGHTMAP_ENABLE                                 (false)
#endif

#ifndef ALPHA_REF
#define ALPHA_REF                                       (0.33)
#endif

#ifndef SNOW_HEIGHT_MODIFIER 
#define SNOW_HEIGHT_MODIFIER                            (1.0)
#endif

#ifndef SAMPLE_SHELTERMAP
#define SAMPLE_SHELTERMAP	0
#endif

#endif//__FILE_DEFINITIONS_FXH__

