// (100*100*100) / (1024*1024) = 95.36%
#define TEXTURE_SIZE 	(1024)
#define EDGEVOLUMES		(100)
#define FACE_PERLINE	(10)
#define RAYMARCHING_STEPS (10)

#define VolumeIdToXYZId(vid_x, vid_y, xyzId)\
{\
	xyzId.z = (vid_y/EDGEVOLUMES) * FACE_PERLINE + (vid_x/EDGEVOLUMES);\
	xyzId.y = vid_y - (vid_y/EDGEVOLUMES)*EDGEVOLUMES;\
	xyzId.x = vid_x - (vid_x/EDGEVOLUMES)*EDGEVOLUMES;\
}

#define XYZIdToUV(xyzId, uv)\
{\
	uv = xyzId.xy;\
	int by = (int)xyzId.z / FACE_PERLINE;\
	int bx = (int)xyzId.z - by * FACE_PERLINE;\
	uv += half2(bx,by) * EDGEVOLUMES;\
	uv = uv / TEXTURE_SIZE + 0.5 / TEXTURE_SIZE;\
}

#define XYZIdToWorldPos(xyzId, VOLUME_SIZE, MinXYZ) (MinXYZ + xyzId * VOLUME_SIZE)

#define WorldPosToXYZId(worldPos, VOLUME_SIZE, MinXYZ) ((worldPos-MinXYZ) / VOLUME_SIZE)

