#ifndef __SHADER_GRAPH_DEF_FXH__
#define __SHADER_GRAPH_DEF_FXH__

#ifndef VARYING_MASK
#define VARYING_MASK             0
#endif

#define IS_ShaderGraph

// Note: should be synchronized with "ShaderGraphCommon.h"
#define VA_TEXCOORD              0x0001
#define VA_TEXCOORD2             0x0002
#define VA_TINT_COLOR            0x0004
#define VA_WORLD_NORMAL          0x0008
#define VA_WORLD_TANGENT         0x0010
#define VA_WORLD_BINORMAL        0x0020
#define VA_WORLD_POSITION        0x0040
#define VA_VIEW_DIRECTION        0x0080
#define VA_LINEAR_DEPTH          0x0100
#define VA_SCREEN_COORD          0x0200

#ifndef ENABLE_WORLDPOSITION
#define ENABLE_WORLDPOSITION (VARYING_MASK & VA_WORLD_POSITION)
#endif

#ifndef ENABLE_VIEWDIRECTION
#define ENABLE_VIEWDIRECTION (VARYING_MASK & VA_VIEW_DIRECTION)
#endif

#ifndef ENABLE_LINEARDEPTH
#define ENABLE_LINEARDEPTH (VARYING_MASK & VA_LINEAR_DEPTH)
#endif

#ifndef ENABLE_WORLDNORMAL
#define ENABLE_WORLDNORMAL (VARYING_MASK & VA_WORLD_NORMAL)
#endif

#ifndef ENABLE_VERTEXCOLOR
#define ENABLE_VERTEXCOLOR (VARYING_MASK & VA_TINT_COLOR)
#endif

#endif /*__SHADER_GRAPH_DEF_FXH__*/

