//	--------------------------------------------------------------------
//	Copyright(C) 2006~2020 NetEase Games. All rights reserved.
//	This file is a part of the project Messiah.
//	Messiah Engine, Technology Department of NetEase Games.
//	Contact : zhaoyukun@corp.netease.com
//	Author: chaos
//	$(reservedDeclaration)
//	--------------------------------------------------------------------
///	@file	<Streams.fxh>
///	@path	~/System/Shader/Include/
///	@date	2010/05/04
///	@brief	Stream related definition.

// Inputs.

// Geomtry stream.
#define	IN_Position			float4	Position 	: SV_POSITION
#define	IN_Color			float4	Color 		: COLOR0
#define	IN_Coord			float2	BaseTC		: TEXCOORD0
#define	IN_Depth			float	Depth 		: SV_DEPTH;

// Tangent stream.
#define	IN_Tangent			float4	Tangent		: TANGENT; \
							float4	Binormal	: BINORMAL

// Outputs.

// Vertex shader outputs.
#define VS_Position			float4	Position 	: SV_POSITION
#define	VS_Diffuse			float4	Diffuse 	: COLOR0
#define	VS_Specular			float4	Specular	: COLOR1

// Pixel shader outputs.
#define	PS_Output			float4 Output		: SV_TARGET0
#define	PS_Depth			float Depth			: SV_DEPTH

// Predepth map outputs.
#define	DP_Depth			float4 Depth		: SV_TARGET0

// Reflective shadow map outputs.
#define	RS_DepthNormal		float4 DepthNormal	: SV_TARGET0
#define	RS_Flux				float4 Flux			: SV_TARGET1

// Pixel output struct.
struct PixelOutput {
	PS_Output;
};

// Depth output struct.
struct DepthOutput {
	DP_Depth;
};

// RSM output struct.
struct RsmOutput {
	RS_DepthNormal;
	RS_Flux;
};
