#pragma shader material

#define MATERIAL_SHADINGMODEL_DEFAULT_LIT 0

#define USE_LIGHTMAP			0
#define USE_CLIPPING			0
#define USE_WIREFRAME			0
#define USE_XRAY				0
#define USE_HIGHLIGHT			0
#define USE_FROZEN				0
#define USE_BURNT				0
#define USE_EDGELINE			0
#define USE_PLANAR_SHADOW		0
#define USE_LIGHTMAP_CONST		0
#define USE_VBufferGen			0
#define VIRTUAL_LIT 0
#define DOUBLE_REFLECTCOLOR 0

#include "Constants.fxh"
#include "Common.fxh"
#include "Lighting.fxh" 

#pragma shader predict("@_INSTANCED", "false")

//////////////////////////////////Vertex Output////////////////////////////////////////
/// Decal vertex input.
struct VertexAssembleOcclusion
{
	float4		Position		: POSITION;
};

struct VertexOcclusionOutput
{
	// Most common geometric info.
	float4		HPosition		: SV_Position;			//	Position in homogeneous space. For output to rasterizer.
};


//////////////////////////////////VS////////////////////////////////////////
#include "PBR_VS.fxh"

VertexOcclusionOutput OcclusionVertexShading(in VertexAssembleOcclusion IN)
{
	VertexOcclusionOutput OUT;

	//	[@_HLSL]
	//	OUT = (LODVertexShadingOutput)0;

	//position
	float3 WorldPosition;
	if (@_INSTANCED)
	{
		WorldPosition = Matrix4x3TransformP(IN.Transform0, IN.Transform1, IN.Transform2, IN.Position.xyz).xyz;
	}
	else
	{
		WorldPosition = MulMat3x4(World, float4(IN.Position.xyz, 1)).xyz;
	}

	//diy output
	OUT.HPosition = MulMat4x4(ViewProj, float4(WorldPosition, 1.0));
	return OUT;
}

float4 OcclusionPixelShading(in VertexOcclusionOutput IN) : SV_Target
{
	return float4(1, 1, 1, 1);
}

technique Shading
{
	VertexShader = OcclusionVertexShading();
	PixelShader = OcclusionPixelShading();
}
