//	--------------------------------------------------------------------
//	Copyright(C) 2006~2020 NetEase Games. All rights reserved.
//	This file is a part of the project Messiah.
//	Messiah Engine, Technology Department of NetEase Games.
//	Contact : gzchenjiating@corp.netease.com
//	Author: Getting
//	$(reservedDeclaration)
//	--------------------------------------------------------------------
///	@file	<UILineImage.fx>
///	@path	~/Shader/UI/
///	@date	2015/09/13
///	@brief	Line UI.

#pragma shader draw
#pragma shader category("UI")

#include "Constants.fxh"
#include "Common.fxh"

cbuffer Batch
{
	float4x4 WorldViewProj		 		;
};

struct VertexAssemble
{
	float4		Position 				: POSITION;
	float4		Color 					: COLOR;
	float2		TexCoord				: TEXCOORD0;
};

struct VertexOutput
{
	float4		HPosition				: SV_Position;
	float4		Color					: COLOR;
};

////////////////////////////////////////////////////////////////////////
// Line UI draw.

VertexOutput LineUIDrawVS(in VertexAssemble IN)
{
	VertexOutput OUT;

	[@_HLSL]
		OUT = (VertexOutput)0;

	OUT.HPosition = MulMat4x4(WorldViewProj, IN.Position);
	OUT.Color = GetVertexColor(IN.Color);

	return OUT;
}

float4 LineUIDrawPS(in VertexOutput IN) : SV_Target
{
	return IN.Color;
}

technique UILineImageDraw
{
	VertexShader = LineUIDrawVS();
	PixelShader = LineUIDrawPS();
}
