#ifndef __FILE_CLIP_FXH__
#define __FILE_CLIP_FXH__

#ifndef USE_HISM
#define USE_HISM 0
#endif

void SimpleAlphaSample( in VertexShadingOutput IN, out half Alpha)
{
	half4 samplerBase = tBaseMap.SampleBias(sBaseSampler, BaseMapUV(IN.TexCoord), 0);
	Alpha = cAlpha * samplerBase.a;
}
// !notice need PbrVertexShading
/////////////////////////////////Clip/////////////////////////////////////////
[barycentric("sample")][RE_Z]
float4 ClipPixelShading(in VertexShadingOutput IN) : SV_Target
{
	half Alpha = 1;
	if(@_CLIPPING)
	{
		SimpleAlphaSample(IN,Alpha);
	}
	// Clipping
	float clipValue = 1.0;
	if (@_CLIPPING)
	{
		clipValue = (Alpha - ALPHA_REF);
	}
	if (@_DISSOLVING)
	{
#if USE_UNIDIRECTIONAL_DISSOLVE
		if(@_UnidirectionalDissolveEnable)
		{
			float ratio = min((GameTime - cParamter2.y) /  (abs(cParamter2.z) + EPSILON), 1);
			ratio = abs(cParamter2.w - ratio);
			float clipRatio = cParamter2.z > 0 ? (1 - ratio - IN.ModelPositionY/2 ) : (IN.ModelPositionY/2 - ratio );
			clipValue = min(clipValue, clipRatio);
		}
#endif
		float ratio = 0;
#if USE_HISM
		if(@_INSTANCED && !@_IsHISM)
		{
			ratio = IN.LightMapScale.w;
		}
		else
#else
		if(@_INSTANCED)
		{
			ratio = IN.LightMapScale.w;
		}
		else
#endif
		{
			ratio = cParamter2.x;
		}
		clipValue = min(clipValue, ratio - GetRandom(IN.HPosition.xy) * sign(ratio));
	}
	if (@_CLIPPING || @_DISSOLVING)
		clip(clipValue);
	return float4(0, 0, 0, 0);
}

technique Clip
{
	VertexShader = PbrVertexShading();
	PixelShader = ClipPixelShading();
}
#endif // __FILE_CLIP_FXH__
