#ifndef __FILE_EDGELINENORMAL_FXH__
#define __FILE_EDGELINENORMAL_FXH__
float4 EdgeLineNormalGenPixelShading(in VertexShadingOutput IN) : SV_Target
{
	float4 OUT = float4(0, 0, 0, 0);

	//material parameters
	MaterialShadingParameters MaterialParameters;
	PS_GetParameters(IN, MaterialParameters);
	OUT.a = MaterialParameters.Alpha;
	OUT.rgb = MaterialParameters.WorldNormal.rgb * 0.5 + 0.5;

	float clipValue = 1.0;
	if (@_CLIPPING)
	{
		clipValue = OUT.a - ALPHA_REF;
	}
	if (@_TRANSPARENT)
	{
		clipValue = OUT.a - 0.3;
	}
	if (@_CLIPPING || @_TRANSPARENT)
		clip(clipValue);

	return OUT;
}

technique EdgeLineNormalGen
{
	VertexShader = PbrVertexShading();
	PixelShader = EdgeLineNormalGenPixelShading();
}
#endif // __FILE_EDGELINENORMAL_FXH__
