#ifndef _ScreenSpaceReflection_
#define _ScreenSpaceReflection_ 1

#include "ScreenSpaceRayCast.fxh"

// return (HitUV.xy, Rate)
float3 ScreenSpaceReflection(in float3 WorldPosition, in half2 PixelPos, in float3 R, in half NoV)
{
	half SSRRate = 0;
	float2 ScreenUV = PixelPos * ScreenInfo.zw * 2 - 1; // screen space uv [-1, 1]
	ScreenUV *= ScreenUV; // screen space uv**2 [0, 1]
	
	SSRRate = saturate(1 - dot(ScreenUV, ScreenUV)); // less reflection when near the edge of screen
	// NoV = saturate(NoV * 3);
	// SSRRate *= 1 - sqrt(NoV); // less reflection when nearly perpendicular
	
	[branch]
//	if (SSRRate > 0.005)
	{	
		float3 SSR = ScreenSpaceRayCast(WorldPosition, PixelPos, R);
		SSR.z *= SSRRate;
		return SSR;
	}
	return float3(0, 0, 0);
}

#endif
