#ifndef __FILE_XRAY_FXH__
#define __FILE_XRAY_FXH__
// !notice need PbrVertexShading
//////////////////////////////////////////////////////////////////////////
// XRay
float4 XRayPixelShading(in VertexShadingOutput IN) : SV_Target
{
	float4 OUT = float4(0, 0, 0, 0);

	//material parameters
	MaterialShadingParameters MaterialParameters;
	PS_GetParameters(IN, MaterialParameters);

	//runtime per-pixel parameters
	float3 V = normalize( -IN.ViewDirection.xyz );
	half NoV = saturate( dot(MaterialParameters.WorldNormal, V) );

	//light
	OUT.rgb += half3(0, 0.25, 1.0) * 0.5;

	//Fresnel
	half k = (1-NoV);
	k = k*k;
	k = k*k * 5;
	OUT.rgb += 0.2 * k;

	OUT.a = saturate(0.2 * (OUT.r+OUT.g+OUT.b));
	OUT.rgb *= OUT.a;
	OUT.a = EncodeTransparentBloomFactor(OUT.a, 0.5*k);

	// encode hdr
	EncodeHDR(OUT.rgb);

	return OUT;
}

technique XRay
{
	VertexShader = PbrVertexShading();
	PixelShader = XRayPixelShading();
}
#endif // __FILE_XRAY_FXH__
