#pragma shader material

///////////////choice define start///////////////////////////
#define MATERIAL_SHADINGMODEL_DEFAULT_LIT 	1 // for deferred
#define USE_LIGHTMAP						1
#define USE_LIGHTMAP_CONST					0
#define USE_CLIPPING						1
#define USE_WIREFRAME						1
#define USE_FROZEN							0
#define USE_BURNT							0
#define USE_HIGHLIGHT						0
#define USE_XRAY							0
#define USE_EDGELINE						0
#define USE_PLANAR_SHADOW					0
#define USE_VBufferGen						1
#define VIRTUAL_LIT 						1
#define USE_GRAY                            0
#define USE_ONE_SIDE_LIGHTING				0
#define USE_UNIDIRECTIONAL_DISSOLVE			0
// #pragma shader predict("@_TANGENT", "true")
// #pragma shader predict("@_CLIPPING", "false")
// #pragma shader predict("@_TRANSPARENT", "false")
#pragma shader predict("@_VERTEXCOLOR", "false")
// #pragma shader predict("@_INSTANCED", "false")
// #pragma shader predict("@_DF_SKIN", "0")

#define HAS_2UV								(@_LIGHT_MAP)
#define ENABLE_MIXMAP						(@_EnableReflection)
#define ENABLE_ANISOTROPIC 					(@_AnisotropicEnable)
#define ENABLE_RIPPLE 						(@_RIPPLE && !@_SKELETON)
#define ENABLE_SCREEN_SHADOWMAP				(@_ReceiveShadow && @_CSM && @_CastSunShadow && @_LOD_LEVEL <= LOD_Level_2 && !@_TRANSPARENT)
#define ENABLE_HIGHLIGHT					(@_HighlightEnable) // deferred
#define ENABLE_BURNT						(@_BurntEnable) // deferred
#define USE_SHADOWMAP_SAMPLE				((@_LOD_LEVEL <= LOD_Level_2 && @_CastSunShadow) && (@_TRANSPARENT || (!@_CSM && @_REC_SHADOW)))
#define DEFERRED_PRE_AO						1 // 是否走ao
#define USE_PLAYER_SHADOWMAP				1 // 全是在开csm下有效的
///////////////choice define end//////////////////////////

#include "PBR_Definitions.fxh"
#include "Constants.fxh"
#include "Common.fxh"
//////////////////////////////////Properties////////////////////////////////////////
@_BaseMapEnable 
{ 
	Name = BaseMapEnable;
	Description = "Do we have BaseMap?";  
	AffectedTex = tBaseMap;
	Fallback = true;
	Visible = false;
};
@_EnableReflection 
{
	Name = EnableReflection;
	Description = "EnableReflection?";
	AffectedTex = tMixMap;
	Fallback = true;
	Visible = false;
	Default = false;
};
@_OneSideLightingEnable
{
	Name = OneSideLightingEnable;
	Description = "Do we need calc One side lighting?";
	Default = false;
	Visible = true;	
};
@_EnableDepthBias
{
	Name = EnableDepthBias;
	Description = "Enable Image based lighting?";
	Default = false;
	Visible = false;	
};
@_EnableIBL
{
	Name = EnableIBL;
	Description = "Enable Image based lighting?";
	Default = true;
	Visible = true;	
};
@_NormalMapEnable
{
	Name = NormalMapEnable;
	Description = "Do we have NormalMap?"; 
	AffectedTex = tNormalMap;
	Fallback = "@_TANGENT";
	Visible = false;
};
@_LightMapEnable
{
	Name = LightMapEnable;
	Description = "Do we have LightMap?";
	AffectedTex = tLightMap;
	Fallback = "@_LIGHT_MAP";
	Visible = false;
};
@_EmissionMapEnable
{
	Name = EmissionMapEnable;
	Description = "Do we have EmissionMap?";
	AffectedTex = tEmissionMap; 
	Fallback = true;
	Visible = false;
};
@_AnisotropicEnable
{
	Name = AnisotropicEnable;
	Description = "Do we need calc anisotropic lighting?";
	Visible = true;
	Predict = false;
};
@_LightmapConstEnable
{
	Name = LightmapConstEnable;
	Default = false;
	Visible = false;
	Predict = false;
};
@_IsFootprint
{
	Name = IsFootprint;
	Description = "Footprint material has fade out effect";
	Default = false;
	Visible = true;
	
};
@_HighlightEnable
{
	Name = HighlightEnable;
	Description = "for deferred pipeline change highlight pass";
	Default = false;
	Predict = false;
	
};
@_FrozenEnable
{
	Name = FrozenEnable;
	Description = "for deferred pipeline change frozen pass";
	Default = false;
	Predict = false;
};
@_BurntEnable
{
	Name = BurntEnable;
	Description = "for deferred pipeline change burnt pass";
	Default = false;
	Predict = false;
};
@_UnidirectionalDissolveEnable
{
	Name = UnidirectionalDissolveEnable;
	Description = "material has unidirectional dissolve effect";
	Visible = true;
	Default = false;
	// Predict = false;
};
@_WeaponHighLight
{
	Name = WeaponHighLight;
	Description = "for WeaponHighlight";
	Default = false;
};
@_WeaponPreview
{
	Name = WeaponPreview;
	Description = "for WeaponPreview";
	Default = false;
};
@_GrayEffect
{
	Name = GrayEffect;
	Description = "for Graying";
	Visible = true;
	Default = false;
	Predict = false;
};
@_ReceiveShadow
{
	Name = ReceiveShadow;
	Description = "for WeaponPreview";
	Default = true;
	Visible = false;
};
@_ReceiveCubeReflect
{
	Name = ReceiveCubeReflect;
	Description = "for Glass";
	Default = false;
	Predict = false;
	Visible = true;
};
@_RadarEnable
{
	Name = RadarEnable;
	Description = "RadarEnable";
	Default = false;
	Visible = false;
};
//////////////////////////////////Constant buffer////////////////////////////////////////
cbuffer Shader
{
	float3 cBaseColor 				 < Widget = "LinearColor3"; > = {1, 1, 1};
	float cMetallic					 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; > = 0;	//金属度[0:1] 

	float cAliasingFactor			 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; > = 0.2;//抗锯齿因子
	float cEnvStrength				 < Widget = "FloatSlider"; Min = "0"; Max = "20"; Step = "0.01"; Precision = "2"; > = 1;	//环境强度[0:8]
	float cRoughnessLow				 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; > = 0;	//粗糙度下界
	float cRoughnessHigh			 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; > = 1;	//粗糙度上界
	
	float4 cLightMapScale			 = {1, 1, 1, 1};
	float4 cLightMapUVTransform		 = {1, 1, 0, 0};

	float  cSmoothness				 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; > = 0;
	float  cBloomScale				 < Widget = "FloatSlider"; Min = "1"; Max = "100"; Step = "0.01"; Precision = "2"; > = 80.0;
	float  cBaseMapBias				 < Widget = "FloatSlider"; Min = "-2"; Max = "2"; Step = "0.01"; Precision = "2"; > = -1;
	float  cNormalMapBias			 < Widget = "FloatSlider"; Min = "-2"; Max = "2"; Step = "0.01"; Precision = "2"; > = -0.5;

	float4 cEmissionScale			 = {1, 1, 1, 0};
	float4 cEmissionScrolling		 = {1, 1, 0, 0};

	float cRoughnessX				 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.001"; Precision = "2"; > = 0.1;
	float cRoughnessY				 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.001"; Precision = "2"; > = 1;
	float cAnisotropicScale			 < Widget = "FloatSlider"; Min = "0"; Max = "10"; Step = "0.01"; Precision = "2"; > = 0;
	float cFogDistance				 < Widget = "FloatSlider"; Min = "0"; Max = "1000"; Step = "0.1"; Precision = "2"; > = 100;

	float cBumpIns      			 < Widget = "FloatSlider"; Min = "0"; Max = "10"; Step = "0.1"; Precision = "2"; > = 1;
	float cAlpha	      			 < Widget = "FloatSlider"; Min = "0"; Max = "10"; Step = "0.1"; Precision = "2"; > = 1.0;
	float cDepthOffset     			 < Widget = "FloatSlider"; Min = "-20"; Max = "20"; Step = "0.1"; Precision = "2"; > = 0;
	float cDepthBias	  			 < Widget = "FloatSlider"; Min = "-1"; Max = "1"; Step = "0.1"; Precision = "2"; > = 0;
	float cSnowHeight	  			 < Widget = "FloatSlider"; Min = "-2"; Max = "2"; Step = "0.1"; Precision = "2"; > = 0.6;
	float cSnowDetail	  			 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.1"; Precision = "2"; > = 1;
	float cBiasFarAwayShadow		 < Widget = "FloatSlider"; Min = "0"; Max = "10"; Step = "0.1"; Precision = "3"; > = 0.01;
	float cSaturation				 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.1"; Precision = "2"; > = 1;
	float cWeaponAnimation			= {0};
	float3 cWeaponHighLightColor	< Widget = "LinearColor3"; > = {1, 1, 1};
	float cFov						< Widget = "FloatSlider"; Min = "0"; Max = "5"; Step = "0.1"; Precision = "2"; > = 1;
	float cGrayingin				< Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.1"; Precision = "2"; > = 0;
	float cReflection				< Widget = "FloatSlider"; Min = "0"; Max = "20"; Step = "0.1"; Precision = "2"; > = 0;
	float2 cReflectionOffset		= {0,0};
	
	float3 cRadarColor				< Widget = "LinearColor3"; > = {1, 1, 1};
	float	cRadarScrolling			={0};
	float 	cPlayerDirection			 = {1};
};

//////////////////////////////////Input Texture////////////////////////////////////////
texture2D tBaseMap : layout(t0) = "White";
sampler sBaseSampler : layout(s0)
{
	Texture = tBaseMap;
	Filter = Linear;
	Address = FromTexture;
	SRGB = false;
};

texture2D tMixMap : layout(t1) = "Reflection";
sampler sMixSampler : layout(s1)
{
	Texture = tMixMap;
	Filter = Linear;
	Address = Wrap;
	SRGB = false;
};

texture2D tEnvMap : EnvMap : layout(t2) = "White";
sampler sEnvSampler : layout(s2)
{
	Texture = tEnvMap;
	Filter = Linear;
	Address = Clamp;
	SRGB = false; 
};

texture2D tNormalMap : layout(t3) = "NormalMap";
sampler sNormalSampler : layout(s3)
{
	Texture = tNormalMap;
	Filter = Linear;
	Address = Wrap;
	SRGB = false;
};

// Light map
texture2D tLightMap : layout(t4);
sampler sLightMapSampler : layout(s4)
{
	Texture = tLightMap;
	Filter = Linear;
	Address = Clamp;
	SRGB = false;
	MaxMipLevel = 0;
};

texture2D tShadowMask : ShadowMask : layout(t5) = "White";
sampler sShadowMaskSampler : layout(s5)
{
	Texture = tShadowMask; 
	Filter = Point; 
	Address = Clamp;
	SRGB = false;
	MaxMipLevel = 0;
};
// ShadowMap 
texture2D tShadowMap : ShadowMap : layout(t6) = "White";
SamplerComparisonState sShadowMapSampler : layout(s6)
{
	Texture = tShadowMap;
	Filter = Linear;
	Address = Clamp;
	ComparisonFunc = Greater;
	SRGB = false;
	MaxMipLevel = 0;
};

// Emission map
texture2D tEmissionMap : layout(t7) = "Transparent";
sampler sEmissionMapSampler : layout(s7)
{
	Texture = tEmissionMap;
	Filter = Linear; 
	Address = Wrap;
	SRGB = false;
};

texture2D tRainMap : RainMap: layout(t8) = "NormalMap";
sampler sRainSampler : layout(s8)
{
	Texture = tRainMap;
	Filter = Linear;
	Address = Wrap;
	SRGB = false;
};

texture2D tShelterMap: ShelterMap : layout(t9) = "Black";
sampler ShelterMap_Sampler : layout(s9)
{
	Texture = tShelterMap;
	Filter = Linear;
	Address = Clamp;
	SRGB = false;
};

texture2D tSkeletonMap : SkeletonMap : layout(t3) = "Black";
sampler sSkeletonSampler : layout(s3)
{
	Texture = tSkeletonMap;
	Filter = Point;
	Address = Clamp;
	SRGB = false;
};


texture2D tReflectMap : layout(t10) = "White";
sampler sReflectMapSampler : layout(s10)
{
	Texture = tReflectMap;
	Filter = Linear;
	Address = Clamp;
	SRGB = false; 
};




#include "PBR_VS.fxh"
//////////////////////////////////VS////////////////////////////////////////
void VS_DIY_OUTPUT(in VertexAssemble IN, in InterMediateVertex INTM, inout VertexShadingOutput OUT)
{
	// 1. init tint color
	InitTintColorCommon(IN, OUT); 

	// 2. for snow height calc
	OUT.WorldPosition.w = IN.Position.y;

	// 3. init emmision uv; if not need emmision uv
	InitEmissionUVCommon(IN, OUT);

	// 4. hposition calc
	InitHPositionCommon(INTM, OUT); // init hposition calc
//	if(@_EnableDepthBias)
//	{
	

	InitDepthCommon(INTM,OUT);


	if(@_CastSunShadow && @_TRANSPARENT)
	{
		// for player's shadow		
		OUT.LitUVZ2 = MulMat4x4(ShadowViewProjTexs0, float4(OUT.WorldPosition.xyz + 
		OUT.WorldNormal.xyz * cBiasFarAwayShadow,1));
	}

}
#include "PBR_Common.fxh"
//////////////////////////////////PS////////////////////////////////////////
void PS_GetParameters(in VertexShadingOutput IN, out MaterialShadingParameters MaterialParameters)
{
	// 1. init MaterialParameters (always need)
	InitShadingParameters(MaterialParameters);
	// InitRainOcclusion(IN, MaterialParameters);

	// 2. init MaterialParameters.BaseColor and MaterialParameters.Alpha by sample basemap
	InitBaseColorCommon(IN, MaterialParameters);
	// footprint fade out effect
	if (@_IsFootprint && @_INSTANCED)
	{
		MaterialParameters.Alpha *= saturate((IN.LightMapScale.x - GameTime) / IN.LightMapScale.y);
	}
	
	// 3. init smoothness/metal/ao by sample mixmap
	InitSmoothnessMetalAO(IN, MaterialParameters);

	// 4. init MaterialParameters.WorldNormal by sample normalmap
	InitWorldNormal(IN, MaterialParameters);
	
	// 5. init MaterialParameters.Emission by sample emissinMap (if need or not)
	InitEmission(IN, MaterialParameters);
	
	InitWeaponHighlight(IN,MaterialParameters);


	// 6. init anisotropic by use cRoughnessX/cRoughnessY/cAnisotropicScale (if need or not)
	// InitAnisotropic(IN, MaterialParameters);

	// 7. Apply Burnt
	// if(!@_SKELETON)
	// {
	// 	InitBurnt(IN, MaterialParameters);
	// }
	// 8. Apply Weather
	InitRain(IN, MaterialParameters);

	//GrayingEffect
	// InitGrayEffect(cGrayingin,MaterialParameters);

	//GlassReflectEffect
	// InitReflectEffect(IN,MaterialParameters);
	InitRadarEffect(IN,MaterialParameters);
}
#include "PBR_PS.fxh"

#if SD_ENABLE_VXGI
#include "VXGI/VXGIVoxelize.fxh"
#endif

