#pragma shader material

///////////////choice define start///////////////////////////
#define MATERIAL_SHADINGMODEL_DEFAULT_LIT 	1 // for deferred
#define USE_LIGHTMAP						1
#define USE_LIGHTMAP_CONST					0
#define USE_CLIPPING						0
#define USE_WIREFRAME						0
#define USE_FROZEN							0
#define USE_BURNT							0
#define USE_HIGHLIGHT						0
#define USE_XRAY							0
#define USE_EDGELINE						0
#define USE_PLANAR_SHADOW					0
#define USE_VBufferGen						0
#define VIRTUAL_LIT 						0
#define NO_SHADOW_CLIPPING 					1
#define USE_UNIDIRECTIONAL_DISSOLVE			1
#pragma shader predict("@_TANGENT", "true")
#pragma shader predict("@_CLIPPING", "false")
#pragma shader predict("@_TRANSPARENT", "false")
#pragma shader predict("@_VERTEXCOLOR", "true")
#pragma shader predict("@_INSTANCED", "false")
#pragma shader predict("@_DF_SKIN", "0")
#define HAS_2UV								@_LIGHT_MAP
#define ENABLE_MIXMAP						1
#define ENABLE_ANISOTROPIC 					0
#define ENABLE_RIPPLE 						(@_RIPPLE)
#define ENABLE_SCREEN_SHADOWMAP				(@_CSM && @_CastSunShadow && @_LOD_LEVEL <= LOD_Level_2 && !@_TRANSPARENT)
#define DEFERRED_PRE_AO						1
///////////////choice define end//////////////////////////

#include "PBR_Definitions.fxh"
#include "Constants.fxh"
#include "Common.fxh"
//////////////////////////////////Properties////////////////////////////////////////
@_BaseMapEnable 
{ 
	Name = BaseMapEnable;
	Description = "Do we have BaseMap?";  
	AffectedTex = tBaseMap;
	Fallback = true;
	Visible = false;
};
@_EnableReflection 
{
	Name = EnableReflection;
	Description = "EnableReflection?";
	AffectedTex = tMixMap;
	Fallback = true;
	Visible = false;
	Default = true;
	

};
@_EnableIBL
{
	Name = EnableIBL;
	Description = "Enable Image based lighting?";
	Default = true;
	Visible = true;	
};
@_NormalMapEnable
{
	Name = NormalMapEnable;
	Description = "Do we have NormalMap?"; 
	AffectedTex = tNormalMap;
	Fallback = "@_TANGENT";
	Visible = false;
};
@_LightMapEnable
{
	Name = LightMapEnable;
	Description = "Do we have LightMap?";
	AffectedTex = tLightMap;
	Fallback = "@_LIGHT_MAP";
	Visible = false;
};
@_EmissionMapEnable
{
	Name = EmissionMapEnable;
	Description = "Do we have EmissionMap?";
	AffectedTex = tEmissionMap;
	Fallback = true;
	Visible = false;
};
@_LightmapConstEnable
{
	Name = LightmapConstEnable;
	Default = false;
	Visible = false;
	Predict = false;
};
// @_TexBlendEnable
// {
// 	Name = VertexColorBlendEnable;
// 	Description = "Enable TexBlend?";
// 	AffectedTex = tMixMap;
// 	Default = false;
// 	Fallback = false;
// 	Visible = false;
// };
@_BlendAlphaEnable
{
	Name = BlendAlphaEnable;
	Description = "Enable BlendAlpha?";
	Default = true;
	Visible = true;
	Predict = true;
};
@_BlendVTEnable
{
	Name = BlendVTEnable;
	Description = "Enable BlendVT?";
	Default = false;
	Visible = true;
	Predict = false;
};
@_UnidirectionalDissolveEnable
{
	Name = UnidirectionalDissolveEnable;
	Description = "material has unidirectional dissolve effect";
	Visible = true;
	Default = false;
	
};
//////////////////////////////////Constant buffer////////////////////////////////////////
cbuffer Shader
{
	float3 cBaseColor 				 < Widget = "LinearColor3"; > = {1, 1, 1};
	float cMetallic					 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; > = 0;	//金属度[0:1] 

	float cAliasingFactor			 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; > = 0.2;//抗锯齿因子
	float cEnvStrength				 < Widget = "FloatSlider"; Min = "0"; Max = "10"; Step = "0.01"; Precision = "2"; > = 1;	//环境强度[0:8]
	float cRoughnessLow				 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; > = 0;	//粗糙度下界
	float cRoughnessHigh			 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; > = 1;	//粗糙度上界
	
	float4 cLightMapScale			 = {1, 1, 1, 1};
	float4 cLightMapUVTransform		 = {1, 1, 0, 0};

	float cSmoothness				 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; > = 0;
	float cBloomScale				 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; > = 0.5;
	float cBaseMapBias				 < Widget = "FloatSlider"; Min = "-2"; Max = "2"; Step = "0.01"; Precision = "2"; > = -2;
	float cNormalMapBias			 < Widget = "FloatSlider"; Min = "-2"; Max = "2"; Step = "0.01"; Precision = "2"; > = -1;

	float4 cEmissionScale			 = {1, 1, 1, 0};
	float4 cEmissionScrolling		 = {1, 1, 1, 1};
	
	float cBumpIns      			 < Widget = "FloatSlider"; Min = "0"; Max = "10"; Step = "0.1"; Precision = "2"; > = 1;
	float cAlpha	      			 < Widget = "FloatSlider"; Min = "0"; Max = "10"; Step = "0.1"; Precision = "2"; > = 1.0;
	float cDepthOffset     			 < Widget = "FloatSlider"; Min = "-20"; Max = "20"; Step = "0.1"; Precision = "2"; > = 0;
	float cDepthBias	  			 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.1"; Precision = "2"; > = 0;
	float cSnowHeight	  			 < Widget = "FloatSlider"; Min = "-2"; Max = "2"; Step = "0.1"; Precision = "2"; > = 0.6;
	float cSnowDetail	  			 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.1"; Precision = "2"; > = 1;

	float cDetailNormalIntensity	 < Widget = "FloatSlider"; Min = "0"; Max = "2"; Step = "0.01"; Precision = "2"; > = 1;
	float cSharpness				 < Widget = "FloatSlider"; Min = "0"; Max = "0.5"; Step = "0.01"; Precision = "2"; > = 0.2;

	float cDetail01UV				 < Widget = "FloatSlider"; Min = "1"; Max = "30"; Step = "0.1"; Precision = "2"; > = 1;
	float cDetail02UV				 < Widget = "FloatSlider"; Min = "1"; Max = "30"; Step = "0.1"; Precision = "2"; > = 1;
	float cDetail03UV				 < Widget = "FloatSlider"; Min = "1"; Max = "30"; Step = "0.1"; Precision = "2"; > = 1;
	float cWaterAmount				 < Widget = "FloatSlider"; Min = "0"; Max = "2"; Step = "0.1"; Precision = "2"; > = 1;
};

//////////////////////////////////Input Texture////////////////////////////////////////
texture2DArray tBaseMap : layout(t0) = "White";
sampler2DArray sBaseSampler : layout(s0)
{
	Texture = tBaseMap;
	Filter = Linear;
	Address = Wrap;
	SRGB = false;
};

texture2DArray tMixMap : layout(t1) = "Reflection";
sampler2DArray sMixSampler : layout(s1)
{
	Texture = tMixMap;
	Filter = Linear;
	Address = Wrap;
	SRGB = false;
};

texture2DArray tNormalMap : layout(t2) = "NormalMap";
sampler2DArray sNormalSampler : layout(s2)
{
	Texture = tNormalMap;
	Filter = Linear;
	Address = Wrap;
	SRGB = false;
};

texture2D tOverlayNormal : layout(t3) = "NormalMap";
sampler sOverlayNormalSampler : layout(s3)
{
	Texture = tOverlayNormal;
	Filter = Linear;
	Address = Wrap;
	SRGB = false;
};

texture2D tEnvMap : EnvMap : layout(t4) = "White";
sampler sEnvSampler : layout(s4)
{
	Texture = tEnvMap;
	Filter = Linear;
	Address = Clamp;
	SRGB = false;
};

// Light map
texture2D tLightMap : layout(t5);
sampler sLightMapSampler : layout(s5)
{
	Texture = tLightMap;
	Filter = Linear;
	Address = Clamp;
	SRGB = false;
	MaxMipLevel = 0;
};

texture2D tShadowMask : ShadowMask : layout(t6) = "White";
sampler sShadowMaskSampler : layout(s6)
{
	Texture = tShadowMask; 
	Filter = Point; 
	Address = Clamp;
	SRGB = false;
	MaxMipLevel = 0;
};

// ShadowMap 
texture2D tShadowMap : ShadowMap : layout(t6) = "White";
SamplerComparisonState sShadowMapSampler : layout(s6)
{
	Texture = tShadowMap;
	Filter = Linear;
	Address = Clamp;
	ComparisonFunc = Greater;
	SRGB = false;
	MaxMipLevel = 0;
};

texture2D tRainMap : RainMap: layout(t7) = "NormalMap";
sampler sRainSampler : layout(s7)
{
	Texture = tRainMap;
	Filter = Linear;
	Address = Wrap;
	SRGB = false;
};

texture2D tShelterMap: ShelterMap : layout(t8) = "Black";
sampler ShelterMap_Sampler : layout(s8)
{
	Texture = tShelterMap;
	Filter = Linear;
	Address = Clamp;
	SRGB = false;
};

texture2D tVTIndMap : VTIndMap : layout(t9) = "Black";
sampler sVTIndSampler : layout(s9)
{
	Texture = tVTIndMap;
	Filter = Point;
	Address = Clamp;
};

texture2D tVTBaseNormalXMap : VTBaseNormalXMap: layout(t10) = "Black";
sampler sVTBaseNormalXSampler : layout(s10)
{
	Texture = tVTBaseNormalXMap;
	Filter = Linear;
	Address = Clamp;
};
texture2D tLocalHeightmap: LocalHeightmap : layout(t11) = "Black";
sampler sLocalHeightmapSampler : layout(s11)
{
	Texture = tLocalHeightmap;
	Filter = Linear;
	Address = Clamp;
};

// texture2D tMaskMap : layout(t12) = "Black";
// sampler sMaskSampler : layout(s12)
// {
// 	Texture = tMaskMap;
// 	Filter = Linear;
// 	Address = Wrap;
// 	SRGB = false;
// };

//#if SD_TSAA_VBUFFER
texture2D tSkeletonMap : SkeletonMap : layout(t3) = "Black";
sampler sSkeletonSampler : layout(s3)
{
	Texture = tSkeletonMap;
	Filter = Point;
	Address = Clamp;
	SRGB = false;
};
//#endif

#include "VT_Common.fxh"
#include "PBR_VS.fxh"
//////////////////////////////////VS////////////////////////////////////////
void VS_DIY_OUTPUT(in VertexAssemble IN, in InterMediateVertex INTM, inout VertexShadingOutput OUT)
{
	// 1. init tint color
	if (@_VERTEXCOLOR)
		OUT.TintColor.rgb = GetVertexColor(IN.Color);
	else
		OUT.TintColor = float4(1, 1, 1, 1);

	// 2. for snow height calc
	OUT.WorldPosition.w = IN.Position.y;

	// 3. init emmision uv; if not need emmision uv
	InitEmissionUVCommon(IN, OUT);

	// 4. hposition calc
	InitHPositionCommon(INTM, OUT); // init hposition calc
}
#include "PBR_Common.fxh"
//////////////////////////////////PS////////////////////////////////////////
void PS_GetParameters(in VertexShadingOutput IN, out MaterialShadingParameters MaterialParameters)
{
	InitShadingParameters(MaterialParameters);	
	InitRainOcclusion(IN, MaterialParameters);
	MaterialParameters.Alpha = cAlpha;
	half Smoothness = cSmoothness;
	half maskWater = 0;
	half mask01 = 0;
	half mask02 = 0;
	if (@_VERTEXCOLOR)
	{
		maskWater = IN.TintColor.r * cWaterAmount;
		mask01 = IN.TintColor.g;
		mask02 = IN.TintColor.b;
	}
	// else
	// {
	// 	half3 samplerMask = tMaskMap.Sample(sMaskSampler, LightMapUV(IN.TexCoord)).rgb;
	// 	mask01 = samplerMask.g;
	// 	mask02 = samplerMask.b;
	// 	maskWater = samplerMask.r;
	// }
	half3 blendNormal = half3(0.5,0.5,1);
	half blendHeight01 = 1;
	half blendHeight02 = 1;
	half blendHeight03 = 1;
	if(@_TANGENT && @_NormalMapEnable)
	{
		half4 normal01 = tNormalMap.SampleBias(sNormalSampler, float3(BaseMapUV(IN.TexCoord) * cDetail01UV, 0), cNormalMapBias);
		half4 normal02 = tNormalMap.SampleBias(sNormalSampler, float3(BaseMapUV(IN.TexCoord) * cDetail02UV, 1), cNormalMapBias);
		half4 normal03 = tNormalMap.SampleBias(sNormalSampler, float3(BaseMapUV(IN.TexCoord) * cDetail03UV, 2), cNormalMapBias);
		half3 waterNormal = half3(0.5, 0.5, 1);
		half sharpness = 0.2;
		half waterSharpness = 0.5;

		heightLerp(normal01.a, normal02.a, sharpness, mask01, blendHeight01);
		heightLerp(blendHeight01, normal03.a, sharpness, mask02, blendHeight02);
		heightLerp(blendHeight02, 0, waterSharpness, maskWater, blendHeight03);
		blendNormal = lerp(normal01.rgb, normal02.rgb, mask01);
		blendNormal = lerp(blendNormal, normal03.rgb, mask02);
		blendNormal = lerp(blendNormal, waterNormal, maskWater * maskWater * maskWater * maskWater);
		blendNormal = blendNormal * 2 - 1;
	}
	else
		MaterialParameters.WorldNormal = IN.WorldNormal.xyz;
	
	half4 base01 = tBaseMap.SampleBias(sBaseSampler, float3(BaseMapUV(IN.TexCoord) * cDetail01UV, 0), cBaseMapBias);
	base01.rgb = DecodeGamma(base01.rgb);
	half4 base02 = tBaseMap.SampleBias(sBaseSampler, float3(BaseMapUV(IN.TexCoord) * cDetail02UV, 1), cBaseMapBias);
	base02.rgb = DecodeGamma(base02.rgb);
	half4 base03 = tBaseMap.SampleBias(sBaseSampler, float3(BaseMapUV(IN.TexCoord) * cDetail03UV, 2), cBaseMapBias);
	base03.rgb = DecodeGamma(base03.rgb);

	half4 blendBase = lerp(base01, base02, mask01);
	blendBase = lerp(blendBase, base03, mask02);
	blendBase.rgb = lerp(blendBase.rgb, blendBase.rgb * 0.7, sqrt(maskWater));
	MaterialParameters.BaseColor = blendBase.rgb;

	half3 mix01 = tMixMap.Sample(sMixSampler, float3(BaseMapUV(IN.TexCoord) * cDetail01UV, 0));
	half3 mix02 = tMixMap.Sample(sMixSampler, float3(BaseMapUV(IN.TexCoord) * cDetail02UV, 1));
	half3 mix03 = tMixMap.Sample(sMixSampler, float3(BaseMapUV(IN.TexCoord) * cDetail03UV, 2));
	half3 blendMix = lerp(mix01, mix02, mask01);
	blendMix = lerp(blendMix, mix03, mask02);
	Smoothness = blendMix.r;
	Smoothness = lerp(Smoothness, 0.9, maskWater * maskWater * maskWater * maskWater);
	MaterialParameters.Roughness = 1 - Smoothness;
	MaterialParameters.Metallic = blendMix.g;
	MaterialParameters.AO = blendMix.b;

	if(@_TANGENT && @_NormalMapEnable)
	{
		half3 tangentNormal = half3(0.5,0.5,1);
		if (@_NormalMapEnable)
			tangentNormal = tOverlayNormal.SampleBias(sOverlayNormalSampler, BaseMapUV(IN.TexCoord), cNormalMapBias).xyz;
		tangentNormal = (2 * tangentNormal) - 1;
		if (ENABLE_RIPPLE)
			Ripple(IN, MaterialParameters, tangentNormal, blendHeight03);
		tangentNormal.xy = tangentNormal.xy * cBumpIns + blendNormal.xy * cDetailNormalIntensity;
		MaterialParameters.WorldNormal = tangentNormal.x * IN.WorldTangent + tangentNormal.y * IN.WorldBinormal + tangentNormal.z * IN.WorldNormal.xyz;
		MaterialParameters.WorldNormal = normalize(MaterialParameters.WorldNormal);
		if (ENABLE_RIPPLE)
			RainFlowNormal(MaterialParameters, IN.WorldPosition.xz);
	}

	if(@_VTEnable && @_BlendVTEnable)
	{
		half3 vt_diff;
		SampleVTOnlyDiff(IN.WorldPosition.xyz, vt_diff);
		half blend_factor = SampleVTBlendFactor(IN.WorldPosition.xyz, 0.5);
		MaterialParameters.BaseColor = lerp(MaterialParameters.BaseColor, DecodeGamma(vt_diff), blend_factor);
	}

	if (@_CLIPPING || @_TRANSPARENT)
	{
		if(@_BlendAlphaEnable)
			MaterialParameters.Alpha = blendBase.a * cAlpha;
		else
			MaterialParameters.Alpha = base01.a * cAlpha;
	}
	// Apply Burnt
	InitBurnt(IN, MaterialParameters);

	// Apply Weather
	InitRain(IN, MaterialParameters);

}
#include "PBR_PS.fxh"

#ifndef __FILE_CLIP_FXH__
#define __FILE_CLIP_FXH__
/////////////////////////////////Clip/////////////////////////////////////////
[barycentric("sample")][RE_Z]
float4 ClipPixelShading(in VertexShadingOutput IN) : SV_Target
{
	half Alpha = 1;
	float clipValue = 1.0;
	if (@_CLIPPING)
	{
		clipValue = (Alpha - ALPHA_REF);
	}
	if (@_DISSOLVING)
	{
#if USE_UNIDIRECTIONAL_DISSOLVE
		if(@_UnidirectionalDissolveEnable)
		{
			float ratio = min((GameTime - cParamter2.y) /  (abs(cParamter2.z) + EPSILON), 1);
			float clipRatio = cParamter2.z > 0 ? (1 - ratio - IN.ModelPositionY/2 ) : (IN.ModelPositionY/2 - ratio );
			clipValue = min(clipValue, clipRatio);
		}
#endif
		clipValue = min(clipValue, cParamter2.x - GetRandom(IN.HPosition.xy) * sign(cParamter2.x));
	}
	if (@_CLIPPING || @_DISSOLVING)
		clip(clipValue);
	return float4(0, 0, 0, 0);
}

technique Clip
{
	VertexShader = PbrVertexShading();
	PixelShader = ClipPixelShading();
}
#endif // __FILE_CLIP_FXH__

#if SD_ENABLE_VXGI
#include "VXGI/VXGIVoxelize.fxh"
#endif

