#pragma shader material

///////////////choice define start///////////////////////////
#define MATERIAL_SHADINGMODEL_CLOTH 		1 // for deferred
#define USE_LIGHTMAP						0
#define USE_LIGHTMAP_CONST					0
#define USE_CLIPPING						1
#define USE_WIREFRAME						1
#define USE_FROZEN							1
#define USE_BURNT							1
#define USE_HIGHLIGHT						1
#define USE_XRAY							1
#define USE_EDGELINE						1
#define USE_PLANAR_SHADOW					0
#define USE_VBufferGen						1
#define VIRTUAL_LIT 						1
#define USE_GRAY                            1
#define USE_ONE_SIDE_LIGHTING				1
#define USE_UNIDIRECTIONAL_DISSOLVE			1
#pragma shader predict("@_TANGENT", "true")
#pragma shader predict("@_CLIPPING", "false")
#pragma shader predict("@_TRANSPARENT", "false")
#pragma shader predict("@_VERTEXCOLOR", "true")
#pragma shader predict("@_INSTANCED", "false")
#pragma shader predict("@_DF_SKIN", "0")
#define HAS_2UV								0
#define ENABLE_MIXMAP						(@_EnableReflection)
#define ENABLE_ANISOTROPIC 					0
#define ENABLE_RIPPLE 						0
#define ENABLE_SCREEN_SHADOWMAP				(@_CSM && @_CastSunShadow && @_LOD_LEVEL <= LOD_Level_2 && !@_TRANSPARENT)
#define ENABLE_HIGHLIGHT					(@_HighlightEnable) // deferred
#define ENABLE_BURNT						(@_BurntEnable) // deferred
#define USE_SHADOWMAP_SAMPLE				((@_LOD_LEVEL <= LOD_Level_2 && @_CastSunShadow) && (@_TRANSPARENT || (!@_CSM && @_REC_SHADOW)))
#define DEFERRED_PRE_AO						0 // 是否走ao
#define USE_PLAYER_SHADOWMAP				1 // 全是在开csm下有效的

#define ENABLE_DETAIL_MASK					(@_DetailMaskEnable && @_LOD_LEVEL <= LOD_Level_2)
#define ENABLE_DETAIL_BASE					(@_DetailBaseEnable && @_LOD_LEVEL <= LOD_Level_2)
#define ENABLE_DETAIL_NORMAL				(@_DetailNormalEnable && @_LOD_LEVEL <= LOD_Level_1)
///////////////choice define end//////////////////////////

#include "PBR_Definitions.fxh"
#include "Constants.fxh"
#include "Common.fxh"
//////////////////////////////////Properties////////////////////////////////////////
@_BaseMapEnable 
{ 
	Name = BaseMapEnable;
	Description = "Do we have BaseMap?";  
	AffectedTex = tBaseMap;
	Fallback = true;
	Visible = false;
};
@_EnableReflection 
{
	Name = EnableReflection;
	Description = "EnableReflection?";
	AffectedTex = tMixMap;
	Fallback = true;
	Visible = false;
	Default = false;
};
@_EnableDepthBias
{
	Name = EnableDepthBias;
	Description = "Enable Image based lighting?";
	Default = false;
	Visible = false;
	Predict = false;	
};
@_OneSideLightingEnable
{
	Name = OneSideLightingEnable;
	Description = "Do we need calc One side lighting?";
	Default = false;
	Visible = true;	
	Predict = false;
	
};
@_EnableIBL
{
	Name = EnableIBL;
	Description = "Enable Image based lighting?";
	Default = true;
	Visible = true;	
	
};
@_NormalMapEnable
{
	Name = NormalMapEnable;
	Description = "Do we have NormalMap?"; 
	AffectedTex = tNormalMap;
	Fallback = "@_TANGENT";
	Visible = false;
};
@_DetailMaskEnable
{
	Name = DetailMaskEnable;
	Description = "Do we have DetailMaskMap?"; 
	AffectedTex = tDetailMaskMap;
	Visible = false;
	Predict = false;
};
@_DetailBaseEnable
{
	Name = DetailBaseEnable;
	Description = "Do we have DetailBaseMap?"; 
	AffectedTex = tDetailBaseMap;
	Visible = false;
	Predict = false;
};
@_DetailNormalEnable
{
	Name = DetailNormalEnable;
	Description = "Do we have DetailNormalMap?"; 
	AffectedTex = tDetailNormalMap;
	Visible = false;
	Predict = false;
};
@_LightMapEnable
{
	Name = LightMapEnable;
	Description = "Do we have LightMap?";
	AffectedTex = tLightMap;
	Fallback = "@_LIGHT_MAP";
	Visible = false;
	Predict = false;
};
@_EmissionMapEnable
{
	Name = EmissionMapEnable;
	Description = "Do we have EmissionMap?";
	AffectedTex = tEmissionMap; 
	Fallback = true;
	Visible = false;
	Predict = false;
};
@_LightmapConstEnable
{
	Name = LightmapConstEnable;
	Default = false;
	Visible = false;
	Predict = false;
};
@_HighlightEnable
{
	Name = HighlightEnable;
	Description = "for deferred pipeline change highlight pass";
	Default = false;
	Visible = false;
	Predict = false;
};
@_FrozenEnable
{
	Name = FrozenEnable;
	Description = "for deferred pipeline change frozen pass";
	Default = false;
	Visible = false;
	Predict = false;
};
@_BurntEnable
{
	Name = BurntEnable;
	Description = "for deferred pipeline change burnt pass";
	Default = false;
	Visible = false;
	Predict = false;
};
@_UnidirectionalDissolveEnable
{
	Name = UnidirectionalDissolveEnable;
	Description = "material has unidirectional dissolve effect";
	Visible = true;
	Default = false;
	Predict = false;
};
//////////////////////////////////Constant buffer////////////////////////////////////////
cbuffer Shader
{
	float3 cBaseColor 				< Widget = "LinearColor3"; > = {1, 1, 1};
	float cMetallic					< Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; > = 0;	//金属度[0:1] 

	float cAliasingFactor			< Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; > = 0.2;//抗锯齿因子
	float cEnvStrength				< Widget = "FloatSlider"; Min = "0"; Max = "10"; Step = "0.01"; Precision = "2"; > = 1;	//环境强度[0:8]
	float cRoughnessLow				< Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; > = 0;	//粗糙度下界
	float cRoughnessHigh			< Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; > = 1;	//粗糙度上界

	float  cSmoothness				< Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; > = 0;
	float  cBloomScale				< Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; > = 0.5;
	float  cBaseMapBias				< Widget = "FloatSlider"; Min = "-2"; Max = "2"; Step = "0.01"; Precision = "2"; > = -1;
	float  cNormalMapBias			< Widget = "FloatSlider"; Min = "-2"; Max = "2"; Step = "0.01"; Precision = "2"; > = -0.5;

	float4 cEmissionScale			= {1, 1, 1, 0};
	float4 cEmissionScrolling		= {1, 1, 0, 0};

	float cFogDistance				< Widget = "FloatSlider"; Min = "0"; Max = "1000"; Step = "0.1"; Precision = "2"; > = 100;
	float cBumpIns      			< Widget = "FloatSlider"; Min = "0"; Max = "10"; Step = "0.1"; Precision = "2"; > = 1;
	float cAlpha	      			< Widget = "FloatSlider"; Min = "0"; Max = "10"; Step = "0.1"; Precision = "2"; > = 1.0;
	float cSaturation				< Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.1"; Precision = "2"; > = 1;

	float cDepthOffset     			< Widget = "FloatSlider"; Min = "-20"; Max = "20"; Step = "0.1"; Precision = "2"; > = 0;
	float cDepthBias	  			< Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.1"; Precision = "2"; > = 0;
	float cBiasFarAwayShadow		< Widget = "FloatSlider"; Min = "0"; Max = "10"; Step = "0.1"; Precision = "3"; > = 0.01;
	float cPlaceHolder				= 0;

	float cFuzzSpecIns 				< Widget = "FloatSlider"; Min = "0"; Max = "10"; Step = "0.1"; Precision = "2"; > = 3;
	float cSilkSpecIns 				< Widget = "FloatSlider"; Min = "0"; Max = "10"; Step = "0.1"; Precision = "2"; > = 1;
	float cSilkSpecShift  			< Widget = "FloatSlider"; Min = "-2"; Max = "2"; Step = "0.1"; Precision = "2"; > = 0;
	float cSilkSpecRange	  		< Widget = "FloatSlider"; Min = "0.01"; Max = "10"; Step = "0.01"; Precision = "2"; > = 0.5;

	float cDetailBase01Ins 			< Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; > = 1;
	float cDetailNormal01Ins 		< Widget = "FloatSlider"; Min = "0"; Max = "2"; Step = "0.01"; Precision = "2"; > = 1;
	float cDetailMix01Ins 			< Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; > = 1;
	float cDetail01UV 				< Widget = "FloatSlider"; Min = "0"; Max = "30"; Step = "0.1"; Precision = "2"; > = 3;

	float cDetailBase02Ins 			< Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; > = 1;
	float cDetailNormal02Ins 		< Widget = "FloatSlider"; Min = "0"; Max = "2"; Step = "0.01"; Precision = "2"; > = 1;
	float cDetailMix02Ins 			< Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; > = 1;	
	float cDetail02UV 				< Widget = "FloatSlider"; Min = "0"; Max = "30"; Step = "0.1"; Precision = "2"; > = 3;

	float cDetailBase03Ins 			< Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; > = 1;
	float cDetailNormal03Ins 		< Widget = "FloatSlider"; Min = "0"; Max = "2"; Step = "0.01"; Precision = "2"; > = 1;
	float cDetailMix03Ins 			< Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; > = 1;
	float cDetail03UV 				< Widget = "FloatSlider"; Min = "0"; Max = "30"; Step = "0.1"; Precision = "2"; > = 3;
	float cFov 						< Widget = "FloatSlider"; Min = "0"; Max = "30"; Step = "0.1"; Precision = "2"; > = 1;
};

//////////////////////////////////Input Texture////////////////////////////////////////
texture2D tBaseMap : layout(t0) = "White";
sampler sBaseSampler : layout(s0)
{
	Texture = tBaseMap;
	Filter = Linear;
	Address = FromTexture;
	SRGB = false;
};

texture2D tMixMap : layout(t1) = "Reflection";
sampler sMixSampler : layout(s1)
{
	Texture = tMixMap;
	Filter = Linear;
	Address = Wrap;
	SRGB = false;
};

texture2D tEnvMap : EnvMap : layout(t2) = "White";
sampler sEnvSampler : layout(s2)
{
	Texture = tEnvMap;
	Filter = Linear;
	Address = Clamp;
	SRGB = false; 
};

texture2D tNormalMap : layout(t3) = "NormalMap";
sampler sNormalSampler : layout(s3)
{
	Texture = tNormalMap;
	Filter = Linear;
	Address = Wrap;
	SRGB = false;
};

// Light map
texture2D tLightMap : layout(t4);
sampler sLightMapSampler : layout(s4)
{
	Texture = tLightMap;
	Filter = Linear;
	Address = Clamp;
	SRGB = false;
	MaxMipLevel = 0;
};

texture2D tShadowMask : ShadowMask : layout(t5) = "White";
sampler sShadowMaskSampler : layout(s5)
{
	Texture = tShadowMask; 
	Filter = Point; 
	Address = Clamp;
	SRGB = false;
	MaxMipLevel = 0;
};
// ShadowMap 
texture2D tShadowMap : ShadowMap : layout(t6) = "White";
SamplerComparisonState sShadowMapSampler : layout(s6)
{
	Texture = tShadowMap;
	Filter = Linear;
	Address = Clamp;
	ComparisonFunc = Greater;
	SRGB = false;
	MaxMipLevel = 0;
};

// Emission map
texture2D tEmissionMap : layout(t7) = "Transparent";
sampler sEmissionMapSampler : layout(s7)
{
	Texture = tEmissionMap;
	Filter = Linear; 
	Address = Wrap;
	SRGB = false;
};

texture2D tDetailMaskMap : layout(t8) = "Black";
sampler sDetailMaskMapSampler : layout(s8)
{
	Texture = tDetailMaskMap;
	Filter = Linear; 
	Address = Wrap;
	SRGB = false;
};

texture2DArray tDetailBaseMap : layout(t9);
sampler2DArray sDetailBaseSampler : layout(s9)
{
	Texture = tDetailBaseMap;
	Filter = Linear;
	Address = Wrap;
};

texture2DArray tDetailNormalMap : layout(t10);
sampler2DArray sDetailNormalSampler : layout(s10)
{
	Texture = tDetailNormalMap;
	Filter = Linear;
	Address = Wrap;
};

// texture2D tRainMap : RainMap: layout(t8) = "NormalMap";
// sampler sRainSampler : layout(s8)
// {
// 	Texture = tRainMap;
// 	Filter = Linear;
// 	Address = Wrap;
// 	SRGB = false;
// };

texture2D tSkeletonMap : SkeletonMap : layout(t3) = "Black";
sampler sSkeletonSampler : layout(s3)
{
	Texture = tSkeletonMap;
	Filter = Point;
	Address = Clamp;
	SRGB = false;
};
//////////////////////////////////Function////////////////////////////////////////
half3 ShiftTangent(in half3 T,in half3 N,in half shift )
{  
	half3 shiftedT = T + shift * N ;
	return normalize(shiftedT);
}
half StrandSpecuar(in half HoT, in half exponent)
{
	half sinTH = 1.0 - HoT*HoT;
	half dirAtten = smoothstep(-1.0, 0.0, HoT);

	return dirAtten * pow(sinTH, exponent);
}
#include "PBR_VS.fxh"
//////////////////////////////////VS////////////////////////////////////////
void VS_DIY_OUTPUT(in VertexAssemble IN, in InterMediateVertex INTM, inout VertexShadingOutput OUT)
{
	// 1. init tint color
	InitTintColorCommon(IN, OUT); 

	// 2. for snow height calc
	OUT.WorldPosition.w = IN.Position.y;

	// 3. init emmision uv; if not need emmision uv
	InitEmissionUVCommon(IN, OUT);

	// 4. hposition calc
	InitHPositionCommon(INTM, OUT); // init hposition calc

	OUT.HPosition.w *=cFov;

	if(@_CastSunShadow && @_TRANSPARENT)
	{
		// for player's shadow		
		OUT.LitUVZ2 = MulMat4x4(ShadowViewProjTexs0, float4(OUT.WorldPosition.xyz + 
		OUT.WorldNormal.xyz * cBiasFarAwayShadow,1));
	}
}
#include "PBR_Common.fxh"
#include "BRDF.fxh"
//////////////////////////////////PS////////////////////////////////////////
void PS_GetParameters(in VertexShadingOutput IN, out MaterialShadingParameters MaterialParameters)
{
	// init MaterialParameters (always need)
	InitShadingParameters(MaterialParameters);
	//DetailMask
	half4 detailMask = half4(1,0,0,0);
	if(ENABLE_DETAIL_MASK)
		detailMask = tDetailMaskMap.Sample(sDetailMaskMapSampler, BaseMapUV(IN.TexCoord));

	// init MaterialParameters.BaseColor and MaterialParameters.Alpha by sample basemap
	if(@_BaseMapEnable)
	{
		half4 samplerBase;
		samplerBase = tBaseMap.SampleBias(sBaseSampler, BaseMapUV(IN.TexCoord), cBaseMapBias);
		MaterialParameters.BaseColor = DecodeGamma(samplerBase.rgb);
		MaterialParameters.Alpha = min(cAlpha,samplerBase.a);
	}
	else
	{
		MaterialParameters.BaseColor = cBaseColor;
		MaterialParameters.Alpha = cAlpha;
	}
	half clothMask = 0;
	half silkMask = 0;
	// init smoothness/metal/ao by sample mixmap
	if (@_EnableReflection && @_LOD_LEVEL <= LOD_Level_2)
	{
		half4 samplerMis = tMixMap.Sample(sMixSampler, BaseMapUV(IN.TexCoord));
		clothMask = samplerMis.b;
		silkMask = samplerMis.a;
		MaterialParameters.Roughness = 1 - samplerMis.r;
		MaterialParameters.Metallic = samplerMis.g;
		MaterialParameters.CustomData.r = clothMask;
		MaterialParameters.CustomData.g = cFuzzSpecIns * 0.1;
	}
	//Detail Base And Roughness
	if(ENABLE_DETAIL_BASE)
	{
		if(detailMask.r > 0.1)
		{
			half4 detailBase01 = tDetailBaseMap.Sample(sDetailBaseSampler, float3(BaseMapUV(IN.TexCoord) * cDetail01UV, 0));
			detailBase01.rgb = DecodeGamma(detailBase01.rgb);
			half detailRoughness01 = 1 - detailBase01.a;
			MaterialParameters.BaseColor = lerp(MaterialParameters.BaseColor, detailBase01.rgb, detailMask.r * cDetailBase01Ins);
			MaterialParameters.Roughness = lerp(MaterialParameters.Roughness, detailRoughness01, detailMask.r * cDetailMix01Ins);
		}
		if(detailMask.g > 0.1)
		{
			half4 detailBase02 = tDetailBaseMap.Sample(sDetailBaseSampler, float3(BaseMapUV(IN.TexCoord) * cDetail02UV, 1));
			detailBase02.rgb = DecodeGamma(detailBase02.rgb);
			half detailRoughness02 = 1 - detailBase02.a;
			MaterialParameters.BaseColor = lerp(MaterialParameters.BaseColor, detailBase02.rgb, detailMask.g * cDetailBase02Ins);
			MaterialParameters.Roughness = lerp(MaterialParameters.Roughness, detailRoughness02, detailMask.g * cDetailMix02Ins);
		}
		if(detailMask.b > 0.1)
		{
			half4 detailBase03 = tDetailBaseMap.Sample(sDetailBaseSampler, float3(BaseMapUV(IN.TexCoord) * cDetail03UV, 2));
			detailBase03.rgb = DecodeGamma(detailBase03.rgb);
			half detailRoughness03 = 1 - detailBase03.a;
			MaterialParameters.BaseColor = lerp(MaterialParameters.BaseColor, detailBase03.rgb, detailMask.b * cDetailBase03Ins);
			MaterialParameters.Roughness = lerp(MaterialParameters.Roughness, detailRoughness03, detailMask.b * cDetailMix03Ins);
		}
	}

	// init MaterialParameters.WorldNormal by sample normalmap
	if(@_TANGENT && @_NormalMapEnable)
	{
		half4 samplerNormal = tNormalMap.SampleBias(sNormalSampler, BaseMapUV(IN.TexCoord), cNormalMapBias);
		MaterialParameters.AO = samplerNormal.a;
		half3 tangentNormal = samplerNormal.xyz;
		[@_DIRECTX]//always use bc5 for pc
		tangentNormal.z = 1;
		tangentNormal = (2 * tangentNormal) - 1;
		//Detail Normal And Metallic
		if(ENABLE_DETAIL_NORMAL)
		{
			if(detailMask.r > 0.1)
			{
				half4 detailNormal01 = tDetailNormalMap.Sample(sDetailNormalSampler, float3(BaseMapUV(IN.TexCoord) * cDetail01UV, 0));
				silkMask = max(silkMask, detailNormal01.b * cDetailMix01Ins);
				half detailMetallic01 = detailNormal01.a;
				tangentNormal.xy += (detailNormal01.xy * 2 - 1) * detailMask.r * cDetailNormal01Ins;
				MaterialParameters.Metallic = lerp(MaterialParameters.Metallic, detailMetallic01, detailMask.r * cDetailMix01Ins);
			}
			if(detailMask.g > 0.1)
			{
				half4 detailNormal02 = tDetailNormalMap.Sample(sDetailNormalSampler, float3(BaseMapUV(IN.TexCoord) * cDetail02UV, 1));
				silkMask = max(silkMask, detailNormal02.b * cDetailMix02Ins);
				half detailMetallic02 = detailNormal02.a;
				tangentNormal.xy += (detailNormal02.xy * 2 - 1) * detailMask.g * cDetailNormal02Ins;
				MaterialParameters.Metallic = lerp(MaterialParameters.Metallic, detailMetallic02, detailMask.g * cDetailMix02Ins);
			}
			if(detailMask.b > 0.1)
			{
				half4 detailNormal03 = tDetailNormalMap.Sample(sDetailNormalSampler, float3(BaseMapUV(IN.TexCoord) * cDetail03UV, 2));
				silkMask = max(silkMask, detailNormal03.b * cDetailMix03Ins);
				half detailMetallic03 = detailNormal03.a;
				tangentNormal.xy += (detailNormal03.xy * 2 - 1) * detailMask.b * cDetailNormal03Ins;
				MaterialParameters.Metallic = lerp(MaterialParameters.Metallic, detailMetallic03, detailMask.b * cDetailMix03Ins);
			}
		}
		if (@_LOD_LEVEL == LOD_Level_1)
			tangentNormal.xy *= LOD_RATE;
		MaterialParameters.WorldNormal = tangentNormal.x * IN.WorldTangent + tangentNormal.y * IN.WorldBinormal + tangentNormal.z * IN.WorldNormal.xyz;
		MaterialParameters.WorldNormal = normalize(MaterialParameters.WorldNormal);
		if(silkMask > 0.1)
		{
			float3 L = SunDirection.xyz;
			float3 V = normalize( -IN.ViewDirection.xyz );
			float3 H = normalize(L + V);
			half3 T = -normalize(cross(IN.WorldBinormal.xyz, MaterialParameters.WorldNormal));
			half3 t1 = ShiftTangent(T, MaterialParameters.WorldNormal, cSilkSpecShift);
			half silkSpec = StrandSpecuar(dot(H, t1), cSilkSpecRange * 100);
			MaterialParameters.CustomData.b = saturate(silkSpec) * cSilkSpecIns * 0.1 * silkMask;
		}
	}
	else
		MaterialParameters.WorldNormal = IN.WorldNormal.xyz;
	
	// init MaterialParameters.Emission by sample emissinMap (if need or not)
	if (@_EmissionMapEnable && @_LOD_LEVEL <= LOD_Level_2)
	{
		half2 EmissionUV = half2(IN.WorldNormal.w, IN.ViewDirection.w);
		MaterialParameters.Emission = tEmissionMap.Sample(sEmissionMapSampler, EmissionUV).rgb;
		MaterialParameters.Emission.rgb *= cEmissionScale.rgb;
		if(@_HDR){MaterialParameters.Emission.rgb *= MaterialParameters.BaseColor;}
	}

	// Apply Weather
	InitRain(IN, MaterialParameters);
}
#include "PBR_PS.fxh"


