#pragma shader material

///////////////choice define start///////////////////////////
#define MATERIAL_SHADINGMODEL_EYE 			1
#define NO_LIGHT_MAP_SCALE 					0
#define USE_LIGHTMAP						0
#define USE_LIGHTMAP_CONST					0
#define USE_CLIPPING						1
#define USE_WIREFRAME						1
#define USE_FROZEN							0
#define USE_BURNT							0
#define USE_HIGHLIGHT						0
#define USE_XRAY							1
#define USE_EDGELINE						0
#define USE_PLANAR_SHADOW					0
#define USE_VBufferGen						1
#define VIRTUAL_LIT 						0
#define USE_UNIDIRECTIONAL_DISSOLVE			1
#pragma shader predict("@_TANGENT", "true")
#pragma shader predict("@_CLIPPING", "false")
#pragma shader predict("@_TRANSPARENT", "false")
#pragma shader predict("@_VERTEXCOLOR", "true")
#pragma shader predict("@_INSTANCED", "false")
#pragma shader predict("@_DF_SKIN", "0")
#define HAS_2UV								0
#define ENABLE_MIXMAP						(@_EnableReflection)
#define ENABLE_ANISOTROPIC 					0
#define ENABLE_RIPPLE 						0
#define ENABLE_SCREEN_SHADOWMAP				(@_CSM && @_CastSunShadow && @_LOD_LEVEL <= LOD_Level_2 && !@_TRANSPARENT)
#define USE_SHADOWMAP_SAMPLE				((@_LOD_LEVEL <= LOD_Level_2 && @_CastSunShadow) && (@_TRANSPARENT || (!@_CSM && @_REC_SHADOW)))
#define DEFERRED_PRE_AO						1 // 是否走ao
///////////////choice define end//////////////////////////

#include "PBR_Definitions.fxh"
#include "Constants.fxh"
#include "Common.fxh"
//////////////////////////////////Properties////////////////////////////////////////
@_BaseMapEnable 
{ 
	Name = BaseMapEnable;
	Description = "Do we have BaseMap?";
	AffectedTex = tBaseMap;
	Fallback = true;
	Visible = false;
};
@_EnableReflection 
{
	Name = EnableReflection;
	Description = "EnableReflection?";
	AffectedTex = tMixMap;
	Fallback = true;
	Visible = false;
	Default = false;
};
@_EnableIBL
{
	Name = EnableIBL;
	Description = "Enable Image based lighting?";
	Default = true;
	Visible = true;	
};
@_NormalMapEnable
{
	Name = NormalMapEnable;
	Description = "Do we have NormalMap?"; 
	AffectedTex = tNormalMap;
	Fallback = "@_TANGENT";
	Visible = false;
};
@_LightMapEnable
{
	Name = LightMapEnable;
	Description = "Do we have LightMap?";
	AffectedTex = tLightMap;
	Fallback = "@_LIGHT_MAP";
	Visible = false;
};
@_EmissionMapEnable
{
	Name = EmissionMapEnable;
	Description = "Do we have EmissionMap?";
	AffectedTex = tEmissionMap; 
	Fallback = true;
	Visible = false;
};
@_LightmapConstEnable
{
	Name = LightmapConstEnable;
	Default = false;
	Visible = false;
};
@_HighlightEnable
{
	Name = HighlightEnable;
	Description = "for deferred pipeline change highlight pass";
	Default = false;
	Visible = false;
};
@_FrozenEnable
{
	Name = FrozenEnable;
	Description = "for deferred pipeline change frozen pass";
	Default = false;
	Visible = false;
};
@_BurntEnable
{
	Name = BurntEnable;
	Description = "for deferred pipeline change burnt pass";
	Default = false;
	Visible = false;
};
@_UnidirectionalDissolveEnable
{
	Name = UnidirectionalDissolveEnable;
	Description = "material has unidirectional dissolve effect";
	Visible = true;
	Default = false;
};
@_GrayEffect
{
	Name = GrayEffect;
	Description = "for Graying";
	Visible = true;
	Default = false;
};
//////////////////////////////////Constant buffer////////////////////////////////////////
cbuffer Shader
{
	float3 cBaseColor 				 < Widget = "LinearColor3";Visible = "0"; > = {1, 1, 1};
	float3 cEyeShadowColor			 < Widget = "LinearColor3";> = {0.23,0.08,0.03};
	float cAlpha	      			 < Widget = "FloatSlider"; Min = "0"; Max = "10"; Step = "0.1"; Precision = "2"; Visible = "0";> = 1.0;

	float cAliasingFactor			 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2";Visible = "0"; > = 0.2;//抗锯齿因子
	float cEnvStrength				 < Widget = "FloatSlider"; Min = "0"; Max = "10"; Step = "0.01"; Precision = "2"; Visible = "0";> = 1;	//环境强度[0:8]
	//float cRoughnessLow				 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; > = 0;	//粗糙度下界
	//float cRoughnessHigh			 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; > = 1;	//粗糙度上界
	float cRoughness				 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; > = 0;

	float  cSmoothness				 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; Visible = "0";> = 0;
	float  cBloomScale				 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; Visible = "0";> = 0.5;
	float  cBaseMapBias				 < Widget = "FloatSlider"; Min = "-2"; Max = "2"; Step = "0.01"; Precision = "2"; Visible = "0";> = -1;
	float  cNormalMapBias			 < Widget = "FloatSlider"; Min = "-2"; Max = "2"; Step = "0.01"; Precision = "2"; Visible = "0";> = -0.5;

	float4 cEmissionScale			 < Widget = "FloatSlider";Visible = "0";> = {1, 1, 1, 0};
	float4 cEmissionScrolling		< Widget = "FloatSlider";Visible = "0";> = {1, 1, 0, 0};

	float cFogDistance				 < Widget = "FloatSlider"; Min = "0"; Max = "1000"; Step = "0.1"; Precision = "2";Visible = "0"; > = 100;
	float cBumpIns      			 < Widget = "FloatSlider"; Min = "0"; Max = "10"; Step = "0.1"; Precision = "2"; Visible = "0";> = 1;
	float cDepthOffset     			 < Widget = "FloatSlider"; Min = "-20"; Max = "20"; Step = "0.1"; Precision = "2";Visible = "0"; > = 0;
	float cDepthBias	  			 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.1"; Precision = "2"; Visible = "0";> = 0;
	float cGrayingin				< Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.1"; Precision = "2"; > = 0;
	float cShadowRadius				< Widget = "FloatSlider"; Min = "0"; Max = "20"; Step = "0.1"; Precision = "2"; > = 10;
	float cShadowHardness			< Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.1"; Precision = "2"; > = 0.34;
	float cScaleCenter				< Widget = "FloatSlider"; Min = "0"; Max = "10"; Step = "0.1"; Precision = "2"; Visible = "0";> = 1;
};

//////////////////////////////////Input Texture////////////////////////////////////////
texture2D tBaseMap : layout(t0) = "White";
sampler sBaseSampler : layout(s0, s1)
{
	Texture = tBaseMap;
	Filter = Linear;
	Address = FromTexture;
	SRGB = false;
};

texture2D tMixMap : layout(t2) = "Reflection";
sampler sMixSampler : layout(s2)
{
	Texture = tMixMap;
	Filter = Linear;
	Address = Wrap;
	SRGB = false;
};

texture2D tEnvMap : EnvMap : layout(t3) = "White";
sampler sEnvSampler : layout(s3)
{
	Texture = tEnvMap;
	Filter = Linear;
	Address = Clamp;
	SRGB = false; 
};

texture2D tNormalMap : layout(t4) = "NormalMap";
sampler sNormalSampler : layout(s4)
{
	Texture = tNormalMap;
	Filter = Linear;
	Address = Wrap;
	SRGB = false;
};

// Skin profile map
texture2D tSkinProfileMap : layout(t5) = "White";
sampler sSkinProfileMapSampler : layout(s5)
{
	Texture = tSkinProfileMap;
	Filter = Linear;
	Address = Clamp;
	SRGB = false;
};

// Screen ShadowMap
texture2D tShadowMask : ShadowMask : layout(t6) = "White";
sampler sShadowMaskSampler : layout(s6)
{
	Texture = tShadowMask; 
	Filter = Point; 
	Address = Clamp;
	SRGB = false;
	MaxMipLevel = 0;
};

// ShadowMap 
texture2D tShadowMap : ShadowMap : layout(t7) = "White";
SamplerComparisonState sShadowMapSampler : layout(s7)
{
	Texture = tShadowMap;
	Filter = Linear;
	Address = Clamp;
	ComparisonFunc = Greater;
	SRGB = false;
	MaxMipLevel = 0;
};

// Emission map
texture2D tEmissionMap : layout(t8) = "Transparent";
sampler sEmissionMapSampler : layout(s8)
{
	Texture = tEmissionMap;
	Filter = Linear; 
	Address = Wrap;
	SRGB = false;
};

texture2D tRainMap : RainMap: layout(t9) = "NormalMap";
sampler sRainSampler : layout(s9)
{
	Texture = tRainMap;
	Filter = Linear;
	Address = Wrap;
	SRGB = false;
};

texture2D tSkeletonMap : SkeletonMap : layout(t3) = "Black";
sampler sSkeletonSampler : layout(s3)
{
	Texture = tSkeletonMap;
	Filter = Point;
	Address = Clamp;
	SRGB = false;
};
#include "PBR_VS.fxh"
//////////////////////////////////////Function////////////////////////////////////
float SphereMask(float2 A, float2 B, float AttenuationRadius, float Hardness)
{
	float Distance = length((A-B));
	float ArgInvRadius = 1/AttenuationRadius;
	float NormalizeDistance = Distance * ArgInvRadius;
	float ArgInvHardness = 1 - Hardness;
	float NegNormalizedDistance=1-NormalizeDistance;
	float MaskUnclamped = NegNormalizedDistance * ArgInvHardness;
	return clamp(MaskUnclamped, 0, 1);
}

float2 ScaleUVsByCenter(float scale,in VertexShadingOutput IN)
{
	float2 A = (IN.TexCoord / scale) + float2(0.5,0.5);
	float2 B = float2(0.5,0.5) / (IN.TexCoord / scale);
	return (A - B);
}
////////////////////////////////////////////////////////////////////////////////////

//////////////////////////////////VS////////////////////////////////////////
void VS_DIY_OUTPUT(in VertexAssemble IN, in InterMediateVertex INTM, inout VertexShadingOutput OUT)
{
	// 1. init tint color
	InitTintColorCommon(IN, OUT); 

	// 2. for snow height calc
	OUT.WorldPosition.w = IN.Position.y;

	// 3. init emmision uv; if not need emmision uv
	InitEmissionUVCommon(IN, OUT);

	// 4. hposition calc
	InitHPositionCommon(INTM, OUT); // init hposition calc
}
#include "PBR_Common.fxh"
//////////////////////////////////PS////////////////////////////////////////
void PS_GetParameters(in VertexShadingOutput IN, out MaterialShadingParameters MaterialParameters)
{
	InitShadingParameters(MaterialParameters);

	half2 parallax = half2(0,0);
	half3 V = normalize( -IN.ViewDirection.xyz );
	if (ENABLE_MIXMAP && @_LOD_LEVEL <= LOD_Level_2)
	{
		half3 samplerMis = tMixMap.Sample(sMixSampler, BaseMapUV(IN.TexCoord)).rgb;
		half Smoothness = 1;
		MaterialParameters.CustomData.r = 1- samplerMis.r;
		MaterialParameters.Specular *= samplerMis.g;
		//MaterialParameters.Roughness = lerp(cRoughnessHigh, cRoughnessLow, Smoothness);
		MaterialParameters.Roughness = cRoughness;
		if(@_TANGENT && !@_TRANSPARENT)
		{
			half2 tangentV = half2(dot(IN.WorldTangent,V),dot(IN.WorldBinormal,V));
			half parallaxMask = 1 - samplerMis.b;
			parallax = tangentV.xy * parallaxMask * -0.2;
			parallax.y = - parallax.y;
		}
	}

	//init MaterialParameters.WorldNormal by sample normalmap
	if(@_TANGENT && @_NormalMapEnable)
	{
		half3 tangentNormal = tNormalMap.SampleBias(sNormalSampler, BaseMapUV(IN.TexCoord), -2).xyz;
		[@_DIRECTX]//always use bc5 for pc
		tangentNormal.z = 1;
		tangentNormal = (2 * tangentNormal) - 1;
		MaterialParameters.WorldNormal = tangentNormal.x * IN.WorldTangent.xyz + tangentNormal.y * IN.WorldBinormal.xyz + tangentNormal.z * IN.WorldNormal.xyz;
		MaterialParameters.WorldNormal = normalize(MaterialParameters.WorldNormal);
	}
	else
		MaterialParameters.WorldNormal = IN.WorldNormal.xyz;

	if(@_BaseMapEnable)
	{
		half4 samplerBase;
		samplerBase = tBaseMap.SampleBias(sBaseSampler, BaseMapUV(IN.TexCoord) + parallax, cBaseMapBias);
		MaterialParameters.BaseColor = DecodeGamma(samplerBase.rgb);
		MaterialParameters.Alpha = min(cAlpha,samplerBase.a);
	}
	else
	{
		MaterialParameters.BaseColor = cBaseColor;
		MaterialParameters.Alpha = cAlpha;
	}

	//R Specular Virtrual Lit
	if(VIRTUAL_LIT)
	{
		half3 V = normalize(-IN.ViewDirection.xyz);
		half NoV = dot(MaterialParameters.WorldNormal, V) * 0.5 + 0.5;
		half3 H = normalize(V + V);
		//specular lighting	
		half specularIns = lerp(1, 0.1, MaterialParameters.CustomData.r);
		half3 virtrualSpecLight = pow(max(0.0001,dot(MaterialParameters.WorldNormal, H)), 500) * 2 * specularIns;
		half3 virtrualDiffLight = NoV * MaterialParameters.BaseColor / PI;
		MaterialParameters.Emission += cVirtualLitColor * NoV * (virtrualSpecLight + virtrualDiffLight);
	}

	//EyeReflection
	// if(@_LOD_LEVEL <= LOD_Level_2)
	// {
	// 	half3 samplerMis = tMixMap.Sample(sMixSampler, BaseMapUV(IN.TexCoord)).rgb;

	// 	half3 sampleEnvSpecular = half3(0,0,0);
	// 	half MIP_ROUGHNESS = 0.45;
	// 	half3 R = reflect( -IN.ViewDirection.xyz,IN.WorldNormal.xyz);
	// 	half level = MaterialParameters.Roughness / MIP_ROUGHNESS;
	// 	half fSign = R.z > 0;
	// 	half fSign2 = fSign*2 - 1;
	// 	R.xy /= R.z*fSign2 + 1;
	// 	R.xy = R.xy * half2(0.25, -0.25) + (0.25+0.5*fSign);
	// 	sampleEnvSpecular = RGBMDecode( tEnvMap.SampleLevel(sEnvSampler, R.xy,level), 16.0);

	// 	float3 vcolor = lerp(0.08 * MaterialParameters.Specular.xxx, MaterialParameters.BaseColor, MaterialParameters.Metallic);
	// 	sampleEnvSpecular = pow(sampleEnvSpecular,1.5).x * 0.3 * vcolor; 
	// 	sampleEnvSpecular *= samplerMis.r; 
		
	// 	MaterialParameters.BaseColor += sampleEnvSpecular;
	// }

	//EyeSclera
	if(@_LOD_LEVEL <= LOD_Level_2)
	{
		float3 EyeCornerDarknessColor = cEyeShadowColor;
		half3 samplerMis = tMixMap.Sample(sMixSampler, BaseMapUV(IN.TexCoord)).rgb;

		float2 ScaledUV = ScaleUVsByCenter(cScaleCenter,IN);
		float SMask = SphereMask(ScaledUV,float2(0.5, 0.5),cShadowRadius,cShadowHardness);

		EyeCornerDarknessColor = lerp(float3(1,1,1),EyeCornerDarknessColor,SMask);

		MaterialParameters.BaseColor =lerp(MaterialParameters.BaseColor,MaterialParameters.BaseColor*EyeCornerDarknessColor,1 - samplerMis.r);
	}


	//Apply Weather
	MaterialParameters.BaseColor *= 1 - 0.3 * RainRate;

	//GrayingEffect
	InitGrayEffect(cGrayingin,MaterialParameters);

	
}
#include "PBR_PS.fxh"

