#pragma shader material

///////////////choice define start///////////////////////////
#define MATERIAL_SHADINGMODEL_DEFAULT_LIT 	1 // for deferred
#define NO_LIGHT_MAP_SCALE 					0
#define USE_LIGHTMAP						0
#define USE_LIGHTMAP_CONST					0
#define USE_VBufferGen						1
#define VIRTUAL_LIT 						0
#define USE_UNIDIRECTIONAL_DISSOLVE			1
#pragma shader predict("@_TANGENT", "true")
#pragma shader predict("@_CLIPPING", "false")
#pragma shader predict("@_TRANSPARENT", "false")
#pragma shader predict("@_VERTEXCOLOR", "true")
#pragma shader predict("@_INSTANCED", "false")
#pragma shader predict("@_DF_SKIN", "0")
#define HAS_2UV								0
#define ENABLE_MIXMAP						1
#define ENABLE_SCREEN_SHADOWMAP				(@_CSM && @_CastSunShadow && @_LOD_LEVEL <= LOD_Level_2 && !@_TRANSPARENT)
#define USE_SHADOWMAP_SAMPLE				((@_LOD_LEVEL <= LOD_Level_2 && @_CastSunShadow) && (@_TRANSPARENT || (!@_CSM && @_REC_SHADOW)))
#define USE_PLAYER_SHADOWMAP				1 // 全是在开csm下有效的
///////////////choice define end//////////////////////////

#include "PBR_Definitions.fxh"
#include "Constants.fxh"
#include "Common.fxh"
//////////////////////////////////Properties////////////////////////////////////////
@_EnableReflection 
{
	Name = EnableReflection;
	Description = "EnableReflection?";
	AffectedTex = tMixMap;
	Fallback = true;
	Visible = false;
	Default = false;
};
@_EnableIBL
{
	Name = EnableIBL;
	Description = "Enable Image based lighting?";
	Default = true;
	Visible = true;	
};
@_NormalMapEnable
{
	Name = NormalMapEnable;
	Description = "Do we have NormalMap?"; 
	AffectedTex = tNormalMap;
	Fallback = "@_TANGENT";
	Visible = false;
};
@_UnidirectionalDissolveEnable
{
	Name = UnidirectionalDissolveEnable;
	Description = "material has unidirectional dissolve effect";
	Visible = true;
	Default = false;
};
@_GrayEffect
{
	Name = GrayEffect;
	Description = "for Graying";
	Visible = true;
	Default = false;
};
//////////////////////////////////Constant buffer////////////////////////////////////////
cbuffer Shader
{
	float3 cBaseColor 				< Widget = "LinearColor3"; > = {1, 1, 1};
	float cAlpha	      			< Widget = "FloatSlider"; Min = "0"; Max = "10"; Step = "0.1"; Precision = "2";Visible = "0"; > = 1.0;

	float cAliasingFactor			< Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; Visible = "0";> = 0.2;//抗锯齿因子
	float cEnvStrength				< Widget = "FloatSlider"; Min = "0"; Max = "10"; Step = "0.01"; Precision = "2";Visible = "0"; > = 1;//环境强度[0:8]
	float cRoughnessLow				< Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; > = 0;	//粗糙度下界
	float cRoughnessHigh			< Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; > = 1;	//粗糙度上界

	float  cBloomScale				< Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; Visible = "0";> = 0.5;
	float  cBaseMapBias				< Widget = "FloatSlider"; Min = "-2"; Max = "2"; Step = "0.01"; Precision = "2";Visible = "0"; > = -1;
	float  cNormalMapBias			< Widget = "FloatSlider"; Min = "-2"; Max = "2"; Step = "0.01"; Precision = "2"; Visible = "0";> = -0.5;
	float cFogDistance				< Widget = "FloatSlider"; Min = "0"; Max = "1000"; Step = "0.1"; Precision = "2"; Visible = "0";> = 100;

	float cDepthOffset     			< Widget = "FloatSlider"; Min = "-20"; Max = "20"; Step = "0.1"; Precision = "2";Visible = "0"; > = 0;
	float cDepthBias	  			< Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.1"; Precision = "2";Visible = "0"; > = 0;
	float cBiasFarAwayShadow		< Widget = "FloatSlider"; Min = "0"; Max = "10"; Step = "0.1"; Precision = "3"; Visible = "0";> = 0.01;
	float cRefraction	 	 	 	< Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; > = 1.0;
	float cGrayingin				< Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.1"; Precision = "2"; > = 0;
	float cSpecular					< Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.1"; Precision = "2"; > = 0.5;
	
};

//////////////////////////////////Input Texture////////////////////////////////////////
texture2D tMixMap : layout(t0) = "Reflection";
sampler sMixSampler : layout(s0)
{
	Texture = tMixMap;
	Filter = Linear;
	Address = Wrap;
	SRGB = false;
};

texture2D tEnvMap : EnvMap : layout(t1) = "White";
sampler sEnvSampler : layout(s1)
{
	Texture = tEnvMap;
	Filter = Linear;
	Address = Clamp;
	SRGB = false; 
};

texture2D tNormalMap : layout(t2) = "NormalMap";
sampler sNormalSampler : layout(s2)
{
	Texture = tNormalMap;
	Filter = Linear;
	Address = Wrap;
	SRGB = false;
};

// Light map
texture2D tLightMap : layout(t3);
sampler sLightMapSampler : layout(s3)
{
	Texture = tLightMap;
	Filter = Linear;
	Address = Clamp;
	SRGB = false;
	MaxMipLevel = 0;
};

texture2D tShadowMask : ShadowMask : layout(t4) = "White";
sampler sShadowMaskSampler : layout(s4)
{
	Texture = tShadowMask; 
	Filter = Point; 
	Address = Clamp;
	SRGB = false;
	MaxMipLevel = 0;
};
// ShadowMap 
texture2D tShadowMap : ShadowMap : layout(t5) = "White";
SamplerComparisonState sShadowMapSampler : layout(s5)
{
	Texture = tShadowMap;
	Filter = Linear;
	Address = Clamp;
	ComparisonFunc = Greater;
	SRGB = false;
	MaxMipLevel = 0;
};

texture2D ScreenTexture : SceneColorOpaque : layout(t6);
sampler ScreenTexture_Sampler : layout(s6)
{
	Texture = ScreenTexture;
	Filter = Linear;
	Address = Mirror;
};

texture2D tSkeletonMap : SkeletonMap : layout(t4) = "Black";
sampler sSkeletonSampler : layout(s4)
{
	Texture = tSkeletonMap;
	Filter = Point;
	Address = Clamp;
	SRGB = false;
};

#include "PBR_VS.fxh"
//////////////////////////////////VS////////////////////////////////////////
void VS_DIY_OUTPUT(in VertexAssemble IN, in InterMediateVertex INTM, inout VertexShadingOutput OUT)
{
	// 1. init tint color
	InitTintColorCommon(IN, OUT); 

	// 2. for snow height calc
	OUT.WorldPosition.w = IN.Position.y;

	// 4. hposition calc
	InitHPositionCommon(INTM, OUT); // init hposition calc

	if(@_CastSunShadow && @_TRANSPARENT)
	{
		// for player's shadow		
		OUT.LitUVZ2 = MulMat4x4(ShadowViewProjTexs0, float4(OUT.WorldPosition.xyz + 
		OUT.WorldNormal.xyz * cBiasFarAwayShadow,1));
	}
}
#include "PBR_Common.fxh"
//////////////////////////////////PS////////////////////////////////////////
void PS_GetParameters(in VertexShadingOutput IN, out MaterialShadingParameters MaterialParameters)
{
	//init MaterialParameters (always need)
	InitShadingParameters(MaterialParameters);

	//init MaterialParameters.WorldNormal by sample normalmap
	if(@_TANGENT && @_NormalMapEnable && @_LOD_LEVEL <= LOD_Level_1)
	{
		half3 tangentNormal = tNormalMap.SampleBias(sNormalSampler, BaseMapUV(IN.TexCoord), 2).xyz * 2 - 1;
		[@_DIRECTX]//always use bc5 for pc
		tangentNormal.z = 1;
		tangentNormal.xy*= 0.5;
		MaterialParameters.WorldNormal = tangentNormal.x * IN.WorldTangent + tangentNormal.y * IN.WorldBinormal + tangentNormal.z * IN.WorldNormal.xyz;
		MaterialParameters.WorldNormal = normalize(MaterialParameters.WorldNormal);
	}
	else
	{ 
		MaterialParameters.WorldNormal = normalize(IN.WorldNormal.xyz);
	}

	half3 samplerMis = tMixMap.Sample(sMixSampler, BaseMapUV(IN.TexCoord)).rgb;
	half Smoothness = samplerMis.r;
	MaterialParameters.CustomData.a = samplerMis.g ;//Specular Mask
	MaterialParameters.AO = samplerMis.b;
	MaterialParameters.Roughness = lerp(cRoughnessHigh, cRoughnessLow, Smoothness);
	MaterialParameters.Specular = cSpecular;

	float2 spos = IN.HPosition.xy;
	if(@_D3D9)
		{spos += 0.5;}
	half2 baseUV = spos * ScreenInfo.zw;
	baseUV += MaterialParameters.WorldNormal.xy * half2(0.1 * cRefraction * MaterialParameters.CustomData.a, 0);
	MaterialParameters.CustomData.rgb = ScreenTexture.Sample(ScreenTexture_Sampler, baseUV).rgb;
}
#include "BRDF.fxh"
//////////////////////////////////Shading////////////////////////////////////////
VertexShadingOutput PbrVertexShading(in VertexAssemble IN)
{
	VertexShadingOutput OUT;
	InitVertexShadingOutput(OUT);
	
	//InterMediate
	InterMediateVertex INTM;
	VertexUnifyInterMediate(IN, INTM);
	VertexUnifySkinning(IN, INTM);
#if IS_HEIGHTMAP
	HEIGHTMAP_MODIFIER(IN, INTM);
#endif

	//OUTPUT
	VertexUnifyOutputCommon(IN, INTM, OUT);

	return OUT;
}

float4 PbrPixelShading(in VertexShadingOutput IN) : SV_Target
{
	float4 OUT = float4(0, 0, 0, 0);

	//1, Gen MaterialParameters & GBufferData
	MaterialShadingParameters MaterialParameters;
	GBufferData GBuffer;
	PS_GetParameters(IN, MaterialParameters);
	OUT.a = MaterialParameters.Alpha;

	//screen gray
	MaterialParameters.SpecularColor = lerp(0.08 * MaterialParameters.Specular.xxx, MaterialParameters.BaseColor, MaterialParameters.Metallic);
	MaterialParameters.DiffuseColor = Diffuse_Lambert(MaterialParameters.BaseColor);
		
	//ShadowAndAO
	half GTAO = 1;
	if(USE_SHADOWMAP_SAMPLE)
		MaterialParameters.InShadow = GetDynamicShadowForSun(IN);
	
	//2, lighting
	LightingResult LitResult;
	LitResult.DiffuseLighting = half3(0, 0, 0);
	LitResult.SpecularLighting = half3(0, 0, 0);
	half3 V = normalize(-IN.ViewDirection.xyz);
	half NoV = saturate(dot(MaterialParameters.WorldNormal, V));
	half3 R = reflect(-V, MaterialParameters.WorldNormal);
	ModifyReflectionDirection(IN, R);
	//set GBuffer
	SetGBufferForShadingModel(GBuffer, MaterialParameters);
	//GI Specular lighting
	half3 IBLSpec = half3(0,0,0);
	if (@_LOD_LEVEL <= LOD_Level_1)
		IBLSpec = IBL_Specular(GBuffer, R, NoV);
	//sun lighting
	LightingData LitData = GetSunLightData(V, GBuffer, PBRQualityLevel_Normal);


	// half3 InputRadiance = LitData.FalloffColor * LitData.Atten * (1 - LitData.InShadow);
	// half3 H = normalize(LitData.V + LitData.L);
	// half NoL = LitData.NoL;
	// //sun specular lighting
	// half3 DirectSpecularAdd = pow(max(0.0001,dot(GBuffer.WorldNormal, H)), 500);
	// LitResult.SpecularLighting += InputRadiance * DirectSpecularAdd * NoL;

	IntegrateBxDF(LitResult, GBuffer, LitData);	

	//thunder shading
	LitResult.SpecularLighting *= ThunderRate;
	//point lighting calc include vs lighting and ps lighting
	InitPointLighting(IN, GBuffer, LitResult, V, NoV);
	//virtual lit calc
	if(VIRTUAL_LIT)
	{
		half3 virtualLitSpec = SimpleBRDF_SPEC(V, GBuffer.WorldNormal, V, NoV, NoV, GBuffer.SpecularColor, GBuffer.Roughness) * cVirtualLitColor.rgb * NoV;
		LitResult.SpecularLighting += virtualLitSpec;
	}
	//accumulate specular and diffuse
	OUT.rgb += GBuffer.Emission;//emission without GI lighting
	OUT.rgb += (LitResult.SpecularLighting + IBLSpec) * GBuffer.CustomData.a;
	OUT.rgb += GBuffer.CustomData.rgb * GBuffer.AO;

	//3, Fog shading.
	InitFogLighting(IN, LitData, OUT);

	//always calc in linear space
	EncodeHDR(OUT.rgb);

	//5, bloom scale dependends specular color only and transparent will OUT.rgb * OUT.a
	InitBloomScale( LitResult, MaterialParameters, OUT);

	//GrayingEffect
	InitGrayEffect(cGrayingin,MaterialParameters);
	return OUT;
}

technique Shading
{
	VertexShader = PbrVertexShading();
#if USE_TESSELLATION	
	HullShader = PbrVertexShading_HS();
	DomainShader = PbrVertexShading_DS();
#endif
	PixelShader = PbrPixelShading();
}

#include "GBufferGenPass.fxh"
#include "WireframePass.fxh"

