#pragma shader material

///////////////choice define start///////////////////////////
#define MATERIAL_SHADINGMODEL_DEFAULT_LIT 	1 // for deferred
#define USE_LIGHTMAP						0
#define USE_LIGHTMAP_CONST					0
#define USE_CLIPPING						1
#define USE_WIREFRAME						1
#define USE_FROZEN							1
#define USE_BURNT							1
#define USE_HIGHLIGHT						1
#define USE_XRAY							1
#define USE_EDGELINE						1
#define USE_PLANAR_SHADOW					0
#define USE_VBufferGen						1
#define VIRTUAL_LIT 						1
#define USE_GRAY                            1
#define USE_ONE_SIDE_LIGHTING				1
#pragma shader predict("@_TANGENT", "true")
#pragma shader predict("@_CLIPPING", "true")
#pragma shader predict("@_TRANSPARENT", "false")
#pragma shader predict("@_VERTEXCOLOR", "true")
// #pragma shader predict("@_INSTANCED", "false")
#pragma shader predict("@_DF_SKIN", "0")
#define HAS_2UV								0
#define ENABLE_MIXMAP						1
#define ENABLE_ANISOTROPIC 					0
#define ENABLE_RIPPLE 						0
#define ENABLE_SCREEN_SHADOWMAP				1
#define ENABLE_HIGHLIGHT					0
#define ENABLE_BURNT						0 // deferred
#define USE_SHADOWMAP_SAMPLE				0
#define DEFERRED_PRE_AO						1 // 是否走ao
#define USE_PLAYER_SHADOWMAP				1 // 全是在开csm下有效的
#define USE_HISM							1
///////////////choice define end//////////////////////////

#include "PBR_Definitions.fxh"
#include "Constants.fxh"
#include "Common.fxh"
//////////////////////////////////Properties////////////////////////////////////////
@_BaseMapEnable 
{ 
	Name = BaseMapEnable;
	Description = "Do we have BaseMap?";  
	AffectedTex = tBaseMap;
	Fallback = true;
	Visible = false;
};
@_EnableReflection 
{
	Name = EnableReflection;
	Description = "EnableReflection?";
	AffectedTex = tMixMap;
	Fallback = true;
	Visible = false;
	Default = false;
};
@_OneSideLightingEnable
{
	Name = OneSideLightingEnable;
	Description = "Do we need calc One side lighting?";
	Default = false;
	Visible = true;	
};
// @_EnableDepthBias
// {
// 	Name = EnableDepthBias;
// 	Description = "Enable Image based lighting?";
// 	Default = false;
// 	Visible = false;	
// };
// @_EnableIBL
// {
// 	Name = EnableIBL;
// 	Description = "Enable Image based lighting?";
// 	Default = false;
// 	Visible = true;	
// };
@_NormalMapEnable
{
	Name = NormalMapEnable;
	Description = "Do we have NormalMap?"; 
	AffectedTex = tNormalMap;
	Fallback = "@_TANGENT";
	Visible = false;
};
// @_LightMapEnable
// {
// 	Name = LightMapEnable;
// 	Description = "Do we have LightMap?";
// 	AffectedTex = tLightMap;
// 	Fallback = "@_LIGHT_MAP";
// 	Visible = false;
// };
@_EmissionMapEnable
{
	Name = EmissionMapEnable;
	Description = "Do we have EmissionMap?";
	AffectedTex = tEmissionMap; 
	Fallback = true;
	Visible = false;
};
// @_AnisotropicEnable
// {
// 	Name = AnisotropicEnable;
// 	Description = "Do we need calc anisotropic lighting?";
// 	Visible = true;
// 	Default = false;
// 	Predict = false;
// };
// @_LightmapConstEnable
// {
// 	Name = LightmapConstEnable;
// 	Default = false;
// 	Visible = false;
// 	Predict = false;
// };
@_IsFootprint
{
	Name = IsFootprint;
	Description = "Footprint material has fade out effect";
	Default = false;
	Visible = true;
};
// @_HighlightEnable
// {
// 	Name = HighlightEnable;
// 	Description = "for deferred pipeline change highlight pass";
// 	Default = false;
// };
// @_FrozenEnable
// {
// 	Name = FrozenEnable;
// 	Description = "for deferred pipeline change frozen pass";
// 	Default = false;
// 	Predict = false;
// };
// @_BurntEnable
// {
// 	Name = BurntEnable;
// 	Description = "for deferred pipeline change burnt pass";
// 	Default = false;
// 	Predict = false;
// };
@_UnidirectionalDissolveEnable
{
	Name = UnidirectionalDissolveEnable;
	Description = "material has unidirectional dissolve effect";
	Visible = true;
	Default = false;
};
// @_WeaponHighLight
// {
// 	Name = WeaponHighLight;
// 	Description = "for WeaponHighlight";
// 	Default = false;
// };

@_IsHISM
{
	Name = IsHISM;
	Description = "Is HISM?"; 
	Fallback = false;
	Visible = false;
};
@_RadarEnable
{
	Name = RadarEnable;
	Description = "RadarEnable";
	Default = false;
	Visible = false;
};
//////////////////////////////////Constant buffer////////////////////////////////////////
cbuffer Shader
{
	float3 cBaseColor 				 < Widget = "LinearColor3"; > = {1, 1, 1};
	float cMetallic					 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; > = 0;	//金属度[0:1] 

	float cAliasingFactor			 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; > = 0.2;//抗锯齿因子
	float cEnvStrength				 < Widget = "FloatSlider"; Min = "0"; Max = "10"; Step = "0.01"; Precision = "2"; > = 1;	//环境强度[0:8]
	float cRoughnessLow				 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; > = 0;	//粗糙度下界
	float cRoughnessHigh			 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; > = 1;	//粗糙度上界
	
	float4 cLightMapScale			 = {1, 1, 1, 1};
	float4 cLightMapUVTransform		 = {1, 1, 0, 0};

	float  cSmoothness				 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; > = 0;
	float  cBloomScale				 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; > = 0.5;
	float  cBaseMapBias				 < Widget = "FloatSlider"; Min = "-2"; Max = "2"; Step = "0.01"; Precision = "2"; > = -1;
	float  cNormalMapBias			 < Widget = "FloatSlider"; Min = "-2"; Max = "2"; Step = "0.01"; Precision = "2"; > = -0.5;

	float4 cEmissionScale			 = {1, 1, 1, 0};
	float4 cEmissionScrolling		 = {1, 1, 0, 0};
	float4 cUVOffsets	 			= {0, 0, 0, 0};

	float cRoughnessX				 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.001"; Precision = "2"; > = 0.1;
	float cRoughnessY				 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.001"; Precision = "2"; > = 1;
	float cAnisotropicScale			 < Widget = "FloatSlider"; Min = "0"; Max = "10"; Step = "0.01"; Precision = "2"; > = 0;
	float cFogDistance				 < Widget = "FloatSlider"; Min = "0"; Max = "1000"; Step = "0.1"; Precision = "2"; > = 100;

	float cBumpIns      			 < Widget = "FloatSlider"; Min = "0"; Max = "10"; Step = "0.1"; Precision = "2"; > = 1;
	float cAlpha	      			 < Widget = "FloatSlider"; Min = "0"; Max = "10"; Step = "0.1"; Precision = "2"; > = 1.0;
	float cDepthOffset     			 < Widget = "FloatSlider"; Min = "-20"; Max = "20"; Step = "0.1"; Precision = "2"; > = 0;
	float cDepthBias	  			 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.1"; Precision = "2"; > = 0;
	
	// float cSnowHeight	  			 < Widget = "FloatSlider"; Min = "-2"; Max = "2"; Step = "0.1"; Precision = "2"; > = 0.6;
	// float cSnowDetail	  			 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.1"; Precision = "2"; > = 1;
	
	float cFov						< Widget = "FloatSlider"; Min = "0"; Max = "5"; Step = "0.1"; Precision = "2"; > = 1;
	float cBiasFarAwayShadow		 < Widget = "FloatSlider"; Min = "0"; Max = "10"; Step = "0.1"; Precision = "3"; > = 0.01;
	float cSaturation				 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.1"; Precision = "2"; > = 1;
	float cWeaponAnimation			= {0};
	
	float3 cRadarColor				< Widget = "LinearColor3"; > = {1, 1, 1};
	float	cRadarScrolling			={0};
	float 	cPlayerDirection			 = {1};

	
	
	
};

//////////////////////////////////Input Texture////////////////////////////////////////
texture2D tBaseMap : layout(t0) = "White";
sampler sBaseSampler : layout(s0)
{
	Texture = tBaseMap;
	Filter = Linear;
	Address = FromTexture;
	SRGB = false;
};

texture2D tMixMap : layout(t1) = "Reflection";
sampler sMixSampler : layout(s1)
{
	Texture = tMixMap;
	Filter = Linear;
	Address = Wrap;
	SRGB = false;
};

texture2D tEnvMap : EnvMap : layout(t2) = "White";
sampler sEnvSampler : layout(s2)
{
	Texture = tEnvMap;
	Filter = Linear;
	Address = Clamp;
	SRGB = false; 
};

texture2D tNormalMap : layout(t3) = "NormalMap";
sampler sNormalSampler : layout(s3)
{
	Texture = tNormalMap;
	Filter = Linear;
	Address = Wrap;
	SRGB = false;
};

// Light map
texture2D tLightMap : layout(t4);
sampler sLightMapSampler : layout(s4)
{
	Texture = tLightMap;
	Filter = Linear;
	Address = Clamp;
	SRGB = false;
	MaxMipLevel = 0;
};

texture2D tShadowMask : ShadowMask : layout(t5) = "White";
sampler sShadowMaskSampler : layout(s5)
{
	Texture = tShadowMask; 
	Filter = Point; 
	Address = Clamp;
	SRGB = false;
	MaxMipLevel = 0;
};
// ShadowMap 
texture2D tShadowMap : ShadowMap : layout(t6) = "White";
SamplerComparisonState sShadowMapSampler : layout(s6)
{
	Texture = tShadowMap;
	Filter = Linear;
	Address = Clamp;
	ComparisonFunc = Greater;
	SRGB = false;
	MaxMipLevel = 0;
};

// Emission map
texture2D tEmissionMap : layout(t7) = "Transparent";
sampler sEmissionMapSampler : layout(s7)
{
	Texture = tEmissionMap;
	Filter = Linear; 
	Address = Wrap;
	SRGB = false;
};

texture2D tRainMap : RainMap: layout(t8) = "NormalMap";
sampler sRainSampler : layout(s8)
{
	Texture = tRainMap;
	Filter = Linear;
	Address = Wrap;
	SRGB = false;
};

texture2D tSkeletonMap : SkeletonMap : layout(t3) = "Black";
sampler sSkeletonSampler : layout(s3)
{
	Texture = tSkeletonMap;
	Filter = Point;
	Address = Clamp;
	SRGB = false;
};
float3 WindParamNormlize()
{
    return float3( normalize( WindParam.xyz + float3( 0.01, 0.01, 0.01)));
}
float3 WindWaveMovementTree(  float3 worldPos,  float scale, float UVy)
{
	float mask = (1-saturate(UVy*2) );
	mask *=mask;
    worldPos = abs(worldPos) * sign(worldPos);
	float3 windDir = float3( WindParamNormlize().x, 0, WindParamNormlize().z);
	float treeSoftWave =  WindParam.w*0.05;
	float3 _treePostion_Instance = worldPos * 0.2;
	float WaveSpeed = GameTime *0.5*6.5;  		
	float WaveSpeedSecond = WaveSpeed * 6.5;//6.5  for unreal to  excharge num
	float WavePos =_treePostion_Instance.x + _treePostion_Instance.z  +WaveSpeed;
	float treeWoldPosWave = sin(WavePos);//+ windTemp.x
	treeWoldPosWave =  pow(treeWoldPosWave + 1.0, 1.5) + 2.0 + WindParam.w;
	float3 windDirDown = float3(0, -1, 0);

	float3 waveHorizontal = windDir * treeSoftWave * treeWoldPosWave * mask;
	float3 waveDown = treeSoftWave * 0.1 * windDirDown * abs(treeWoldPosWave) * mask;
	float3 waveforce = waveHorizontal  ;//+ waveDown
	return waveforce * scale;
}

#ifndef __FILE_PBR_VS_FXH__
#define __FILE_PBR_VS_FXH__

//////////////////////////////////Constant buffer////////////////////////////////////////
cbuffer Batch
{
	float4x3 World 					: World 					;
	float4 cTintColor1				: TintColor1				; 
	float4 cTintColor2				: TintColor2				; 
	float4 cTintColor3				: TintColor3				; 

	float4 cShadowBias				: ShadowBias				; 
#if SD_SH_IBL
	float4 cSHCoefficients[7]		: SHCoefficentsData			;
#else	
	float4 cPointCloud[6]			: PointCloudData			;
	float4 cPlaceHold											;
#endif
	float4 cParamter				: Param						;
	float4 cParamter2				: Param2					;
#if !IS_TERRAIN	
	float4 cVirtualLitDir			: VirtualLitDir				;
	float4 cVirtualLitColor			: VirtualLitColor			;
#else
	float4 cHeightmapMinPos			: HeightmapMinPos			;//w heightmap height
	float4 cHeightmapMaxPos			: HeightmapMaxPos			;//w heightmap range / texture size 
#endif
	float4x4 WorldViewProj			: WorldViewProj				;
	float4x4 LastWorldViewProjTex	: LastWorldViewProjTex		;
	float4 PlayerPos                : PlayerPos					;
	float4 FoliageCenter            : FoliageCenter				;
	float4	SheltermapMinPos		: SheltermapMinPos			;
	float4	SheltermapMaxPos		: SheltermapMaxPos			;
	float4x4 NormalWorld			: NormalWorld				;
	// WolrdToObject
	float4x3 Local 					: InvWorld;	
};

#define SHADOW_BIAS (cShadowBias.x)	
#define SHADOW_SLOPEBIAS (cShadowBias.y)
#if SD_FORWARD_CSM
	#define SHADOW_SELFRATE (frac(cShadowBias.z))
#else
	#define SHADOW_SELFRATE (cShadowBias.z)
#endif
#define SHADOW_PIXELSIZE (cShadowBias.w)
#define LOD_RATE (cParamter.w)
#define SHADOW_BIAS2 (SHADOW_BIAS * floor(cShadowBias.z))
#define SHADOW_SLOPEBIAS2 (SHADOW_SLOPEBIAS * floor(cShadowBias.z))

//////////////////////////////////Assemble Input////////////////////////////////////////
struct VertexAssemble
{
	float4		Position 		: POSITION;
	
	[@_VERTEXCOLOR]
	float4		Color 			: COLOR;
	
	float4		Normal 			: NORMAL;
	float2		TexCoord		: TEXCOORDN;

	[@_LIGHT_MAP]
	float2		TexCoord2		: TEXCOORDN;

	[@_UV3UV4]
	float4		TexCoord3		: TEXCOORD2;

	[@_TANGENT]
	float4		Tangent			: TANGENT;
	[@_TANGENT]
	float4		Binormal		: BINORMAL;

	[@_DF_SKIN]
	float4		BlendWeights	: BLENDWEIGHT;
	[@_DF_SKIN]
	uint4		BlendIndices	: BLENDINDICES;

	[@_INSTANCED]
	float4		Transform0		: TEXCOORD3;
	[@_INSTANCED]
	float4		Transform1		: TEXCOORD4;
	[@_INSTANCED]
	float4		Transform2		: TEXCOORD5;
	[@_INSTANCED]
	float4		LightMapScale	: TEXCOORD6;		// w : Dissolving Ratio
	[@_INSTANCED]
	float4		LightMapTransform: TEXCOORD7;

};

//////////////////////////////////Vertex Output////////////////////////////////////////
struct VertexShadingOutput 
{ 
	// Most common geometric info.
	float4		HPosition		: SV_Position;			//	Position in homogeneous space. For output to rasterizer.
	
	float4		TexCoord		: TEXCOORDN;			//	Texture coordinate for surface.

	float4 		WorldPosition 	: TEXCOORDN;			//  World Position
  
	float		ModelPositionY	: TEXCOORDN;			//	Model PositionY

	float4		WorldNormal		: TEXCOORDN;			//	Outputing normlized normal for lighting.

	float4		ViewDirection	: TEXCOORDN;			//	View direction eye->worldPos.
	
	float4 		DiffLighting 	: TEXCOORDN;			//  PerVertex Diffuse Lighting.
 	
#if IS_TERRAIN//terrain always need tangent/binormal
	half3		WorldTangent	: TEXCOORDN;
	half3		WorldBinormal	: TEXCOORDN;
#else	
	[@_TANGENT] 
	half4		WorldTangent	: TEXCOORDN;
	[@_TANGENT]
	half4		WorldBinormal	: TEXCOORDN;
#endif

	[@_CastSunShadow]
	float4 		LitUVZ			: TEXCOORDN; 

#if IS_WATER
	[@_CastSunShadow]
	float4 		LitUVZ2			: TEXCOORDN;
#elif USE_PLAYER_SHADOWMAP
	[@_CastSunShadow && @_TRANSPARENT]
	float4 		LitUVZ2			: TEXCOORDN;
#endif

	// Shader special output
	float4		TintColor 		: COLOR;				//	TintColor

	[@_INSTANCED]
	float4		LightMapScale	: TEXCOORDN;			//	Light map scale

	float 		LinearZ			: TEXCOORDN;
#ifdef HAS_WORLD_POSITION_OFFSET
	half3		WorldOffset		: TEXCOORDN;
#endif
	float 		CameraDistance  : TEXCOORDN;
};

//////////////////////////////////InterMediateVertex////////////////////////////////////////
struct InterMediateVertex
{
	float4 LocalPosition;

	float3 LocalNormal;

	[@_TANGENT]
	float3 LocalTangent;

	[@_TANGENT]
	float3 LocalBinormal;
};

//////////////////////////////////Functions////////////////////////////////////////
void InitVertexShadingOutput(inout VertexShadingOutput OUT)
{
	//[@_HLSL]
	//OUT = (VertexShadingOutput)0;

	//PBR_VS::struct VertexShadingOutput

	OUT.HPosition = float4(0, 0, 0, 0);

	OUT.TexCoord = float4(0,0,0,0);

	OUT.WorldPosition = float4(0,0,0,0);

	OUT.ModelPositionY = 0;

	OUT.WorldNormal = float4(0,0,0,0);

	OUT.ViewDirection = float4(0,0,0,0);

	OUT.DiffLighting = float4(0,0,0,1);

	#if IS_TERRAIN
		OUT.WorldTangent = half3(0,0,0);
		OUT.WorldBinormal = half3(0,0,0);
	#else
	[@_TANGENT]
	OUT.WorldTangent = half4(0,0,0,0);
	[@_TANGENT]	
	OUT.WorldBinormal = half4(0,0,0,0);
	#endif

	[@_CastSunShadow]
	OUT.LitUVZ = float4(0,0,0,0);

#if IS_WATER
	[@_CastSunShadow]
	OUT.LitUVZ2	 = float4(0,0,0,0);
#elif USE_PLAYER_SHADOWMAP
	[@_CastSunShadow && @_TRANSPARENT]
	OUT.LitUVZ2	 = float4(0,0,0,0);
#endif

	OUT.TintColor = float4(0,0,0,0);

	[@_INSTANCED]
	OUT.LightMapScale = float4(0,0,0,0);

#ifdef HAS_WORLD_POSITION_OFFSET
	OUT.WorldOffset = half3(0, 0, 0);
#endif
	OUT.LinearZ = 0; 
	OUT.CameraDistance = 1;
}

void InitInterMediateVertex(inout InterMediateVertex INTM)
{
	INTM.LocalPosition = float4(0,0,0,0);
	
	INTM.LocalNormal = float3(0,0,0);

	[@_TANGENT]
	INTM.LocalTangent = float3(0,0,0);

	[@_TANGENT]
	INTM.LocalBinormal = float3(0,0,0);
}

void VertexUnifyInterMediate(in VertexAssemble IN, inout InterMediateVertex INTM)
{
	//[@_HLSL]
	//INTM = (InterMediateVertex)0;

	INTM.LocalPosition = float4(IN.Position.xyz, 1.0);
	INTM.LocalNormal.xyz = (float3)Expand(IN.Normal.xyz);

	if(@_TANGENT)
	{
		INTM.LocalTangent = normalize(IN.Tangent.xyz);
		INTM.LocalBinormal = normalize(IN.Binormal.xyz);
	}
}

void VertexUnifySkinning(in VertexAssemble IN, inout InterMediateVertex INTM)
{
	if (@_DF_SKIN)
	{
		half w = 0;		
	
	}
}


void VertexUnifySkinningTex(in VertexAssemble IN, inout InterMediateVertex INTM)
{
	if (@_DF_SKIN)
	{
		half w = 0;
			}
}

void InitTintColorCommon(in VertexAssemble IN, inout VertexShadingOutput OUT)
{

		OUT.TintColor = float4(1, 1, 1, 1);

}

void InitHPositionCommon(in InterMediateVertex INTM, inout VertexShadingOutput OUT)
{
	float3 vertexoffset = float3(0,0,0);
	if(@_LOD_LEVEL< LOD_Level_3)
	{
		vertexoffset = WindWaveMovementTree(OUT.WorldPosition.xyz,WindParam.w,OUT.TexCoord.y);
	}
	
	if (@_INSTANCED)
	{
		OUT.HPosition = MulMat4x4(ViewProj, float4(OUT.WorldPosition.xyz+vertexoffset, 1.0));
	}
	else
	{
		//world * VP leads to jitter issues(>2000), we use local * WVP instead.
		OUT.HPosition = MulMat4x4(WorldViewProj, float4(INTM.LocalPosition.xyz, 1));
	}
	if (@_NoNearPlaneClip)
	{
		OUT.HPosition.w = max(OUT.HPosition.w, EPSILON);
		OUT.HPosition.z = min(OUT.HPosition.z, (1-OUT.HPosition.w*CameraInfo.z)*OUT.HPosition.w);
	}

	if(@_NoFarPlaneClip)
	{
		OUT.HPosition.z = max(OUT.HPosition.z, EPSILON*OUT.HPosition.w);
		
		//overwrite Fog T
		// OUT.DiffLighting.w = FogTransmittance(normalize(OUT.ViewDirection.xyz) * cFogDistance);
		OUT.DiffLighting.w = FogTransmittance(normalize(OUT.ViewDirection.xyz));
	}

	

}

void InitEmissionUVCommon(in VertexAssemble IN, inout VertexShadingOutput OUT)
{
	//EmissionUV
	OUT.WorldNormal.w = 0;
	OUT.ViewDirection.w = 0;	
	if(@_EmissionMapEnable)
	{
		half2 EmissionUV = IN.TexCoord.xy * cEmissionScrolling.xy + GameTime * cEmissionScrolling.zw;
		OUT.WorldNormal.w = EmissionUV.x;
		OUT.ViewDirection.w = EmissionUV.y;
	}
}

#endif//__FILE_PBR_VS_FXH__


void VS_DIY_OUTPUT(in VertexAssemble IN, in InterMediateVertex INTM, inout VertexShadingOutput OUT)
{
	// 1. init tint color
	InitTintColorCommon(IN, OUT); 

	// 2. for snow height calc
	OUT.WorldPosition.w = IN.Position.y;
	half3 center = half3(0,0,0);
	float3 Viewer = float3(0,0,0);
	float3 yAxis = float3(0,1,0);
	float3 zAxis = float3(0,0,0);
	float3 xAxis = float3(0,0,0);
	float3 normalDir = float3(0,0,0);
	if(@_INSTANCED)
	{	
		OUT.WorldPosition = float4(Matrix4x3TransformP(IN.Transform0, IN.Transform1, IN.Transform2, center), 1);
		normalDir = CameraPos.xyz - OUT.WorldPosition.xyz;
		normalDir.y =0;	
		
		zAxis = normalize(normalDir);
		xAxis = cross(yAxis,zAxis);
		float3 offset = xAxis*INTM.LocalPosition.x+yAxis*INTM.LocalPosition.y+zAxis*INTM.LocalPosition.z;
		float scale = length(Matrix4x3TransformN(IN.Transform0, IN.Transform1, IN.Transform2, float3(1, 0, 0)));
		OUT.WorldPosition.xyz +=offset.xyz*scale ;
	
		}
	else
	///////////////no instance
	{
	Viewer = MulMat3x4( Local, float4(CameraPos.xyz,1) ).xyz;
	normalDir = Viewer-center;
	normalDir.y*=0;
	normalDir = normalize(normalDir);
	float3 upDir = float3(0,1,0);
	float3 rightDir = normalize(cross(upDir,normalDir));
	upDir = normalize(cross(normalDir,rightDir));	

////////////////////////////normal///////////////
	if (@_TANGENT)
	{
		OUT.WorldNormal.xyz = normalize(MulMat3x4((float3x3)World, normalDir));
		OUT.WorldBinormal.xyz =upDir;
		OUT.WorldTangent.xyz = -normalize(cross(OUT.WorldNormal,OUT.WorldBinormal)) ;
	}

		INTM.LocalPosition.xyz = rightDir*INTM.LocalPosition.x+upDir*INTM.LocalPosition.y+normalDir*INTM.LocalPosition.z;
	}
	if(@_INSTANCED)
	{
	
		OUT.WorldNormal.xyz = normalize(normalDir);
	if (@_TANGENT)
	{
		OUT.WorldTangent.xyz = xAxis;
		OUT.WorldBinormal.xyz =float3(0,1,0);
	}
	}

	// 4. hposition calc
	InitHPositionCommon(INTM, OUT); // init hposition calc

//////////////////////UV///////////////////////////////
	// if(@_INSTANCED)
	// {
	// 	// Viewer =   Matrix4x3TransformP(IN.InvTransform0, IN.InvTransform1, IN.InvTransform2, CameraPos.xyz).xyz;
	// 	Viewer =   Matrix4x3TransformP(IN.InvTransform0, IN.InvTransform1, IN.InvTransform2, CameraPos.xyz).xyz;
	// 	Viewer.y =0;
	// 	normalDir =normalize(Viewer.xyz-center.xyz);		
		
	// }
	if(@_INSTANCED)
	{
		// Viewer =   Matrix4x3TransformP(IN.InvTransform0, IN.InvTransform1, IN.InvTransform2, CameraPos.xyz).xyz;
		Viewer =   normalize(Matrix4x3TransformN(IN.Transform0, IN.Transform1, IN.Transform2, INTM.LocalNormal));
		Viewer.y =0;
		normalDir =Viewer;		
		
	}
	
	// half3 uv = normalize(-normalDir);
	// uv.x = uv.z*uv.z;
	// uv.x = ceil(uv.x-0.5);
	

	 
	// half3 uvy =saturate(normalDir);

	// uvy*=uvy;
	// uvy = ceil(uvy-0.5);
	// uv.y = uvy.x+uvy.z ;

	// OUT.TexCoord.xy +=uv.xy*0.5; 
	half3 uv = normalize(-normalDir);
	uv.x = uv.z*uv.z;
	uv.x = ceil(uv.x-0.5);
	

	 
	half3 uvy =saturate(normalDir);

	uvy*=uvy;
	uvy = ceil(uvy-0.5);
	uv.y = uvy.x+uvy.z ;

	OUT.TexCoord.xy +=uv.xy*0.5; 



	//UVoffsets
	// half3 uvNormal =saturate(normalize(normalDir)) ;
	// uvNormal*=uvNormal;
	// uvNormal = ceil(uvNormal-0.5);
	// half3 BiuvNormal =saturate(normalize(-normalDir)) ;
	// BiuvNormal*=BiuvNormal;
	// BiuvNormal = ceil(BiuvNormal-0.5);
	
	
	// half4 UVOffsets = cUVOffsets*0.01;
	// OUT.TexCoord.x+=(-UVOffsets.z *uvNormal.x);
	// OUT.TexCoord.x+=(UVOffsets.y *uvNormal.z);
	// OUT.TexCoord.x+=(UVOffsets.x *BiuvNormal.x);
	// OUT.TexCoord.x+=(UVOffsets.y *BiuvNormal.z);
	
	

	
	
	// OUT.TintColor.xyz= normalize(MulMat3x4((float3x3)Local, normalDir));

	if(@_CastSunShadow && @_TRANSPARENT)
	{
		// for player's shadow		
		OUT.LitUVZ2 = MulMat4x4(ShadowViewProjTexs0, float4(OUT.WorldPosition.xyz + 
		OUT.WorldNormal.xyz * cBiasFarAwayShadow,1));
	}
	
}
#include "PBR_Common.fxh"

//////////////////////////////////PS////////////////////////////////////////
void PS_GetParameters(in VertexShadingOutput IN, out MaterialShadingParameters MaterialParameters)
{
	// 1. init MaterialParameters (always need)
	InitShadingParameters(MaterialParameters);

	InitBaseColorCommon(IN, MaterialParameters);

		half4 samplerMis = tMixMap.Sample(sMixSampler, BaseMapUV(IN.TexCoord));
		half Smoothness = samplerMis.r;
	
		MaterialParameters.CustomData = samplerMis.a;
		MaterialParameters.Thickness = samplerMis.g* 0.1;
		MaterialParameters.AO = samplerMis.b;

	if(@_TANGENT && @_NormalMapEnable)
	{
		half3 tangentNormal = tNormalMap.SampleBias(sNormalSampler, BaseMapUV(IN.TexCoord), cNormalMapBias).xyz;
		[@_DIRECTX]//always use bc5 for pc
		tangentNormal.z = 1;
		
		tangentNormal = (2 * tangentNormal) - 1;
		tangentNormal.xyz*=2;
		
		if (@_LOD_LEVEL == LOD_Level_2)
			tangentNormal.xy *= LOD_RATE;
		//tangentNormal.xy *= cBumpIns;
		MaterialParameters.WorldNormal = tangentNormal.x * IN.WorldTangent + tangentNormal.y * IN.WorldBinormal + tangentNormal.z * IN.WorldNormal.xyz;
		MaterialParameters.WorldNormal = normalize(MaterialParameters.WorldNormal);
		
	
	}
	else
	{
		if (@_LOD_LEVEL <= LOD_Level_2)
			MaterialParameters.WorldNormal = normalize(IN.WorldNormal.xyz);
		else
			MaterialParameters.WorldNormal = IN.WorldNormal.xyz;
	}
	
	// 5. init MaterialParameters.Emission by sample emissinMap (if need or not)
	InitEmission(IN, MaterialParameters);
	
	// if(@_LOD_LEVEL> LOD_Level_1)
	// {
	half3 V = normalize(IN.ViewDirection.xyz);
	half vol = saturate(dot(V,SunDirection) );
	vol*=vol;
	MaterialParameters.Emission += samplerMis.g*MaterialParameters.BaseColor*SunColor.xyz*vol*0.3;

	// }
	InitRadarEffect(IN,MaterialParameters);
	
// if(@_LOD_LEVEL== LOD_Level_0)
// {
// MaterialParameters.BaseColor = half3(0,1,0);

// }
// if(@_LOD_LEVEL== LOD_Level_1)
// {
// MaterialParameters.BaseColor = half3(1,0,0);

// }
// if(@_LOD_LEVEL== LOD_Level_2)
// {
// MaterialParameters.BaseColor = half3(0,0,1);

// }
// if(@_LOD_LEVEL== LOD_Level_3)
// {
// MaterialParameters.BaseColor = half3(0,1,1);

// }

}
//////////////////////////////
////////////////////////////// notice will not be use this
//////////////////////////////
//////////////////////////////
#ifndef __FILE_PBR_FXH__
#define __FILE_PBR_FXH__

#include "ShadingModel.fxh"

#ifndef OPACITY_MASK_VALUE
#define OPACITY_MASK_VALUE(IN,ALPHA) {\
	ALPHA = tBaseMap.SampleRGBA( sBaseSampler, IN.TexCoord ).a;\
}
#endif


#ifndef ENABLE_SCREEN_SHADOWMAP
	#define ENABLE_SCREEN_SHADOWMAP false
#endif
#ifndef ENABLE_HIGHLIGHT
	#define ENABLE_HIGHLIGHT false
#endif
#ifndef ENABLE_BURNT
	#define ENABLE_BURNT false
#endif

#include "Lighting.fxh"


//////////////////////////////////Shading////////////////////////////////////////
VertexShadingOutput PbrVertexShading(in VertexAssemble IN)
{
	VertexShadingOutput OUT;
	InitVertexShadingOutput(OUT);
	//InterMediate
	InterMediateVertex INTM;
	VertexUnifyInterMediate(IN, INTM);
	// VertexUnifySkinning(IN, INTM);
#if IS_HEIGHTMAP
	HEIGHTMAP_MODIFIER(IN, INTM);
#endif

	//OUTPUT
	VertexUnifyOutputCommon(IN, INTM, OUT);

	return OUT;
}

half GetShelterRate(in VertexShadingOutput IN)
{
	if(SAMPLE_SHELTERMAP)
	{
		float2 uv = 1 - (IN.WorldPosition.xz - cSheltermapMinPos.xz) * cSheltermapMaxPos.xz;  
		if (@_GLSL)
			uv.y = 1 - uv.y;
		float depth = tShelterMap.Sample(sShelterSampler, uv).r;
		// feel free to change the code below
		if(depth > 0.99)
			return 1;
		uv = abs(uv - 0.5);
		half rate = min(0.5-uv.x, 0.5-uv.y);
		rate = saturate(rate * 10);
		depth = lerp(cSheltermapMaxPos.y, cSheltermapMinPos.y, depth);
		float curDepth = IN.WorldPosition.y + IN.WorldNormal.y*0.02 + 0.02; // add bias
		half res = saturate(1 + (curDepth - depth));
		return lerp(1, res, rate);
	}
	else
	{
		return 1;
	}
}


float4 PbrPixelShading(in VertexShadingOutput IN, in bool FrontFace : SV_IsFrontFace) : SV_Target
{
	float4 OUT = float4(0, 0, 0, 0);
	//1, Gen MaterialParameters & GBufferData
	MaterialShadingParameters MaterialParameters;
	GBufferData GBuffer;
	PS_GetParameters(IN, MaterialParameters);
	OUT.a = MaterialParameters.Alpha;
#if USE_UNIDIRECTIONAL_DISSOLVE
	if(@_UnidirectionalDissolveEnable){
		float ratio = min((GameTime - cParamter2.y) /  (abs(cParamter2.z) + EPSILON), 1);
		ratio = abs(cParamter2.w - ratio);
		float clipRatio = cParamter2.z > 0 ? (1 - ratio - IN.ModelPositionY/2 ) : (IN.ModelPositionY/2 - ratio );
		OUT.a = (clipRatio < 0) ? 0 : OUT.a;
	}
#endif
// #if USE_ONE_SIDE_LIGHTING
// 	if(!@_OneSideLightingEnable)
// #endif	
// 	{
// 		if(!FrontFace)
// 		MaterialParameters.WorldNormal = -MaterialParameters.WorldNormal;
// 	}

	if (@_TRANSPARENT && @_DISSOLVING)
	{
		OUT.a *= cParamter2.x;
	}	

	MaterialParameters.SpecularColor = 0.08 * MaterialParameters.Specular.xxx;
	MaterialParameters.DiffuseColor = MaterialParameters.BaseColor;
	
	//ShadowAndAO
	half GTAO = 1;
	if(USE_SHADOWMAP_SAMPLE)
	{
		MaterialParameters.InShadow = GetDynamicShadowForSun(IN);

	}else if(ENABLE_SCREEN_SHADOWMAP)
	{
		float2 tc = IN.HPosition.xy * ScreenInfo.zw;
		float2 shadowAndAO = tShadowMask.Sample(sShadowMaskSampler, tc).rg;
		MaterialParameters.InShadow = max(shadowAndAO.x, MaterialParameters.InShadow);
		GTAO = shadowAndAO.y;
	}
	
	//2, lighting
	LightingResult LitResult;
	LitResult.DiffuseLighting = half3(0, 0, 0);
	LitResult.SpecularLighting = half3(0, 0, 0);
	int PBRQualityLevel = PBRQualityLevel_None;
	// if (@_LOD_LEVEL <= LOD_Level_2 && @_EnableReflection || IS_TERRAIN)
	// 	PBRQualityLevel = PBRQualityLevel_Normal;
	half3 V = normalize(-IN.ViewDirection.xyz);
	half NoV = saturate(dot(MaterialParameters.WorldNormal, V));
	MaterialParameters.InShadow =(1-MaterialParameters.CustomData);

	half3 R = reflect(-V, MaterialParameters.WorldNormal);

	//GI lighting
	
	DynamicGILight(MaterialParameters.WorldNormal, MaterialParameters.GILighting, MaterialParameters.InShadow);
	
	//InitIBLReflection(IN, MaterialParameters, V, NoV);
	//set GBuffer
	SetGBufferForShadingModel(GBuffer, MaterialParameters);
	
	//sun lighting
	LightingData LitData = GetSunLightData(V, GBuffer, PBRQualityLevel);
	IntegrateBxDF(LitResult, GBuffer, LitData);	
	//thunder shading
	LitResult.SpecularLighting *= ThunderRate;
	LitResult.DiffuseLighting *= ThunderRate;
	//point lighting calc include vs lighting and ps lighting


	//accumulate specular and diffuse
	OUT.rgb += GBuffer.Emission;//emission without GI lighting
	OUT.rgb += (LitResult.DiffuseLighting + GBuffer.GILighting) * GBuffer.DiffuseColor;

	//3, Fog shading.
	InitFogLighting(IN, LitData, OUT);

	//4, screen color tint


	//always calc in linear space
	EncodeHDR(OUT.rgb);

	//5, bloom scale dependends specular color only and transparent will OUT.rgb * OUT.a
	InitBloomScale( LitResult, MaterialParameters, OUT);
	
	return OUT;
}

// Output patch constant data.
struct HS_CONSTANT_DATA_OUTPUT
{
	float EdgeTessFactor[3]			: SV_TessFactor;
	float InsideTessFactor			: SV_InsideTessFactor;
};

// Patch Constant Function
HS_CONSTANT_DATA_OUTPUT CalcHSPatchConstants(
	InputPatch<VertexShadingOutput, 3> ip,
	uint PatchID : SV_PrimitiveID)
{
	HS_CONSTANT_DATA_OUTPUT Output;

	float4 tessFactors = HS_GetTessellationFactor(ip[0], ip[1], ip[2]);
	Output.EdgeTessFactor[0] = tessFactors.x;
	Output.EdgeTessFactor[1] = tessFactors.y;
	Output.EdgeTessFactor[2] = tessFactors.z;
	Output.InsideTessFactor = tessFactors.w;

	return Output;
}

VertexShadingOutput PbrVertexShading_VS(in VertexAssemble IN)
{
	VertexShadingOutput OUT;

	//InterMediate
	InterMediateVertex INTM;
	VertexUnifyInterMediate(IN, INTM);
	VertexUnifySkinning(IN, INTM);

	//OUTPUT
	VertexUnifyOutputCommon(IN, INTM, OUT);
	return OUT;
}

[domain("tri")]
[partitioning("fractional_odd")]
[outputtopology("triangle_cw")]
[outputcontrolpoints(3)]
[patchconstantfunc("CalcHSPatchConstants")]
VertexShadingOutput PbrVertexShading_HS(
	InputPatch<VertexShadingOutput, 3> ip,
	uint i : SV_OutputControlPointID,
	uint PatchID : SV_PrimitiveID)
{
	return ip[i];
}

[domain("tri")]
VertexShadingOutput PbrVertexShading_DS(
	HS_CONSTANT_DATA_OUTPUT input,
	const OutputPatch<VertexShadingOutput, 3> op,
	float3 domain : SV_DomainLocation)
{

	VertexShadingOutput OUT;
	InitVertexShadingOutput(OUT);
//	[@_HLSL]
//	OUT = (VertexShadingOutput)0;

#define INTERPOLATE(field) OUT.field = op[0].field * domain.x + op[1].field * domain.y + op[2].field * domain.z

	INTERPOLATE(TexCoord);
	INTERPOLATE(WorldPosition);
	INTERPOLATE(WorldNormal);
	INTERPOLATE(ViewDirection.w);
	INTERPOLATE(DiffLighting);

#if !IS_TERRAIN
	if (@_TANGENT)
#endif
	{
		INTERPOLATE(WorldTangent);
		INTERPOLATE(WorldBinormal);
	}

	if (@_CastSunShadow)
	{
		INTERPOLATE(LitUVZ);
	}

	if (@_VERTEXCOLOR)
	{
		INTERPOLATE(TintColor);
	}

	// Phone tessellation
	DS_DIY_OUTPUT(op[0], op[1], op[2], domain, OUT);

	// recalc ViewDirection & HPosition
	OUT.ViewDirection.xyz = OUT.WorldPosition.xyz - CameraPos.xyz;
	OUT.HPosition = MulMat4x4(ViewProj, float4(OUT.WorldPosition.xyz, 1.0));
	
	[@_CastSunShadow]
	OUT.LitUVZ = MulMat4x4(ShadowViewProjTexs1, float4(OUT.WorldPosition.xyz,1));

	return OUT;
}

technique Shading
{
	VertexShader = PbrVertexShading_VS();
#if USE_TESSELLATION
	HullShader = PbrVertexShading_HS();
	DomainShader = PbrVertexShading_DS();
#endif
	PixelShader = PbrPixelShading();
}

#include "GBufferGenPass.fxh"

#include "ShadowGenPass.fxh"

#include "HeightmapGenPass.fxh"

#include "DebugShaderPass.fxh"

#if USE_CLIPPING
#include "ClipPass.fxh"
#endif



#if USE_FROZEN
#include "FrozenPass.fxh"
#endif

#if USE_BURNT
#include "BurntPass.fxh"
#endif

#if USE_HIGHLIGHT
#include "HighlightPass.fxh"
#endif

#if USE_XRAY
#include "XRayPass.fxh"
#endif

#if USE_EDGELINE
#include "EdgeLinePass.fxh"
#endif

#if USE_PLANAR_SHADOW
#include "PlanarShadowPass.fxh"
#endif

#if USE_VBufferGen
#include "VBufferGenPass.fxh"
#endif

#include "EdgeLineNormalGenPass.fxh"

#endif //__FILE_PBR_FXH__
