#pragma shader material

///////////////choice define start///////////////////////////
#define MATERIAL_SHADINGMODEL_FUR			1 // for deferred
#define USE_LIGHTMAP						0
#define USE_LIGHTMAP_CONST					0
#define USE_CLIPPING						1
#define USE_WIREFRAME						1
#define USE_FROZEN							1
#define USE_BURNT							1
#define USE_HIGHLIGHT						1
#define USE_XRAY							1
#define USE_EDGELINE						1
#define USE_PLANAR_SHADOW					0
#define USE_VBufferGen						1
#define VIRTUAL_LIT 						1
#define USE_GRAY                            1
#define USE_ONE_SIDE_LIGHTING				1
#define USE_UNIDIRECTIONAL_DISSOLVE			1
#pragma shader predict("@_TANGENT", "true")
#pragma shader predict("@_CLIPPING", "false")
#pragma shader predict("@_TRANSPARENT", "false")
#pragma shader predict("@_VERTEXCOLOR", "true")
#pragma shader predict("@_INSTANCED", "false")
#pragma shader predict("@_DF_SKIN", "0")
#define HAS_2UV								0
#define ENABLE_MIXMAP						0
#define ENABLE_ANISOTROPIC 					0
#define ENABLE_RIPPLE 						0
#define ENABLE_SCREEN_SHADOWMAP				(@_CSM && @_CastSunShadow && @_LOD_LEVEL <= LOD_Level_2 && !@_TRANSPARENT)
#define ENABLE_HIGHLIGHT					(@_HighlightEnable) // deferred
#define ENABLE_BURNT						0 // deferred
#define USE_SHADOWMAP_SAMPLE				((@_LOD_LEVEL <= LOD_Level_2 && @_CastSunShadow) && (@_TRANSPARENT || (!@_CSM && @_REC_SHADOW)))
#define DEFERRED_PRE_AO						1 // 是否走ao
#define USE_PLAYER_SHADOWMAP				1 // 全是在开csm下有效的
///////////////choice define end//////////////////////////

#include "PBR_Definitions.fxh"
#include "Constants.fxh"
#include "Common.fxh"
//////////////////////////////////Properties////////////////////////////////////////
@_BaseMapEnable 
{ 
	Name = BaseMapEnable;
	Description = "Do we have BaseMap?";  
	AffectedTex = tBaseMap;
	Fallback = true;
	Visible = false;
};
@_EnableDepthBias
{
	Name = EnableDepthBias;
	Description = "Enable Image based lighting?";
	Default = false;
	Visible = false;	
};
@_EnableReflection 
{
	Name = EnableReflection;
	Description = "EnableReflection?";
	AffectedTex = tMixMap;
	Fallback = true;
	Visible = false;
	Default = false;
};
@_OneSideLightingEnable
{
	Name = OneSideLightingEnable;
	Description = "Do we need calc One side lighting?";
	Default = false;
	Visible = true;	
};
@_EnableIBL
{
	Name = EnableIBL;
	Description = "Enable Image based lighting?";
	Default = false;
	Visible = true;	
};
@_NormalMapEnable
{
	Name = NormalMapEnable;
	Description = "Do we have NormalMap?"; 
	AffectedTex = tNormalMap;
	Fallback = "@_TANGENT";
	Visible = false;
};
@_LightMapEnable
{
	Name = LightMapEnable;
	Description = "Do we have LightMap?";
	AffectedTex = tLightMap;
	Fallback = "@_LIGHT_MAP";
	Visible = false;
};
@_EmissionMapEnable
{
	Name = EmissionMapEnable;
	Description = "Do we have EmissionMap?";
	AffectedTex = tEmissionMap; 
	Fallback = true;
	Visible = false;
};
@_AnisotropicEnable
{
	Name = AnisotropicEnable;
	Description = "Do we need calc anisotropic lighting?";
	Visible = true;
};
@_LightmapConstEnable
{
	Name = LightmapConstEnable;
	Default = false;
	Visible = false;
};
@_IsFootprint
{
	Name = IsFootprint;
	Description = "Footprint material has fade out effect";
	Default = false;
	Visible = true;
};
@_HighlightEnable
{
	Name = HighlightEnable;
	Description = "for deferred pipeline change highlight pass";
	Default = false;
};
@_FrozenEnable
{
	Name = FrozenEnable;
	Description = "for deferred pipeline change frozen pass";
	Default = false;
};
@_BurntEnable
{
	Name = BurntEnable;
	Description = "for deferred pipeline change burnt pass";
	Default = false;
};
@_UnidirectionalDissolveEnable
{
	Name = UnidirectionalDissolveEnable;
	Description = "material has unidirectional dissolve effect";
	Visible = true;
	Default = false;
};
//////////////////////////////////Constant buffer////////////////////////////////////////
cbuffer Shader
{
	float3 cBaseColor 				 < Widget = "LinearColor3"; > = {1, 1, 1};
	float cMetallic					 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; > = 0;	//金属度[0:1] 

	float cAliasingFactor			 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; > = 0.2;//抗锯齿因子
	float cEnvStrength				 < Widget = "FloatSlider"; Min = "0"; Max = "10"; Step = "0.01"; Precision = "2"; > = 1;	//环境强度[0:8]
	float cRoughnessLow				 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; > = 0;	//粗糙度下界
	float cRoughnessHigh			 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; > = 1;	//粗糙度上界
	
	float4 cLightMapScale			 = {1, 1, 1, 1};
	float4 cLightMapUVTransform		 = {1, 1, 0, 0};

	float  cSmoothness				 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; > = 0;
	float  cBloomScale				 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; > = 0.5;
	float  cBaseMapBias				 < Widget = "FloatSlider"; Min = "-2"; Max = "2"; Step = "0.01"; Precision = "2"; > = -1;
	float  cNormalMapBias			 < Widget = "FloatSlider"; Min = "-2"; Max = "2"; Step = "0.01"; Precision = "2"; > = -0.5;

	float4 cEmissionScale			 = {1, 1, 1, 0};
	float4 cEmissionScrolling		 = {1, 1, 0, 0};

	float cRoughnessX				 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.001"; Precision = "2"; > = 0.1;
	float cRoughnessY				 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.001"; Precision = "2"; > = 1;
	float cAnisotropicScale			 < Widget = "FloatSlider"; Min = "0"; Max = "10"; Step = "0.01"; Precision = "2"; > = 0;
	float cFogDistance				 < Widget = "FloatSlider"; Min = "0"; Max = "1000"; Step = "0.1"; Precision = "2"; > = 100;

	float cBumpIns      			 < Widget = "FloatSlider"; Min = "0"; Max = "10"; Step = "0.1"; Precision = "2"; > = 1;
	float cAlpha	      			 < Widget = "FloatSlider"; Min = "0"; Max = "10"; Step = "0.1"; Precision = "2"; > = 1.0;
	float cDepthOffset     			 < Widget = "FloatSlider"; Min = "-20"; Max = "20"; Step = "0.1"; Precision = "2"; > = 0;
	float cDepthBias	  			 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.1"; Precision = "2"; > = 0;
	float cSnowHeight	  			 < Widget = "FloatSlider"; Min = "-2"; Max = "2"; Step = "0.1"; Precision = "2"; > = 0.6;
	float cSnowDetail	  			 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.1"; Precision = "2"; > = 1;
	float cBiasFarAwayShadow		 < Widget = "FloatSlider"; Min = "0"; Max = "10"; Step = "0.1"; Precision = "3"; > = 0.01;
	float cSaturation				 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.1"; Precision = "2"; > = 1;
	float cFuzzSpecIns				 < Widget = "FloatSlider"; Min = "0"; Max = "10"; Step = "0.1"; Precision = "2"; > = 3;
	float cLightFilter				 < Widget = "FloatSlider"; Min = "-0.5"; Max = "0.5"; Step = "0.001"; Precision = "2"; > = 0;
	float cNoise1Scale                = 1;
	float cNoise2Scale                = 1;
	float cBaseMapScale               = 1;
	float cNoise2Bias                < Widget = "FloatSlider"; Min = "0"; Max = "2"; Step = "0.01"; Precision = "2"; > = 1;
	float cSilkSpecRange	  		 < Widget = "FloatSlider"; Min = "0.01"; Max = "10"; Step = "0.01"; Precision = "2"; > = 0.5;
	float cSilkSpecIns 				 < Widget = "FloatSlider"; Min = "0"; Max = "10"; Step = "0.1"; Precision = "2"; > = 1;
	float cSilkSpecShift  			 < Widget = "FloatSlider"; Min = "-2"; Max = "2"; Step = "0.1"; Precision = "2"; > = 0;

};

//////////////////////////////////Input Texture////////////////////////////////////////
texture2D tBaseMap : layout(t0) = "White";
sampler sBaseSampler : layout(s0)
{
	Texture = tBaseMap;
	Filter = Linear;
	Address = FromTexture;
	SRGB = false;
};

texture2D tEnvMap : EnvMap : layout(t2) = "White";
sampler sEnvSampler : layout(s2)
{
	Texture = tEnvMap;
	Filter = Linear;
	Address = Clamp;
	SRGB = false; 
};

texture2D tNormalMap : layout(t3) = "NormalMap";
sampler sNormalSampler : layout(s3)
{
	Texture = tNormalMap;
	Filter = Linear;
	Address = Wrap;
	SRGB = false;
};

// Light map
texture2D tLightMap : layout(t4);
sampler sLightMapSampler : layout(s4)
{
	Texture = tLightMap;
	Filter = Linear;
	Address = Clamp;
	SRGB = false;
	MaxMipLevel = 0;
};

texture2D tShadowMask : ShadowMask : layout(t5) = "White";
sampler sShadowMaskSampler : layout(s5)
{
	Texture = tShadowMask; 
	Filter = Point; 
	Address = Clamp;
	SRGB = false;
	MaxMipLevel = 0;
};
// ShadowMap 
texture2D tShadowMap : ShadowMap : layout(t6) = "White";
SamplerComparisonState sShadowMapSampler : layout(s6)
{
	Texture = tShadowMap;
	Filter = Linear;
	Address = Clamp;
	ComparisonFunc = Greater;
	SRGB = false;
	MaxMipLevel = 0;
};

// Emission map
texture2D tEmissionMap : layout(t7) = "Transparent";
sampler sEmissionMapSampler : layout(s7)
{
	Texture = tEmissionMap;
	Filter = Linear; 
	Address = Wrap;
	SRGB = false;
};

texture2D tRainMap : RainMap: layout(t8) = "NormalMap";
sampler sRainSampler : layout(s8)
{
	Texture = tRainMap;
	Filter = Linear;
	Address = Wrap;
	SRGB = false;
};

texture2D tShelterMap: ShelterMap : layout(t9) = "Black";
sampler ShelterMap_Sampler : layout(s9)
{
	Texture = tShelterMap;
	Filter = Linear;
	Address = Clamp;
	SRGB = false;
};

texture2D tSkeletonMap : SkeletonMap : layout(t3) = "Black";
sampler sSkeletonSampler : layout(s3)
{
	Texture = tSkeletonMap;
	Filter = Point;
	Address = Clamp;
	SRGB = false;
};

texture2D tNoiseMap : layout(t10) = "White";
sampler sNoiseSampler : layout(s10)
{
	Texture = tNoiseMap;
	Filter = Linear;
	Address = Wrap;
	SRGB = false;
};

//////////////////////////////////Function////////////////////////////////////////
half3 ShiftTangent(in half3 T,in half3 N,in half shift )
{  
	half3 shiftedT = T + shift * N ;
	return normalize(shiftedT);
}
half StrandSpecuar(in half HoT, in half exponent)
{
	half sinTH = 1.0 - HoT*HoT;
	half dirAtten = smoothstep(-1.0, 0.0, HoT);

	return dirAtten * pow(sinTH, exponent);
}
#include "PBR_VS.fxh"
//////////////////////////////////VS////////////////////////////////////////
void VS_DIY_OUTPUT(in VertexAssemble IN, in InterMediateVertex INTM, inout VertexShadingOutput OUT)
{
	OUT.TintColor = float4(0,0,0,0);
	// 1. init tint color
	[@_VERTEXCOLOR]
	OUT.TintColor = GetVertexColor(IN.Color);

	// 2. for snow height calc
	OUT.WorldPosition.w = IN.Position.y;

	// 4. hposition calc
	InitHPositionCommon(INTM, OUT); // init hposition calc


}
#include "PBR_Common.fxh"
//////////////////////////////////PS////////////////////////////////////////
void PS_GetParameters(in VertexShadingOutput IN, out MaterialShadingParameters MaterialParameters)
{
	// 1. init MaterialParameters (always need)
	InitShadingParameters(MaterialParameters);
	InitRainOcclusion(IN, MaterialParameters);

	// 2. init MaterialParameters.BaseColor and MaterialParameters.Alpha by sample basemap
	half Occlusion = (1-IN.TintColor.a * IN.TintColor.a) + 0.04;
	if(@_BaseMapEnable)
	{
		half4 samplerBase;
		samplerBase = tBaseMap.SampleBias(sBaseSampler, BaseMapUV(IN.TexCoord) * cBaseMapScale, cBaseMapBias);
		MaterialParameters.BaseColor = DecodeGamma(samplerBase.rgb) * Occlusion * cBaseColor;
	}
	else
	{
		MaterialParameters.BaseColor = cBaseColor * Occlusion;
	}

	half4 samplerNoise1;
	samplerNoise1 = tNoiseMap.SampleBias(sNoiseSampler, BaseMapUV(IN.TexCoord) * cNoise1Scale, cBaseMapBias);
	half4 samplerNoise2;
	samplerNoise2 = tNoiseMap.SampleBias(sNoiseSampler, BaseMapUV(IN.TexCoord) * cNoise2Scale, cBaseMapBias);
	half Noise2Alpha = pow(IN.TintColor.a , cNoise2Bias);
	MaterialParameters.Alpha = (IN.TintColor.a > samplerNoise1.r ? 1 : 0) * (Noise2Alpha > samplerNoise2.r ? 1 : 0);
	clip(MaterialParameters.Alpha - 0.5);

	// 3. init smoothness/metal/ao by sample mixmap
	half JitterMask = saturate(max(saturate(sqrt(samplerNoise1.r) - IN.TintColor.a) , saturate(sqrt(samplerNoise2.r) - Noise2Alpha))*2) * Occlusion;
	MaterialParameters.Metallic = cMetallic;
	MaterialParameters.Roughness = lerp(cRoughnessHigh, cRoughnessLow, cSmoothness);
	MaterialParameters.CustomData.r = Occlusion;
	MaterialParameters.CustomData.g = cFuzzSpecIns * 0.1;
	MaterialParameters.CustomData.b = cLightFilter + 0.5;
	MaterialParameters.Specular *= JitterMask;

	// 4. init MaterialParameters.WorldNormal by sample normalmap
	InitWorldNormal(IN, MaterialParameters);

	[@_TANGENT]
	{
	float3 L = SunDirection.xyz;
	float3 V = normalize( -IN.ViewDirection.xyz );
	float3 H = normalize(L + V);
	half3 T = -normalize(cross(IN.WorldTangent.xyz, MaterialParameters.WorldNormal));
	half3 t1 = ShiftTangent(T, MaterialParameters.WorldNormal, JitterMask + cSilkSpecShift);
	half silkSpec = StrandSpecuar(dot(H, t1), cSilkSpecRange * 100);
	MaterialParameters.CustomData.a = saturate(silkSpec) * cSilkSpecIns * 0.1;
	}

	// 8. Apply Weather
	InitRain(IN, MaterialParameters);

}
#include "PBR_PS.fxh"

#if SD_ENABLE_VXGI
#include "VXGI/VXGIVoxelize.fxh"
#endif

