#pragma shader material

///////////////choice define start///////////////////////////
#define MATERIAL_SHADINGMODEL_DEFAULT_LIT 	1 // for deferred
#define USE_LIGHTMAP						1
#define USE_LIGHTMAP_CONST					1
#define USE_CLIPPING						1
#define USE_WIREFRAME						1
#define USE_FROZEN							1
#define USE_BURNT							1
#define USE_HIGHLIGHT						1
#define USE_XRAY							1
#define USE_EDGELINE						1
#define USE_PLANAR_SHADOW					0
#define USE_VBufferGen						1
#define VIRTUAL_LIT 						1
#pragma shader predict("@_TANGENT", "true")
#pragma shader predict("@_CLIPPING", "false")
#pragma shader predict("@_TRANSPARENT", "false")
// #pragma shader predict("@_VERTEXCOLOR", "true")
#pragma shader predict("@_INSTANCED", "false")
// #pragma shader predict("@_DF_SKIN", "0")

#define HAS_2UV								(@_LIGHT_MAP)
#define ENABLE_MIXMAP						(@_EnableReflection)
#define ENABLE_ANISOTROPIC 					(@_AnisotropicEnable)
#define ENABLE_RIPPLE 						(@_RIPPLE)
#define ENABLE_SCREEN_SHADOWMAP				(@_ReceiveShadow && @_CSM && @_CastSunShadow && @_LOD_LEVEL <= LOD_Level_2 && !@_TRANSPARENT)
#define ENABLE_HIGHLIGHT					(@_HighlightEnable) // deferred
#define ENABLE_BURNT						(@_BurntEnable) // deferred
#define USE_SHADOWMAP_SAMPLE				((@_LOD_LEVEL <= LOD_Level_2 && @_CastSunShadow) && (@_TRANSPARENT || (!@_CSM && @_REC_SHADOW)))
#define DEFERRED_PRE_AO						1 // 是否走ao
#define USE_PLAYER_SHADOWMAP				1 // 全是在开csm下有效的
///////////////choice define end//////////////////////////

#include "PBR_Definitions.fxh"
#include "Constants.fxh"
#include "Common.fxh"
//////////////////////////////////Properties////////////////////////////////////////
@_BaseMapEnable 
{ 
	Name = BaseMapEnable;
	Description = "Do we have BaseMap?";  
	AffectedTex = tBaseMap;
	Fallback = true;
	Visible = false;
};
@_EnableReflection 
{
	Name = EnableReflection;
	Description = "EnableReflection?";
	AffectedTex = tMixMap;
	Fallback = true;
	Visible = false;
	Default = false;
};
@_EnableIBL
{
	Name = EnableIBL;
	Description = "Enable Image based lighting?";
	Default = true;
	Visible = true;	
};
@_EnableDepthBias
{
	Name = EnableDepthBias;
	Description = "Enable Image based lighting?";
	Default = false;
	Visible = false;
	
};
@_NormalMapEnable
{
	Name = NormalMapEnable;
	Description = "Do we have NormalMap?"; 
	AffectedTex = tNormalMap;
	Fallback = "@_TANGENT";
	Visible = false;
};
@_LightMapEnable
{
	Name = LightMapEnable;
	Description = "Do we have LightMap?";
	AffectedTex = tLightMap;
	Fallback = "@_LIGHT_MAP";
	Visible = false;
};
@_EmissionMapEnable
{
	Name = EmissionMapEnable;
	Description = "Do we have EmissionMap?";
	AffectedTex = tEmissionMap; 
	Fallback = true;
	Visible = false;
};
@_AnisotropicEnable
{
	Name = AnisotropicEnable;
	Description = "Do we need calc anisotropic lighting?";
	Visible = false;
	Predict = false;
};
@_LightmapConstEnable
{
	Name = LightmapConstEnable;
	Default = false;
	Visible = false;
	Predict = false;
};
@_IsFootprint
{
	Name = IsFootprint;
	Description = "Footprint material has fade out effect";
	Default = false;
	Visible = false;
	Predict = false;
};
@_HighlightEnable
{
	Name = HighlightEnable;
	Description = "for deferred pipeline change highlight pass";
	Default = false;
	Predict = false;
};
@_FrozenEnable
{
	Name = FrozenEnable;
	Description = "for deferred pipeline change frozen pass";
	Default = false;
	Visible = false;
	Predict = false;
};
@_BurntEnable
{
	Name = BurntEnable;
	Description = "for deferred pipeline change burnt pass";
	Default = false;
	Visible = false;
	Predict = false;
};
@_WeaponHighLight
{
	Name = WeaponHighLight;
	Description = "for WeaponHighlight";
	Default = false;
	Visible = false;
};
@_WeaponPreview
{
	Name = WeaponPreview;
	Description = "for WeaponPreview";
	Default = false;
	Visible = false;
};
@_GrayEffect
{
	Name = GrayingIn;
	Description = "for Graying";
	Visible = true;
	Default = false;
	Predict = false;
};
@_ReceiveShadow
{
	Name = ReceiveShadow;
	Description = "for WeaponPreview";
	Default = true;
	Visible = false;
};
@_DamagedDetail
{
	Name = DamagedDetail;
	Description = "for DamagedDetail";
	Default = true;
	Visible = false;
};
@_WeaponSkin
{
	Name = WeaponSkin;
	Description = "for WeaponSkin";
	Default = false;
	Visible = true;
};
// @_FXWeaponSkin
// {
// 	Name = WeaponSkin;
// 	Description = "for FXWeaponSkin";
// 	AffectedTex = tWeaponFXMap;
// 	Default = false;
// 	Visible = false;
	
// };
//////////////////////////////////Constant buffer////////////////////////////////////////
cbuffer Shader
{
	float3 cBaseColor 				 < Widget = "LinearColor3";Visible = "0"; > = {1, 1, 1};
	float cMetallic					 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2";Visible = "0"; > = 0;	//金属度[0:1] 

	float cAliasingFactor			 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; Visible = "0";> = 0.2;//抗锯齿因子
	float cEnvStrength				 < Widget = "FloatSlider"; Min = "0"; Max = "10"; Step = "0.01"; Precision = "2";Visible = "0"; > = 1;	//环境强度[0:8]
	float cRoughnessLow				 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; Visible = "0";> = 0;	//粗糙度下界
	float cRoughnessHigh			 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; Visible = "0";> = 1;	//粗糙度上界
	
	float4 cLightMapScale			 < Visible = "0"; > = {1, 1, 1, 1};
	float4 cLightMapUVTransform		 < Visible = "0"; > = {1, 1, 0, 0};

	float  cSmoothness				 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; Visible = "0";> = 0;
	float  cBloomScale				 < Widget = "FloatSlider"; Min = "0"; Max = "100"; Step = "0.01"; Precision = "2"; Visible = "0";> = 80;
	float  cBaseMapBias				 < Widget = "FloatSlider"; Min = "-2"; Max = "2"; Step = "0.01"; Precision = "2";Visible = "0"; > = -1;
	float  cNormalMapBias			 < Widget = "FloatSlider"; Min = "-2"; Max = "2"; Step = "0.01"; Precision = "2"; Visible = "0";> = -0.5;

	float4 cEmissionScale			 < Visible = "1"; > = {1, 1, 1, 0};
	float4 cEmissionScrolling		 < Visible = "0"; > = {1, 1, 0, 0};

	float cRoughnessX				 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.001"; Precision = "2"; Visible = "0";> = 0.1;
	float cRoughnessY				 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.001"; Precision = "2"; Visible = "0";> = 1;
	float cAnisotropicScale			 < Widget = "FloatSlider"; Min = "0"; Max = "10"; Step = "0.01"; Precision = "2";Visible = "0"; > = 0;
	float cFogDistance				 < Widget = "FloatSlider"; Min = "0"; Max = "1000"; Step = "0.1"; Precision = "2";Visible = "0"; > = 100;

	float cBumpIns      			 < Widget = "FloatSlider"; Min = "0"; Max = "10"; Step = "0.1"; Precision = "2";Visible = "0"; > = 1;
	float cAlpha	      			 < Widget = "FloatSlider"; Min = "0"; Max = "10"; Step = "0.1"; Precision = "2"; Visible = "0";> = 1.0;
	float cDepthOffset     			 < Widget = "FloatSlider"; Min = "-20"; Max = "20"; Step = "0.1"; Precision = "2";Visible = "0"; > = 0;
	float cDepthBias	  			 < Widget = "FloatSlider"; Min = "-1"; Max = "1"; Step = "0.1"; Precision = "2"; Visible = "0";> = 0;
	float cSnowHeight	  			 < Widget = "FloatSlider"; Min = "-2"; Max = "2"; Step = "0.1"; Precision = "2";Visible = "0"; > = 0.6;
	float cSnowDetail	  			 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.1"; Precision = "2"; Visible = "0";> = 1;
	float cBiasFarAwayShadow		 < Widget = "FloatSlider"; Min = "0"; Max = "10"; Step = "0.1"; Precision = "3"; Visible = "0";> = 0.01;
	float cWeaponAnimation			 < Visible = "0"; > = 0;
	float3 cWeaponHighLightColor	  < Widget = "LinearColor3";Visible = "0"; > = {1, 1, 1};
	float cScrash					 < Widget = "FloatSlider"; Min = "0.2"; Max = "1.0"; Step = "0.1"; Precision = "3"; Visible = "0";> = 1.00;
	float cNormalUVScale			 < Widget = "FloatSlider"; Min = "10"; Max = "15"; Step = "0.1"; Precision = "3"; > = 0.01;	
	float cDetailUVScale			 < Widget = "FloatSlider"; Min = "3"; Max = "5"; Step = "0.1"; Precision = "3"; > = 0.01;	
	float cDamgeRate				 < Widget = "FloatSlider"; Min = "0.01"; Max = "0.9"; Step = "0.1"; Precision = "3"; Visible = "0";> = 0;
	float cRub						 < Widget = "FloatSlider"; Min = "0.0"; Max = "1.0"; Step = "0.1"; Precision = "3"; Visible = "0";> = 1.0;
	float cFov						 < Widget = "FloatSlider"; Min = "0"; Max = "5"; Step = "0.1"; Precision = "2";Visible = "0"; > = 1;
	float cRoll						 < Widget = "FloatSlider"; Min = "-2"; Max = "4"; Step = "0.1"; Precision = "2";Visible = "1"; > = 1;
	float cGrayingin				< Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.1"; Precision = "2"; > = 0;
	
};

//////////////////////////////////Input Texture////////////////////////////////////////
texture2D tBaseMap : layout(t0) = "White";
sampler sBaseSampler : layout(s0)
{
	Texture = tBaseMap;
	Filter = Linear;
	Address = FromTexture;
	SRGB = false;
};

texture2D tMixMap : layout(t1) = "Reflection";
sampler sMixSampler : layout(s1)
{
	Texture = tMixMap;
	Filter = Linear;
	Address = Wrap;
	SRGB = false;
};

texture2D tEnvMap : EnvMap : layout(t2) = "White";
sampler sEnvSampler : layout(s2)
{
	Texture = tEnvMap;
	Filter = Linear;
	Address = Clamp;
	SRGB = false; 
};

texture2D tNormalMap : layout(t3) = "NormalMap";
sampler sNormalSampler : layout(s3)
{
	Texture = tNormalMap;
	Filter = Linear;
	Address = Wrap;
	SRGB = false;
};

// Light map
texture2D tLightMap : layout(t4);
sampler sLightMapSampler : layout(s4)
{
	Texture = tLightMap;
	Filter = Linear;
	Address = Clamp;
	SRGB = false;
	MaxMipLevel = 0;
};

texture2D tShadowMask : ShadowMask : layout(t5) = "White";
sampler sShadowMaskSampler : layout(s5)
{
	Texture = tShadowMask; 
	Filter = Point; 
	Address = Clamp;
	SRGB = false;
	MaxMipLevel = 0;
};
// ShadowMap 
texture2D tShadowMap : ShadowMap : layout(t6) = "White";
SamplerComparisonState sShadowMapSampler : layout(s6)
{
	Texture = tShadowMap;
	Filter = Linear;
	Address = Clamp;
	ComparisonFunc = Greater;
	SRGB = false;
	MaxMipLevel = 0;
};


// Emission map
texture2D tEmissionMap : layout(t7) = "Transparent";
sampler sEmissionMapSampler : layout(s7)
{
	Texture = tEmissionMap;
	Filter = Linear; 
	Address = Wrap;
	SRGB = false;
};

texture2D tRainMap : RainMap: layout(t8) = "NormalMap";
sampler sRainSampler : layout(s8)
{
	Texture = tRainMap;
	Filter = Linear;
	Address = Wrap;
	SRGB = false;
};
texture2D tBlendMap : layout(t9) = "NormalMap";
sampler sBlendSampler : layout(s9)
{
	Texture = tBlendMap;
	Filter = Linear;
	Address = Wrap;
	SRGB = false;
};
texture2D tBlendNormalMap : layout(t10) = "NormalMap";
sampler sBlendNormalSampler : layout(s10)
{
	Texture = tBlendNormalMap;
	Filter = Linear;
	Address = Wrap;
	SRGB = false;
};

texture2D tSkeletonMap : SkeletonMap : layout(t3) = "Black";
sampler sSkeletonSampler : layout(s3)
{
	Texture = tSkeletonMap;
	Filter = Point;
	Address = Clamp;
	SRGB = false;
};
texture2D tGTAOMap : GIMap : layout(t5) = "White";
sampler sGTAOSampler : layout(s5)
{
	Texture = tGTAOMap;
	Filter = Point;
	Address = Clamp;
	SRGB = false;
};
texture2D tWeaponSkinMap : layout(t11) = "White";
sampler sWeaponSkinMapSampler : layout(s11)
{
	Texture = tWeaponSkinMap;
	Filter = Linear;
	Address = FromTexture;
	SRGB = false;
};
texture2D tWeaponFXMap : layout(t12) = "White";
sampler sWeaponFXMapSampler : layout(s12)
{
	Texture = tWeaponFXMap;
	Filter = Linear;
	Address = FromTexture;
	SRGB = false;
};

#include "PBR_VS.fxh"
//////////////////////////////////VS////////////////////////////////////////
void VS_DIY_OUTPUT(in VertexAssemble IN, in InterMediateVertex INTM, inout VertexShadingOutput OUT)
{
	[@_UV3UV4]
	OUT.MultiUVs = IN.TexCoord3;

	// 1. init tint color
	InitTintColorCommon(IN, OUT); 

	// 2. for snow height calc
	OUT.WorldPosition.w = IN.Position.y;

	// 3. init emmision uv; if not need emmision uv
	InitEmissionUVCommon(IN, OUT);

	// 4. hposition calc
	InitHPositionCommon(INTM, OUT); // init hposition calc
		
	InitDepthCommon(INTM,OUT);
	
	if(@_CastSunShadow && @_TRANSPARENT)
	{
		// for player's shadow		
		OUT.LitUVZ2 = MulMat4x4(ShadowViewProjTexs0, float4(OUT.WorldPosition.xyz + 
		OUT.WorldNormal.xyz * cBiasFarAwayShadow,1));
	}

}

#include "PBR_Common.fxh"
//////////////////////////////////PS////////////////////////////////////////
void PS_GetParameters(in VertexShadingOutput IN, out MaterialShadingParameters MaterialParameters)
{
	// 1. init MaterialParameters (always need)
	InitShadingParameters(MaterialParameters);

	// 2. init MaterialParameters.BaseColor and MaterialParameters.Alpha by sample basemap
	InitSmoothnessMetalAO(IN, MaterialParameters);

	half4 samplerBase;
	samplerBase = tBaseMap.SampleBias(sBaseSampler, BaseMapUV(IN.TexCoord), cBaseMapBias);
	if(@_WeaponSkin)
	{	
		float4 WeaponSkinColor = float4(0,0,0,0);
		float2 FlowUV = float2(0,0);
		if(@_UV3UV4)
		{
			FlowUV = IN.MultiUVs.xy;
			FlowUV.x -= GameTime * 0.5;
			float3 Flow = tWeaponFXMap.Sample(sWeaponFXMapSampler,FlowUV).rgb;
			// FlowColor =	lerp(FlowColor, dot(FlowColor, float3(0.3,0.59,0.11)), 1) ;
			//float3 WeaponSkinColor = tWeaponSkinMap.Sample(sWeaponSkinMapSampler, BaseMapUV(IN.TexCoord)).rgb;
			//FlowColor *= WeaponSkinColor;
			
			WeaponSkinColor = tWeaponSkinMap.Sample(sWeaponSkinMapSampler, BaseMapUV(IN.MultiUVs.xy) + FlowUV.xy * 0.15 + Flow.xy * 0.05);
		}
		else
		{
			 WeaponSkinColor = tWeaponSkinMap.Sample(sWeaponSkinMapSampler, BaseMapUV(IN.TexCoord));
		}

		float Skinmask = tMixMap.Sample(sMixSampler, BaseMapUV(IN.TexCoord)).a;

		MaterialParameters.BaseColor = DecodeGamma(lerp(samplerBase.rgb,WeaponSkinColor.rgb,0.85  * Skinmask));

		float skindamage = saturate(pow(samplerBase.a,5));
		MaterialParameters.BaseColor = lerp(MaterialParameters.BaseColor,samplerBase.rgb,skindamage);

		MaterialParameters.Metallic = lerp(MaterialParameters.Metallic,0.9,0.85 * Skinmask );

		MaterialParameters.Roughness = lerp(MaterialParameters.Roughness,pow(MaterialParameters.Roughness,1.5)*1.5,0.85 * Skinmask);
	}
	else
	{
		MaterialParameters.BaseColor = DecodeGamma(samplerBase.rgb);
	}


	// MaterialParameters.BaseColor = saturate(samplerBase.a - 0.5);

	half2 BlendUVScale = IN.TexCoord.xy * cNormalUVScale;

	if(@_DamagedDetail && @_LOD_LEVEL <= LOD_Level_2)
		{
			half2 DetialUVScale = IN.TexCoord.xy* 1.;//cDetailUVScale
			half4 blendColor = tBlendMap.SampleBias(sBlendSampler, DetialUVScale, cBaseMapBias);
			blendColor*=MaterialParameters.AO;
			float scrash =saturate(samplerBase.a *samplerBase.a*MaterialParameters.AO *blendColor.r*2*0.75) ;//cScrash
			// blendColor.rgb = lerp (blendColor.rgb,1,samplerBase.a);
			float damage = samplerBase.a*2-1; 
			damage =floor(damage*blendColor.b*30*IN.TintColor.b*0.0); //cDamgeRate
			float rub = (blendColor.g*samplerBase.a*samplerBase.a*IN.TintColor.b) ;
			rub*=rub*5*0.3;//cRub

			damage= saturate(damage+rub);

			MaterialParameters.Roughness = saturate(lerp(MaterialParameters.Roughness ,0.5, damage)-scrash)  ;
			MaterialParameters.Metallic =lerp( MaterialParameters.Metallic,1, damage);
			MaterialParameters.BaseColor =lerp(MaterialParameters.BaseColor-scrash*0.05,half3(0.3,0.3,0.3),pow(damage,1.8));
		}
		// footprint fade out effect
	if (@_IsFootprint && @_INSTANCED)
	{
		MaterialParameters.Alpha *= saturate((IN.LightMapScale.x - GameTime) / IN.LightMapScale.y);
	}
	
	// 3. init smoothness/metal/ao by sample mixmap
	

	// BlendUVScale *=(1/(1-MaterialParameters.Roughness));
	
	
	
	if(@_TANGENT && @_NormalMapEnable && @_LOD_LEVEL <= LOD_Level_2)
	{
		
		half3 tangentNormal = tNormalMap.SampleBias(sNormalSampler, BaseMapUV(IN.TexCoord), cNormalMapBias).xyz;
		[@_DIRECTX]//always use bc5 for pc
		tangentNormal.z = 1;
		tangentNormal = (2 * tangentNormal) - 1;

		if(@_DamagedDetail)
		{
			half3 blendNormal =tBlendNormalMap.SampleBias(sBlendNormalSampler, BlendUVScale, cNormalMapBias).xyz;
			blendNormal =  (2 * blendNormal) - 1;

			blendNormal = lerp(blendNormal,half3(0,0,1),saturate( 1-MaterialParameters.Roughness*MaterialParameters.Roughness +MaterialParameters.Metallic*MaterialParameters.Metallic));
			tangentNormal  = BlendAngleCorrectedNormal(tangentNormal,blendNormal);
		}
		if (ENABLE_RIPPLE)
		{
			Ripple(IN, MaterialParameters, tangentNormal, 1);
		}
		if (@_LOD_LEVEL == LOD_Level_1)
			tangentNormal.xy *= LOD_RATE;
		//tangentNormal.xy *= cBumpIns;
		MaterialParameters.WorldNormal = tangentNormal.x * IN.WorldTangent + tangentNormal.y * IN.WorldBinormal + tangentNormal.z * IN.WorldNormal.xyz;
		MaterialParameters.WorldNormal = normalize(MaterialParameters.WorldNormal);
		
	}
	else
	{
		if (@_LOD_LEVEL <= LOD_Level_2)
			MaterialParameters.WorldNormal = normalize(IN.WorldNormal.xyz);
		else
			MaterialParameters.WorldNormal = IN.WorldNormal.xyz;
	}
	

	// 5. init MaterialParameters.Emission by sample emissinMap (if need or not)
	InitEmission(IN, MaterialParameters);
	InitWeaponHighlight(IN,MaterialParameters);
	//InitWeaponPreview(IN,MaterialParameters);
	// }

	// 6. init anisotropic by use cRoughnessX/cRoughnessY/cAnisotropicScale (if need or not)
	InitAnisotropic(IN, MaterialParameters);
	InitRain(IN, MaterialParameters);

	//GrayingEffect
	InitGrayEffect(cGrayingin,MaterialParameters);

	//InitFlowWeaponEffect(IN, MaterialParameters);
}
#include "PBR_PS.fxh"


