#pragma shader material

///////////////choice define start///////////////////////////
#define MATERIAL_SHADINGMODEL_HAIR 			1 // for deferred
#define USE_LIGHTMAP						0
#define USE_LIGHTMAP_CONST					0
#define USE_CLIPPING						1
#define USE_WIREFRAME						1
#define USE_FROZEN							1
#define USE_BURNT							1
#define USE_HIGHLIGHT						1
#define USE_XRAY							1
#define USE_EDGELINE						1
#define USE_PLANAR_SHADOW					0
#define USE_VBufferGen						1
#define VIRTUAL_LIT 						0
#define USE_GRAY                            1
#define USE_PLAYER_SHADOWMAP				1
#define DEFERRED_PRE_AO						1 // 是否走ao
#define USE_UNIDIRECTIONAL_DISSOLVE			1
#pragma shader predict("@_TANGENT", "true")
#pragma shader predict("@_CLIPPING", "false")
#pragma shader predict("@_TRANSPARENT", "false")
#pragma shader predict("@_VERTEXCOLOR", "true")
#pragma shader predict("@_INSTANCED", "false")
#pragma shader predict("@_DF_SKIN", "0")
#define USE_ONE_SIDE_LIGHTING				1
#define HAS_2UV								(@_LIGHT_MAP)
#define ENABLE_MIXMAP						(@_EnableReflection)
#define ENABLE_ANISOTROPIC 					0
#define ENABLE_RIPPLE 						0
#define ENABLE_SCREEN_SHADOWMAP				(@_CSM && @_CastSunShadow && @_LOD_LEVEL <= LOD_Level_2 && !@_TRANSPARENT)
#define USE_SHADOWMAP_SAMPLE				((@_LOD_LEVEL <= LOD_Level_2 && @_CastSunShadow) && (@_TRANSPARENT || (!@_CSM && @_REC_SHADOW)))
#define ENABLE_HIGHLIGHT					(@_HighlightEnable) // deferred
#define ENABLE_BURNT						(@_BurntEnable) // deferred
///////////////choice define end//////////////////////////

#include "PBR_Definitions.fxh"
#include "Constants.fxh"
#include "Common.fxh"
#include "BRDF.fxh"
//////////////////////////////////Properties////////////////////////////////////////
@_BaseMapEnable 
{ 
	Name = BaseMapEnable;
	Description = "Do we have BaseMap?";  
	AffectedTex = tBaseMap;
	Fallback = true;
	Visible = false;
};
@_EnableReflection 
{
	Name = EnableReflection;
	Description = "EnableReflection?";
	AffectedTex = tMixMap;
	Fallback = true;
	Visible = false;
	Default = true;
};
@_OneSideLightingEnable
{
	Name = OneSideLightingEnable;
	Description = "Do we need calc One side lighting?";
	Default = false;
	Visible = true;	
};
@_EnableDepthBias
{
	Name = EnableDepthBias;
	Description = "Enable Image based lighting?";
	Default = false;
	Visible = false;	
};
@_EnableIBL
{
	Name = EnableIBL;
	Description = "Enable Image based lighting?";
	Default = true;
	Visible = true;	
};
@_NormalMapEnable
{
	Name = NormalMapEnable;
	Description = "Do we have NormalMap?"; 
	AffectedTex = tNormalMap;
	Fallback = "@_TANGENT";
	Visible = false;
};
@_LightMapEnable
{
	Name = LightMapEnable;
	Description = "Do we have LightMap?";
	AffectedTex = tLightMap;
	Fallback = "@_LIGHT_MAP";
	Visible = false;
};
@_EmissionMapEnable
{
	Name = EmissionMapEnable;
	Description = "Do we have EmissionMap?";
	AffectedTex = tEmissionMap; 
	Fallback = true;
	Visible = false;
};
@_AnisotropicEnable
{
	Name = AnisotropicEnable;
	Description = "Do we need calc anisotropic lighting?";
	Visible = false;
};
@_LightmapConstEnable
{
	Name = LightmapConstEnable;
	Default = false;
	Visible = false;
};
@_HighlightEnable
{
	Name = HighlightEnable;
	Description = "for deferred pipeline change highlight pass";
	Default = false;
	Predict = false;
	
};
@_FrozenEnable
{
	Name = FrozenEnable;
	Description = "for deferred pipeline change frozen pass";
	Default = false;
	Predict = false;
};
@_BurntEnable
{
	Name = BurntEnable;
	Description = "for deferred pipeline change burnt pass";
	Default = false;
	Predict = false;
};
@_UnidirectionalDissolveEnable
{
	Name = UnidirectionalDissolveEnable;
	Description = "material has unidirectional dissolve effect";
	Visible = true;
	Default = false;
};
@_GrayEffect
{
	Name = GrayEffect;
	Description = "for Graying";
	Visible = true;
	Default = false;
	Predict = false;
};

//////////////////////////////////Constant buffer////////////////////////////////////////
cbuffer Shader
{
	float3 cBaseColor 				 < Widget = "LinearColor3"; Visible = "0";> = {1, 1, 1};
	float cMetallic					 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; Visible = "0";> = 0;	//金属度[0:1] 

	float cAliasingFactor			 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; Visible = "0"; > = 0.2;//抗锯齿因子
	float cEnvStrength				 < Widget = "FloatSlider"; Min = "0"; Max = "10"; Step = "0.01"; Precision = "2"; Visible = "0";> = 1;	//环境强度[0:8]
	float cRoughnessLow				 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; > = 0;	//粗糙度下界
	float cRoughnessHigh			 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; > = 1;	//粗糙度上界
	
	// float4 cLightMapScale			 = {1, 1, 1, 1};
	// float4 cLightMapUVTransform		 = {1, 1, 0, 0};

	float  cSmoothness				 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; Visible = "0";> = 0;
	float  cBloomScale				 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; Visible = "0";> = 0.5;
	float  cBaseMapBias				 < Widget = "FloatSlider"; Min = "-2"; Max = "2"; Step = "0.01"; Precision = "2";Visible = "0";> = -1;
	float  cNormalMapBias			 < Widget = "FloatSlider"; Min = "-2"; Max = "2"; Step = "0.01"; Precision = "2"; Visible = "0";> = -2;

	float4 cEmissionScale			 < Widget = "FloatSlider";Visible = "0";> = {1, 1, 1, 0};
	float4 cEmissionScrolling		 < Widget = "FloatSlider";Visible = "0";> = {1, 1, 0, 0};

	// float cRoughnessX				 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.001"; Precision = "2"; > = 0.1;
	// float cRoughnessY				 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.001"; Precision = "2"; > = 1;
	// float cAnisotropicScale			 < Widget = "FloatSlider"; Min = "0"; Max = "10"; Step = "0.01"; Precision = "2"; > = 0;

	float cDepthOffset     			 < Widget = "FloatSlider"; Min = "-20"; Max = "20"; Step = "0.1"; Precision = "2"; Visible = "0";> = 0;
	float cDepthBias	  			 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.1"; Precision = "2"; Visible = "0";> = 0;
	float cSaturation				 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.1"; Precision = "2"; Visible = "0";> = 1;
	float cFogDistance				 < Widget = "FloatSlider"; Min = "0"; Max = "1000"; Step = "0.1"; Precision = "2"; Visible = "0"; > = 100;

	float cBiasFarAwayShadow		 < Widget = "FloatSlider"; Min = "0"; Max = "10"; Step = "0.1"; Precision = "3";  Visible = "0";> = 0.01;
	float cBumpIns      			 < Widget = "FloatSlider"; Min = "0"; Max = "10"; Step = "0.1"; Precision = "2";  Visible = "0";> = 1;
	float2 cRoughnessXY				 < Widget = "FloatSlider";Visible = "0";> = {0,1};
	float cTangentShift				 < Widget = "FloatSlider"; Min = "-1"; Max = "1"; Step = "0.01"; Precision = "2"; > = -0.3;
	float cTangentSecShift			 < Widget = "FloatSlider"; Min = "-1"; Max = "1"; Step = "0.01"; Precision = "2"; > = 0.0;
	float cAlpha	      			 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.1"; Precision = "2"; > = 0.5;
	float cScatterScale	      		 < Widget = "FloatSlider"; Min = "0"; Max = "10"; Step = "0.1"; Precision = "2"; Visible = "0"; > = 2;
	float cGrayingin				< Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.1"; Precision = "2"; > = 0;
};

//////////////////////////////////Input Texture////////////////////////////////////////
texture2D tBaseMap : layout(t0) = "White";
sampler sBaseSampler : layout(s0)
{
	Texture = tBaseMap;
	Filter = Linear;
	Address = FromTexture;
	SRGB = false;
};

texture2D tMixMap : layout(t1) = "Reflection";
sampler sMixSampler : layout(s1)
{
	Texture = tMixMap;
	Filter = Linear;
	Address = Wrap;
	SRGB = false;
};

texture2D tEnvMap : EnvMap : layout(t2) = "White";
sampler sEnvSampler : layout(s2)
{
	Texture = tEnvMap;
	Filter = Linear;
	Address = Clamp;
	SRGB = false; 
};

texture2D tNormalMap : layout(t3) = "NormalMap";
sampler sNormalSampler : layout(s3)
{
	Texture = tNormalMap;
	Filter = Linear;
	Address = Wrap;
	SRGB = false;
};

// Light map
texture2D tLightMap : layout(t4);
sampler sLightMapSampler : layout(s4)
{
	Texture = tLightMap;
	Filter = Linear;
	Address = Clamp;
	SRGB = false;
	MaxMipLevel = 0;
};

texture2D tShadowMask : ShadowMask : layout(t5) = "White";
sampler sShadowMaskSampler : layout(s5)
{
	Texture = tShadowMask; 
	Filter = Point; 
	Address = Clamp;
	SRGB = false;
	MaxMipLevel = 0;
};
// ShadowMap 
texture2D tShadowMap : ShadowMap : layout(t6) = "White";
SamplerComparisonState sShadowMapSampler : layout(s6)
{
	Texture = tShadowMap;
	Filter = Linear;
	Address = Clamp;
	ComparisonFunc = Greater;
	SRGB = false;
	MaxMipLevel = 0;
};
// Emission map
texture2D tEmissionMap : layout(t7) = "Transparent";
sampler sEmissionMapSampler : layout(s7)
{
	Texture = tEmissionMap;
	Filter = Linear; 
	Address = Wrap;
	SRGB = false;
};

texture2D tRainMap : RainMap: layout(t8) = "NormalMap";
sampler sRainSampler : layout(s8)
{
	Texture = tRainMap;
	Filter = Linear;
	Address = Wrap;
	SRGB = false;
};

texture2D tSkeletonMap : SkeletonMap : layout(t3) = "Black";
sampler sSkeletonSampler : layout(s3)
{
	Texture = tSkeletonMap;
	Filter = Point;
	Address = Clamp;
	SRGB = false;
};

#include "PBR_VS.fxh"
//////////////////////////////////VS////////////////////////////////////////
void VS_DIY_OUTPUT(in VertexAssemble IN, in InterMediateVertex INTM, inout VertexShadingOutput OUT)
{
	// 1. init tint color
	InitTintColorCommon(IN, OUT); 

	// 2. for snow height calc
	OUT.WorldPosition.w = IN.Position.y;

	// 3. init emmision uv; if not need emmision uv
	InitEmissionUVCommon(IN, OUT);

	// 4. hposition calc
	InitHPositionCommon(INTM, OUT); // init hposition calc

	if(@_CastSunShadow && @_TRANSPARENT)
	{
		// for player's shadow		
		OUT.LitUVZ2 = MulMat4x4(ShadowViewProjTexs0, float4(OUT.WorldPosition.xyz + 
		OUT.WorldNormal.xyz * cBiasFarAwayShadow,1));
	}
}
#include "PBR_Common.fxh"
//////////////////////////////////PS////////////////////////////////////////
void PS_GetParameters(in VertexShadingOutput IN, out MaterialShadingParameters MaterialParameters)
{
	// 1. init MaterialParameters (always need)
	InitShadingParameters(MaterialParameters);

	// 2. init MaterialParameters.BaseColor and MaterialParameters.Alpha by sample basemap
	if(@_BaseMapEnable)
	{
		half4 samplerBase;
		samplerBase = tBaseMap.SampleBias(sBaseSampler, BaseMapUV(IN.TexCoord), cBaseMapBias);
		MaterialParameters.BaseColor = DecodeGamma(samplerBase.rgb);
		if (@_TRANSPARENT)
		{
			//MaterialParameters.Alpha = sqrt(samplerBase.a);
			MaterialParameters.Alpha = samplerBase.a;
			// if (MaterialParameters.Alpha > 0.9)
			// 	clip(-1);
		}
		else
		{
			MaterialParameters.Alpha = min(cAlpha,samplerBase.a);
		}
	}
	else
	{
		MaterialParameters.BaseColor = cBaseColor;
		MaterialParameters.Alpha = cAlpha;
	}
	
	// 3. init smoothness/metal/ao by sample mixmap
	if (@_EnableReflection)
	{
		half3 samplerMis = tMixMap.Sample(sMixSampler, BaseMapUV(IN.TexCoord)).rgb;
		half Smoothness = samplerMis.r;
		MaterialParameters.Roughness = lerp(cRoughnessHigh, cRoughnessLow, Smoothness);
		MaterialParameters.CustomData.w = samplerMis.g * cScatterScale / 10;//Scatter
		MaterialParameters.Metallic = cMetallic;
		MaterialParameters.AO = samplerMis.b;
	}
	else	
	{
		MaterialParameters.Roughness = 1 - cSmoothness;
		MaterialParameters.Metallic = cMetallic;
		MaterialParameters.CustomData.w = 1;
	}



	// 4. init MaterialParameters.WorldNormal by sample normalmap
	if( @_TANGENT && @_NormalMapEnable && @_LOD_LEVEL <= LOD_Level_2)
	{
		half4 tangentNormal = tNormalMap.Sample(sNormalSampler, BaseMapUV(IN.TexCoord));
		[@_DIRECTX]//always use bc5 for pc
		tangentNormal.z = 1;
		tangentNormal.xyz = (2 * tangentNormal.xyz) - 1;
		tangentNormal.xy *= cBumpIns;
		MaterialParameters.WorldNormal = tangentNormal.x * IN.WorldTangent + tangentNormal.y * IN.WorldBinormal + tangentNormal.z * IN.WorldNormal.xyz;
		MaterialParameters.WorldNormal = normalize(MaterialParameters.WorldNormal);

		//R TT TRT specular Shift
		half tangentShift = tangentNormal.a;
		half3 tangent = lerp(half3(cRoughnessXY, cTangentShift), half3(cRoughnessXY, cTangentSecShift), tangentShift);
		tangent.xy += tangentNormal.xy;
		tangent = normalize(tangent);
		MaterialParameters.CustomData.xyz = tangent.x * IN.WorldTangent + tangent.y * IN.WorldBinormal + tangent.z * IN.WorldNormal.xyz;
		MaterialParameters.CustomData.xyz = normalize(MaterialParameters.CustomData.xyz);

		//R Specular Virtrual Lit
		if(VIRTUAL_LIT)
		{
			half3 V = normalize(-IN.ViewDirection.xyz);
			half NoV = dot(MaterialParameters.WorldNormal, V) * 0.5 + 0.5;				
			half3 S = 0;
			half3 Tangent = MaterialParameters.CustomData.xyz;
			half ClampedRoughness = clamp(MaterialParameters.Roughness, 1/255.0, 1.0);
			half SinThetaV = dot(Tangent, V);

			half CosPhi = rsqrt( 1e-4 );
			half CosHalfPhi = sqrt( saturate( 0.5 + 0.5 * CosPhi ) );

			half Shift = 0.035;
			half AlphaR = -Shift * 2;
			half BR = pow( ClampedRoughness, 2 );

			// R
			half sa = sin( AlphaR );
			half ca = cos( AlphaR );
			Shift = 2 * sa * ( ca * CosHalfPhi * sqrt( 1 - SinThetaV * SinThetaV ) + sa * SinThetaV );
			half Mp = Hair_g( BR * sqrt(2.0) * CosHalfPhi, SinThetaV * 2 - Shift );
			half Np = 0.25 * CosHalfPhi;
			S += Mp * Np * 0.1 * MaterialParameters.Specular;
			S =  clamp(S, 0, 100);

			half3 D = NoV * MaterialParameters.BaseColor/PI;
			MaterialParameters.Emission += (D + S) * cVirtualLitColor.rgb;
		}
		//encode tangent to 0-1
		MaterialParameters.CustomData.xyz = EncodeNormal(MaterialParameters.CustomData.xyz);
	}
	
	else
	{
		MaterialParameters.WorldNormal = normalize(IN.WorldNormal.xyz);
	}
	
	// 5. init MaterialParameters.Emission by sample emissinMap (if need or not)
	InitEmission(IN, MaterialParameters);

	//GrayingEffect
	InitGrayEffect(cGrayingin,MaterialParameters);
}
#include "PBR_PS.fxh"


