#pragma shader material
///////////////choice define start///////////////////////////
#define MATERIAL_SHADINGMODEL_PREINTEGRATED_SKIN 1
#define USE_LIGHTMAP						0
#define USE_LIGHTMAP_CONST					0
#define USE_CLIPPING						1
#define USE_WIREFRAME						1
#define USE_FROZEN							1
#define USE_BURNT							1
#define USE_HIGHLIGHT						1
#define USE_XRAY							1
#define USE_EDGELINE						1
#define USE_PLANAR_SHADOW					0
#define USE_VBufferGen						1
#define VIRTUAL_LIT 						0
#define USE_GRAY                            1
#define USE_UNIDIRECTIONAL_DISSOLVE			1
#pragma shader predict("@_TANGENT", "true")
#pragma shader predict("@_CLIPPING", "false")
#pragma shader predict("@_TRANSPARENT", "false")
#pragma shader predict("@_VERTEXCOLOR", "true")
#pragma shader predict("@_INSTANCED", "false")
#pragma shader predict("@_DF_SKIN", "0")
#define HAS_2UV								0
#define ENABLE_MIXMAP						(@_EnableReflection)
#define ENABLE_ANISOTROPIC 					0
#define ENABLE_RIPPLE 						0
#define ENABLE_SCREEN_SHADOWMAP				(@_CSM && @_CastSunShadow && @_LOD_LEVEL <= LOD_Level_2 && !@_TRANSPARENT)
#define ENABLE_HIGHLIGHT					(@_HighlightEnable) // deferred
#define ENABLE_BURNT						(@_BurntEnable) // deferred
#define USE_SHADOWMAP_SAMPLE				((@_LOD_LEVEL <= LOD_Level_2 && @_CastSunShadow) && (@_TRANSPARENT || (!@_CSM && @_REC_SHADOW)))
#define USE_PLAYER_SHADOWMAP				1 // 全是在开csm下有效的
#define DEFERRED_PRE_AO						1 // 是否走ao
///////////////choice define end//////////////////////////

#include "PBR_Definitions.fxh"
#include "Constants.fxh"
#include "Common.fxh"
//////////////////////////////////Properties////////////////////////////////////////
@_BaseMapEnable 
{ 
	Name = BaseMapEnable;
	Description = "Do we have BaseMap?";  
	AffectedTex = tBaseMap;
	Fallback = true;
	Visible = false;
};
@_EnableReflection 
{
	Name = EnableReflection;
	Description = "EnableReflection?";
	AffectedTex = tMixMap;
	Fallback = true;
	Visible = false;
	Default = false;
};
@_EnableIBL
{
	Name = EnableIBL;
	Description = "Enable Image based lighting?";
	Default = true;
	Visible = true;	
};
@_NormalMapEnable
{
	Name = NormalMapEnable;
	Description = "Do we have NormalMap?"; 
	AffectedTex = tNormalMap;
	Fallback = "@_TANGENT";
	Visible = false;
};
@_DetailMapEnable
{
	Name = DetailMapEnable;
	Description = "Do we have DetailMap?"; 
	AffectedTex = tDetailMap;
	Fallback = "@_TANGENT";
	Visible = false;
};
@_LightMapEnable
{
	Name = LightMapEnable;
	Description = "Do we have LightMap?";
	AffectedTex = tLightMap;
	Fallback = "@_LIGHT_MAP";
	Visible = false;
};
@_EmissionMapEnable
{
	Name = EmissionMapEnable;
	Description = "Do we have EmissionMap?";
	AffectedTex = tEmissionMap; 
	Fallback = true;
	Visible = false;
};
@_LightmapConstEnable
{
	Name = LightmapConstEnable;
	Default = false;
	Visible = false;
};
@_HighlightEnable
{
	Name = HighlightEnable;
	Description = "for deferred pipeline change highlight pass";
	Default = false;
	Visible = false;
};
@_FrozenEnable
{
	Name = FrozenEnable;
	Description = "for deferred pipeline change frozen pass";
	Default = false;
	Visible = false;
};
@_BurntEnable
{
	Name = BurntEnable;
	Description = "for deferred pipeline change burnt pass";
	Default = false;
	Visible = false;
};
@_UnidirectionalDissolveEnable
{
	Name = UnidirectionalDissolveEnable;
	Description = "material has unidirectional dissolve effect";
	Visible = true;
	Default = false;
};
@_GrayEffect
{
	Name = GrayEffect;
	Description = "for Graying";
	Visible = true;
	Default = false;
};
//////////////////////////////////Constant buffer////////////////////////////////////////
cbuffer Shader
{
	float3 cBaseColor 				 < Widget = "LinearColor3"; Visible = "0";> = {1, 1, 1};
	float cMetallic					 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2";Visible = "0"; > = 0;	//金属度[0:1] 

	float cAliasingFactor			 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; Visible = "0";> = 0.2;//抗锯齿因子
	float cEnvStrength				 < Widget = "FloatSlider"; Min = "0"; Max = "10"; Step = "0.01"; Precision = "2";Visible = "0"; > = 1;	//环境强度[0:8]
	float cRoughnessLow				 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2";> = 0;	//粗糙度下界
	float cRoughnessHigh			 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2";> = 1;	//粗糙度上界

	float  cSmoothness				 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; Visible = "0";> = 0;
	float  cBloomScale				 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; Visible = "0";> = 0.5;
	float  cBaseMapBias				 < Widget = "FloatSlider"; Min = "-2"; Max = "2"; Step = "0.01"; Precision = "2";Visible = "0"; > = -1;
	float  cNormalMapBias			 < Widget = "FloatSlider"; Min = "-2"; Max = "2"; Step = "0.01"; Precision = "2"; Visible = "0";> = -0.5;

	float4 cEmissionScale			  <Visible = "0";> = {1, 1, 1, 0};
	float4 cEmissionScrolling		  <Visible = "0";> = {1, 1, 0, 0};

	float cDepthBias				 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.1"; Precision = "2"; Visible = "0";> = 0;

	float cAlpha	      			 < Widget = "FloatSlider"; Min = "0"; Max = "10"; Step = "0.1"; Precision = "2"; Visible = "0";> = 1.0;
	float cDepthOffset     			 < Widget = "FloatSlider"; Min = "-5"; Max = "5"; Step = "0.1"; Precision = "2"; Visible = "0";> = 0;
	float cBiasFarAwayShadow		 < Widget = "FloatSlider"; Min = "0"; Max = "10"; Step = "0.1"; Precision = "3"; Visible = "0";> = 0.01;
	float cSaturation				 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.1"; Precision = "2"; Visible = "0";> = 1;

	float cDetailUV      			 < Widget = "FloatSlider"; Min = "1"; Max = "50"; Step = "0.1"; Precision = "2"; > = 10;
	float cDetailNormalIns      	 < Widget = "FloatSlider"; Min = "0"; Max = "2"; Step = "0.1"; Precision = "2"; > = 0.5;
	float cGrayingin				< Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.1"; Precision = "2"; > = 0;
	//float cCurvature				 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.1"; Precision = "2"; > = 0.5;
	float3 cTSAmbientColor			 = {0.1, 0.1, 0.1};
	float cTSDistortion	  			 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; > = 0.0;
	float cTSPower					 < Widget = "FloatSlider"; Min = "0"; Max = "100"; Step = "0.01"; Precision = "2"; > = 1.0;
	//float cTSThickness				 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; > = 0.078125;
	float cTSScale 					 < Widget = "FloatSlider"; Min = "0"; Max = "10"; Step = "0.01"; Precision = "2"; > = 1;
};

//////////////////////////////////Input Texture////////////////////////////////////////
texture2D tBaseMap : layout(t0) = "White";
sampler sBaseSampler : layout(s0, s1)
{
	Texture = tBaseMap;
	Filter = Linear;
	Address = FromTexture;
	SRGB = false;
};

texture2D tMixMap : layout(t2) = "Reflection";
sampler sMixSampler : layout(s2)
{
	Texture = tMixMap;
	Filter = Linear;
	Address = Wrap;
	SRGB = false;
};

texture2D tEnvMap : EnvMap : layout(t3) = "White";
sampler sEnvSampler : layout(s3)
{
	Texture = tEnvMap;
	Filter = Linear;
	Address = Clamp;
	SRGB = false; 
};

texture2D tNormalMap : layout(t4) = "NormalMap";
sampler sNormalSampler : layout(s4)
{
	Texture = tNormalMap;
	Filter = Linear;
	Address = Wrap;
	SRGB = false;
};

// Skin profile map
texture2D tSkinProfileMap : layout(t5) = "White";
sampler sSkinProfileMapSampler : layout(s5)
{
	Texture = tSkinProfileMap;
	Filter = Linear;
	Address = Clamp;
	SRGB = false;
};

// Screen ShadowMap
texture2D tShadowMask : ShadowMask : layout(t6) = "White";
sampler sShadowMaskSampler : layout(s6)
{
	Texture = tShadowMask; 
	Filter = Point; 
	Address = Clamp;
	SRGB = false;
	MaxMipLevel = 0;
};

// ShadowMap 
texture2D tShadowMap : ShadowMap : layout(t7) = "White";
SamplerComparisonState sShadowMapSampler : layout(s7)
{
	Texture = tShadowMap;
	Filter = Linear;
	Address = Clamp;
	ComparisonFunc = Greater;
	SRGB = false;
	//MaxMipLevel = 0;
};

// Emission map
texture2D tEmissionMap : layout(t8) = "Transparent";
sampler sEmissionMapSampler : layout(s8)
{
	Texture = tEmissionMap;
	Filter = Linear; 
	Address = Wrap;
	SRGB = false;
};

texture2D tRainMap : RainMap: layout(t9) = "NormalMap";
sampler sRainSampler : layout(s9)
{
	Texture = tRainMap;
	Filter = Linear;
	Address = Wrap;
	SRGB = false;
};

texture2D tDetailMap : layout(t10) = "NormalMap";
sampler sDetailSampler : layout(s10)
{
	Texture = tDetailMap;
	Filter = Linear;
	Address = Wrap;
	SRGB = false;
};

texture2D tSkeletonMap : SkeletonMap : layout(t11) = "Black";
sampler sSkeletonSampler : layout(s11)
{
	Texture = tSkeletonMap;
	Filter = Point;
	Address = Clamp;
	SRGB = false;
};

//////////////////////////////Function/////////////////////////////////////
half3 PS_GetBTDF(in float3 L, in float3 N, in float3 V, in half thickness)
{
	// Translucency.
	half3 transLightDir = L + cTSDistortion*N;
	half transDot = pow (max (0, dot(V, -transLightDir)), cTSPower) * cTSScale;
	half3 transLight = (transDot + cTSAmbientColor) * thickness;
	return transLight;
}

//////////////////////////////////VS////////////////////////////////////////
#include "PBR_VS.fxh"
void VS_DIY_OUTPUT(in VertexAssemble IN, in InterMediateVertex INTM, inout VertexShadingOutput OUT)
{
	// 1. init tint color
	InitTintColorCommon(IN, OUT); 

	// 2. for snow height calc
	OUT.WorldPosition.w = IN.Position.y;

	// 3. init emmision uv; if not need emmision uv
	InitEmissionUVCommon(IN, OUT);

	// 4. hposition calc
	InitHPositionCommon(INTM, OUT); // init hposition calc

	if(@_CastSunShadow && @_TRANSPARENT)
	{
		// for player's shadow		
		OUT.LitUVZ2 = MulMat4x4(ShadowViewProjTexs0, float4(OUT.WorldPosition.xyz + 
		OUT.WorldNormal.xyz * cBiasFarAwayShadow,1));	
	}
}
#include "BRDF.fxh"
#include "PBR_Common.fxh"
//////////////////////////////////PS////////////////////////////////////////
void PS_GetParameters(in VertexShadingOutput IN, out MaterialShadingParameters MaterialParameters)
{
	// 1. init MaterialParameters (always need)
	InitShadingParameters(MaterialParameters);
	//MaterialParameters.Opacity = cCurvature;
	
	// 2. init MaterialParameters.BaseColor and MaterialParameters.Alpha by sample basemap
	InitBaseColorCommon(IN, MaterialParameters);

	// 3. init smoothness/metal/ao by sample mixmap
	if (@_EnableReflection && @_LOD_LEVEL <= LOD_Level_2)
	{

		half3 samplerMis = tMixMap.Sample(sMixSampler, BaseMapUV(IN.TexCoord)).rgb;
		half Smoothness = samplerMis.r;
		MaterialParameters.Thickness = PS_GetBTDF(IN.DiffLighting,IN.WorldNormal,IN.ViewDirection,samplerMis.g );
		MaterialParameters.AO = samplerMis.b;
		MaterialParameters.Roughness = lerp(cRoughnessHigh, cRoughnessLow, Smoothness);
	}
	// 4. init MaterialParameters.WorldNormal by sample normalmap
	if(@_TANGENT && @_NormalMapEnable && @_LOD_LEVEL <= LOD_Level_2)
	{
		float3 TNO = float3(0,0.1,-0.1);
		half4 tangentNormal = tNormalMap.SampleBias(sNormalSampler, BaseMapUV(IN.TexCoord), -1);

		half3 tangentNormal1 = tNormalMap.SampleBias(sNormalSampler, BaseMapUV(IN.TexCoord + TNO.xy), 4).xyz;
		half3 tangentNormal2 = tNormalMap.SampleBias(sNormalSampler, BaseMapUV(IN.TexCoord + TNO.xz), 4).xyz;
		half3 tangentNormal3 = tNormalMap.SampleBias(sNormalSampler, BaseMapUV(IN.TexCoord + TNO.yx), 4).xyz;
		half3 tangentNormal4 = tNormalMap.SampleBias(sNormalSampler, BaseMapUV(IN.TexCoord + TNO.zx), 4).xyz;

		float3 NtangentNormal = (tangentNormal.xyz + tangentNormal1 + tangentNormal2 + tangentNormal3 + tangentNormal4)/5;

		[@_DIRECTX]//always use bc5 for pc
		NtangentNormal.z = 1;
		NtangentNormal = NtangentNormal * 2 - 1;
		MaterialParameters.WorldNormal = NtangentNormal.x * IN.WorldTangent + NtangentNormal.y * IN.WorldBinormal + NtangentNormal.z * IN.WorldNormal.xyz;
		MaterialParameters.WorldNormal = normalize(MaterialParameters.WorldNormal);

		half3 detailMap = half3(0,0,1);
		if(@_DetailMapEnable)
		{
			detailMap = tDetailMap.Sample(sDetailSampler, BaseMapUV(IN.TexCoord) * cDetailUV).xyz;
			detailMap.xy = detailMap.xy * 2 - 1;
			detailMap.z *= 2;
		}

		half4 specTangentNormal = tNormalMap.SampleBias(sNormalSampler, BaseMapUV(IN.TexCoord), -1);
		[@_DIRECTX]//always use bc5 for pc
		specTangentNormal.z = 1;
		specTangentNormal.xyz = (2 * specTangentNormal.xyz) - 1;
		specTangentNormal.xy += detailMap.xy * cDetailNormalIns * specTangentNormal.a;
		MaterialParameters.CustomData.rgb = specTangentNormal.x * IN.WorldTangent + specTangentNormal.y * IN.WorldBinormal + specTangentNormal.z * IN.WorldNormal.xyz;
		MaterialParameters.CustomData.rgb = normalize(MaterialParameters.CustomData.rgb);

		//MaterialParameters.Specular = lerp(MaterialParameters.Specular, MaterialParameters.Specular * detailMap.z, specTangentNormal.a);
	}
	else
	{
		MaterialParameters.WorldNormal = normalize(IN.WorldNormal.xyz);
	}
	//Virtual Light
	float3 V = normalize(-IN.ViewDirection.xyz);
	half wrapNoV = dot(MaterialParameters.WorldNormal, V) * 0.5 + 0.5;
	half NoV = saturate(dot(MaterialParameters.CustomData.rgb, V));
	half3 virtualLitSpec = SimpleBRDF_SPEC(V, MaterialParameters.CustomData.rgb, V, NoV, NoV, MaterialParameters.SpecularColor, MaterialParameters.Roughness) * cVirtualLitColor.rgb * NoV;
	// half3 virtualLitDiff = cVirtualLitColor.rgb * wrapNoV * MaterialParameters.BaseColor / PI;
	// MaterialParameters.Emission += virtualLitSpec + virtualLitDiff;
	//fur rim
	// half NoV = saturate(dot(MaterialParameters.CustomData.rgb, V));
	// half F1 = (1 - NoV) * MaterialParameters.AO;
	// F1 *= F1;
	// MaterialParameters.Emission += F1 * F1 * 0.05;
	
	// 5. init MaterialParameters.Emission by sample emissinMap (if need or not)
	// highlight regions for face customization
	if (@_EmissionMapEnable)
	{
		half4 emission = tEmissionMap.Sample(sEmissionMapSampler, BaseMapUV(IN.TexCoord));
		emission.rgb *= emission.a * lerp(cEmissionScale.x, cEmissionScale.y, saturate(sin((GameTime-cEmissionScale.w) * 2 * PI * cEmissionScale.z) - 0.8));
		MaterialParameters.Emission.rgb = emission.rgb;
	}

	// 6. Apply Weather
	InitRain(IN, MaterialParameters);

	//GrayingEffect
	InitGrayEffect(cGrayingin,MaterialParameters);
}
#include "PBR_PS.fxh"

