#pragma shader material

///////////////choice define start///////////////////////////
#define MATERIAL_SHADINGMODEL_DEFAULT_LIT 	1 // for deferred
#define USE_LIGHTMAP						1
#define USE_LIGHTMAP_CONST					1
#define USE_CLIPPING						1
#define USE_WIREFRAME						1
#define USE_FROZEN							1
#define USE_BURNT							1
#define USE_HIGHLIGHT						1
#define USE_XRAY							1
#define USE_EDGELINE						1
#define USE_PLANAR_SHADOW					0
#define USE_VBufferGen						1
#define VIRTUAL_LIT 						0
// #pragma shader predict("@_TANGENT", "true")
#pragma shader predict("@_CLIPPING", "false")
#pragma shader predict("@_TRANSPARENT", "false")
#pragma shader predict("@_VERTEXCOLOR", "false")
// #pragma shader predict("@_INSTANCED", "false")
#pragma shader predict("@_DF_SKIN", "0")

#define HAS_2UV								(@_LIGHT_MAP)
#define ENABLE_MIXMAP						(@_EnableReflection)
#define ENABLE_ANISOTROPIC 					(@_AnisotropicEnable)
#define ENABLE_RIPPLE 						(@_RIPPLE)
#define ENABLE_SCREEN_SHADOWMAP				(@_CSM && @_CastSunShadow && @_LOD_LEVEL <= LOD_Level_2 && !@_TRANSPARENT)
#define ENABLE_HIGHLIGHT					(@_HighlightEnable) // deferred
#define ENABLE_BURNT						(@_BurntEnable) // deferred
#define USE_SHADOWMAP_SAMPLE				((@_LOD_LEVEL <= LOD_Level_2 && @_CastSunShadow) && (@_TRANSPARENT || (!@_CSM && @_REC_SHADOW)))
#define DEFERRED_PRE_AO						1 // 是否走ao
#define USE_PLAYER_SHADOWMAP				1 // 全是在开csm下有效的
///////////////choice define end//////////////////////////

#include "PBR_Definitions.fxh"
#include "Constants.fxh"
#include "Common.fxh"
//////////////////////////////////Properties////////////////////////////////////////
@_BaseMapEnable 
{ 
	Name = BaseMapEnable;
	Description = "Do we have BaseMap?";  
	AffectedTex = tBaseMap;
	Fallback = true;
	Visible = false;
};
@_EnableReflection 
{
	Name = EnableReflection;
	Description = "EnableReflection?";
	AffectedTex = tMixMap;
	Visible = false;
	Default = false;
};
@_EnableIBL
{
	Name = EnableIBL;
	Description = "Enable Image based lighting?";
	Default = false;
	Visible = true;	
};
@_NormalMapEnable
{
	Name = NormalMapEnable;
	Description = "Do we have NormalMap?"; 
	AffectedTex = tNormalMap;
	Fallback = "@_TANGENT";
	Visible = false;
};
@_LightMapEnable
{
	Name = LightMapEnable;
	Description = "Do we have LightMap?";
	AffectedTex = tLightMap;
	Fallback = "@_LIGHT_MAP";
	Visible = false;
};
@_EmissionMapEnable
{
	Name = EmissionMapEnable;
	Description = "Do we have EmissionMap?";
	AffectedTex = tEmissionMap; 
	Fallback = true;
	Predict = false;
	
};
@_AnisotropicEnable
{
	Name = AnisotropicEnable;
	Description = "Do we need calc anisotropic lighting?";
	Visible = true;
	Default = false;
	Predict = false;
};
@_LightmapConstEnable
{
	Name = LightmapConstEnable;
	Default = false;
	Visible = false;
	Predict = false;
};
@_IsFootprint
{
	Name = IsFootprint;
	Description = "Footprint material has fade out effect";
	Default = false;
	Visible = true;
};
@_HighlightEnable
{
	Name = HighlightEnable;
	Description = "for deferred pipeline change highlight pass";
	Default = false;
	Predict = false;
};
@_FrozenEnable
{
	Name = FrozenEnable;
	Description = "for deferred pipeline change frozen pass";
	Default = false;
	Predict = false;
};
@_BurntEnable
{
	Name = BurntEnable;
	Description = "for deferred pipeline change burnt pass";
	Default = false;
	Predict = false;
};
@_WeaponHighLight
{
	Name = WeaponHighLight;
	Description = "for WeaponHighlight";
	Default = false;
};

@_RadarEnable
{
	Name = RadarEnable;
	Description = "RadarEnable";
	Default = false;
	Visible = false;
};
//////////////////////////////////Constant buffer////////////////////////////////////////
cbuffer Shader
{
	float3 cBaseColor 				< Visible = "0"; > = {1, 1, 1};
	float cMetallic					< Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; Visible = "0"; > = 0;	//金属度[0:1] 

	float cAliasingFactor			< Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; Visible = "0"; > = 0.2;//抗锯齿因子
	float cEnvStrength				< Widget = "FloatSlider"; Min = "0"; Max = "10"; Step = "0.01"; Precision = "2"; Visible = "0"; > = 1;	//环境强度[0:8]
	float cRoughnessLow				< Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; Visible = "0"; > = 0;	//粗糙度下界
	float cRoughnessHigh			< Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; Visible = "0"; > = 1;	//粗糙度上界
	
	float4 cLightMapScale			< Visible = "0"; > = {1, 1, 1, 1};
	float4 cLightMapUVTransform		< Visible = "0"; > = {1, 1, 0, 0};

	float  cSmoothness				< Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; Visible = "0"; > = 0;
	float  cBloomScale				< Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; Visible = "0"; > = 0.5;
	float  cBaseMapBias				< Widget = "FloatSlider"; Min = "-2"; Max = "2"; Step = "0.01"; Precision = "2";Visible = "0";  > = -1;
	float  cNormalMapBias			< Widget = "FloatSlider"; Min = "-2"; Max = "2"; Step = "0.01"; Precision = "2"; Visible = "0"; > = -0.5;

	float4 cEmissionScale			<Visible = "0"; > = {1, 1, 1, 0};
	float4 cEmissionScrolling		<Visible = "0"; > = {1, 1, 0, 0};

	float cRoughnessX				< Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.001"; Precision = "2"; Visible = "0"; > = 0.1;
	float cRoughnessY				< Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.001"; Precision = "2"; Visible = "0"; > = 1;
	float cAnisotropicScale			< Widget = "FloatSlider"; Min = "0"; Max = "10"; Step = "0.01"; Precision = "2"; Visible = "0"; > = 0;
	float cFogDistance				< Widget = "FloatSlider"; Min = "0"; Max = "1000"; Step = "0.1"; Precision = "2"; Visible = "0"; > = 100;

	float cBumpIns      			< Widget = "FloatSlider"; Min = "0"; Max = "10"; Step = "0.1"; Precision = "2"; Visible = "0"; > = 1;
	float cAlpha	      			< Widget = "FloatSlider"; Min = "0"; Max = "10"; Step = "0.1"; Precision = "2"; Visible = "0"; > = 1.0;
	float cDepthOffset     			< Widget = "FloatSlider"; Min = "-20"; Max = "20"; Step = "0.1"; Precision = "2"; Visible = "0"; > = 0;
	float cDepthBias	  			< Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.1"; Precision = "2"; Visible = "0"; > = 0;
	float cSnowHeight	  			< Widget = "FloatSlider"; Min = "-2"; Max = "2"; Step = "0.1"; Precision = "2"; Visible = "0"; > = 0.6;
	float cSnowDetail	  			< Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.1"; Precision = "2"; Visible = "0"; > = 1;
	float cBiasFarAwayShadow		< Widget = "FloatSlider"; Min = "0"; Max = "10"; Step = "0.1"; Precision = "3"; Visible = "0"; > = 0.01;
	float cWeaponAnimation			<Visible = "0"; > = {0};
	float cMossSize					<Visible = "0"; > = {64};
	float cUVScale					<Visible = "0"; > = {14};	
	float cMossHeight				<Visible = "0"; > = {5};	
	float cMossLevel				<Visible = "0"; > = {-6};	
	// float4 cMossColor 				: layout(c11.x) = {1,1,1,1};
	float cDetailNormalScale  		< Visible = "1"; > = 0.0;
	float cNormalBlendHardness 		< Widget = "FloatSlider"; Min = "0"; Max = "100"; Step = "0.01"; Precision = "3"; Visible = "1"; > = 0.0;
	float cGrassRoughness  			< Widget = "FloatSlider"; Min = "0"; Max = "10"; Step = "0.01"; Precision = "3"; Visible = "1"; > = 0.0;
	float cRockRoughness  			< Widget = "FloatSlider"; Min = "0"; Max = "10"; Step = "0.01"; Precision = "3"; Visible = "1"; > = 0.0;
	float cGrassUVTilling  			< Widget = "FloatSlider"; Min = "0"; Max = "10"; Step = "0.01"; Precision = "3"; Visible = "1"; > = 0.0;
	float cStoneUVTilling  			< Widget = "FloatSlider"; Min = "0"; Max = "10"; Step = "0.01"; Precision = "3"; Visible = "1"; > = 0.0;
	float cBlendNormalIntensity  	< Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "3"; Visible = "1"; > = 0.0;
	float cNormalBlendOffset  		< Widget = "FloatSlider"; Min = "-1"; Max = "2"; Step = "0.01"; Precision = "3"; Visible = "1"; >  = 0.0;
	float cFov  		< Widget = "FloatSlider"; Min = "-1"; Max = "2"; Step = "0.01"; Precision = "3"; Visible = "1"; >  = 0.0;

	float3 cRadarColor				< Widget = "LinearColor3"; > = {1, 1, 1};
	float	cRadarScrolling			={0};
	float 	cPlayerDirection			 = {1};

};

//////////////////////////////////Input Texture////////////////////////////////////////
texture2D tBaseMap : layout(t0) = "White";
sampler sBaseSampler : layout(s0)
{
	Texture = tBaseMap;
	Filter = Linear;
	Address = FromTexture;
	SRGB = true;
};

texture2D tMixMap : layout(t1) = "Reflection";
sampler sMixSampler : layout(s1)
{
	Texture = tMixMap;
	Filter = Linear;
	Address = Wrap;
	SRGB = false;
};

texture2D tEnvMap : EnvMap : layout(t2) = "White";
sampler sEnvSampler : layout(s2)
{
	Texture = tEnvMap;
	Filter = Linear;
	Address = Clamp;
	SRGB = false; 
};

texture2D tNormalMap : layout(t3) = "NormalMap";
sampler sNormalSampler : layout(s3)
{
	Texture = tNormalMap;
	Filter = Linear;
	Address = Wrap;
	SRGB = false;
};

// Light map
texture2D tLightMap : layout(t4);
sampler sLightMapSampler : layout(s4)
{
	Texture = tLightMap;
	Filter = Linear;
	Address = Clamp;
	SRGB = false;
	MaxMipLevel = 0;
};

texture2D tShadowMask : ShadowMask : layout(t5) = "White";
sampler sShadowMaskSampler : layout(s5)
{
	Texture = tShadowMask; 
	Filter = Point; 
	Address = Clamp;
	SRGB = false;
	MaxMipLevel = 0;
};
// ShadowMap 
texture2D tShadowMap : ShadowMap : layout(t7) = "White";
SamplerComparisonState sShadowMapSampler : layout(s7)
{
	Texture = tShadowMap;
	Filter = Linear;
	Address = Clamp;
	ComparisonFunc = Greater;
	SRGB = false;
	MaxMipLevel = 0;
}; 

// Emission map
texture2D tEmissionMap : layout(t7) = "Transparent";
sampler sEmissionMapSampler : layout(s7)
{
	Texture = tEmissionMap;
	Filter = Linear; 
	Address = Wrap;
	SRGB = false;
};

texture2D tRainMap : RainMap: layout(t8) = "NormalMap";
sampler sRainSampler : layout(s8)
{
	Texture = tRainMap;
	Filter = Linear;
	Address = Wrap;
	SRGB = false;
};
texture2D tGrassTextureMap : layout(t9) = "NormalMap";
sampler sGrassTextureMapSampler: layout(s9)
{
	Texture = tGrassTextureMap;
	Filter = Linear;
	Address = FromTexture;
	SRGB = true;
};
texture2D tGrassNormalMap : layout(t10) = "NormalMap";
sampler sGrassNormalSampler : layout(s10)
{
	Texture = tGrassNormalMap;
	Filter = Linear;
	Address = Wrap;
	SRGB = false;
};

texture2D tSkeletonMap : SkeletonMap : layout(t3) = "Black";
sampler sSkeletonSampler : layout(s3)
{
	Texture = tSkeletonMap;
	Filter = Point;
	Address = Clamp;
	SRGB = false;
};
texture2D tGTAOMap : GIMap : layout(t5) = "White";
sampler sGTAOSampler : layout(s5)
{
	Texture = tGTAOMap;
	Filter = Point;
	Address = Clamp;
	SRGB = false;
};
#include "PBR_VS.fxh"
//////////////////////////////////VS////////////////////////////////////////
void VS_DIY_OUTPUT(in VertexAssemble IN, in InterMediateVertex INTM, inout VertexShadingOutput OUT)
{
	// 1. init tint color
	InitTintColorCommon(IN, OUT); 

	// 2. for snow height calc
	OUT.WorldPosition.w = IN.Position.y;
	
	
	
	// 3. init emmision uv; if not need emmision uv
	InitEmissionUVCommon(IN, OUT);

	// 4. hposition calc
	InitHPositionCommon(INTM, OUT); // init hposition calc

	if(@_CastSunShadow && @_TRANSPARENT)
	{
		// for player's shadow		
		OUT.LitUVZ2 = MulMat4x4(ShadowViewProjTexs0, float4(OUT.WorldPosition.xyz + 
		OUT.WorldNormal.xyz * cBiasFarAwayShadow,1));
	}
}
#include "PBR_Common.fxh"
//////////////////////////////////PS////////////////////////////////////////
void PS_GetParameters(in VertexShadingOutput IN, out MaterialShadingParameters MaterialParameters)
{
	// 1. init MaterialParameters (always need)
	InitShadingParameters(MaterialParameters);
	// half2 BlendUVScale = IN.TexCoord.xy * cUVScale;
	
	// 2. init MaterialParameters.BaseColor and MaterialParameters.Alpha by sample basemap
	// half4 samplerBase;
	// samplerBase = tBaseMap.SampleBias(sBaseSampler, BlendUVScale, cBaseMapBias);
	// MaterialParameters.BaseColor = DecodeGamma(samplerBase.rgb);
	
	MaterialParameters.Metallic = 0;
	MaterialParameters.Specular = 0;


	// 1.0.1 grass material layer , normal
	half2 StoneUVScaled = IN.TexCoord.xy*cStoneUVTilling;
	half4 samplerBase = tBaseMap.Sample(sBaseSampler,BaseMapUV(StoneUVScaled));
	samplerBase.rgb = DecodeGamma(samplerBase.rgb);
	half roughness = 
		( samplerBase.r+samplerBase.g + samplerBase.b ) * 
		3 * cRockRoughness;
		half2 GrassUVScaled = IN.TexCoord.xy*cGrassUVTilling;
		half LerpValue = 0;
   if(@_TANGENT&& @_NormalMapEnable)
   {
	   half3 samplerNormal = tNormalMap.Sample(sNormalSampler,BaseMapUV(StoneUVScaled)).xyz;
	samplerNormal = samplerNormal * 2 - 1 ;

	// 1.0.2 calc grass normal
	half2 BlendDetailNormalUVScaled = IN.TexCoord.xy*cDetailNormalScale;
	
	half3 additionalnormal = tMixMap.Sample(sMixSampler,BaseMapUV(BlendDetailNormalUVScaled)).xyz;
	additionalnormal.rg*= cBlendNormalIntensity;
	additionalnormal= additionalnormal*2-1;

	// 2 grass material layer
	
	half3 samplerGrassNormal = tGrassNormalMap.SampleBias(sGrassNormalSampler,BaseMapUV(GrassUVScaled),cNormalMapBias).xyz;
	samplerGrassNormal = samplerGrassNormal * 2 - 1 ;
	// // 3.0 set normal
	MaterialParameters.WorldNormal = BlendAngleCorrectedNormal(samplerNormal,additionalnormal);
	if(@_TANGENT )
	{
		MaterialParameters.WorldNormal  = MaterialParameters.WorldNormal.x * IN.WorldTangent + MaterialParameters.WorldNormal.y * IN.WorldBinormal + MaterialParameters.WorldNormal.z * IN.WorldNormal.xyz;
	}
	
			
	
	MaterialParameters.WorldNormal =normalize(MaterialParameters.WorldNormal);


	

	// 3.1.0 make lerp alpha value

	   
   }
   else
   {
	   MaterialParameters.WorldNormal = normalize(IN.WorldNormal.xyz);

   }
	
	LerpValue = saturate(
		( MaterialParameters.WorldNormal.y + cNormalBlendOffset ) * cNormalBlendHardness
	);
	// samplerBase.xyz = float3(1,0,0);
	// samplerGrass.xyz = float3(0,LerpValue,0);
	// LerpValue = 1;
	half3 samplerGrass = tGrassTextureMap.Sample(sGrassTextureMapSampler,BaseMapUV(GrassUVScaled)).xyz;
	samplerGrass.rgb = DecodeGamma(samplerGrass.rgb);
		half grassRoughness = 
		( samplerGrass.r+samplerGrass.g + samplerGrass.b ) * 
		3 * cGrassRoughness;
	// 3.1.1 lerp base color 
	MaterialParameters.BaseColor.rgb = lerp(samplerBase.rgb,samplerGrass.rgb,LerpValue);
	MaterialParameters.Roughness = 1 - lerp(roughness,grassRoughness,LerpValue);
	InitRadarEffect(IN,MaterialParameters);

}
#include "PBR_PS.fxh" 


