///	@file	<PBR_VAT_Soft.fx>
///	@date	2019/11/14
///	@brief	Vertex Animation Texture _ PBR Shader ( Soft Mode ) 20191114

#pragma shader material

///////////////choice define start///////////////////////////
#define MATERIAL_SHADINGMODEL_DEFAULT_LIT 	1 // for deferred
#define USE_LIGHTMAP						0
#define USE_LIGHTMAP_CONST					0
#define USE_CLIPPING						1
#define USE_WIREFRAME						0
#define USE_FROZEN							0
#define USE_BURNT							0
#define USE_HIGHLIGHT						0
#define USE_XRAY							0
#define USE_EDGELINE						0
#define USE_PLANAR_SHADOW					0
#define USE_VBufferGen						0
#define VIRTUAL_LIT 						0

#define ENABLE_ANIMATION_LERP				true 
#define HAS_WORLD_POSITION_OFFSET			1
#pragma shader predict("@_TANGENT", "true")
#pragma shader predict("@_CLIPPING", "false")
#pragma shader predict("@_TRANSPARENT", "false")
#pragma shader predict("@_VERTEXCOLOR", "true")
#pragma shader predict("@_INSTANCED", "false")
#pragma shader predict("@_DF_SKIN", "0")

#define NEED_SHADOWMAP_REFRESH 				(@_ShadowMapRefresh)
#define HAS_2UV								(@_LIGHT_MAP)
#define ENABLE_MIXMAP						(@_EnableReflection)
#define ENABLE_ANISOTROPIC 					(@_AnisotropicEnable)
#define ENABLE_SCREEN_SHADOWMAP				(@_CSM && @_CastSunShadow && @_LOD_LEVEL <= LOD_Level_2 && !@_TRANSPARENT)


///////////////choice define end//////////////////////////
#include "PBR_Definitions.fxh"
#include "Constants.fxh"
#include "Common.fxh"

//////////////////////////////////Properties////////////////////////////////////////
@_BaseMapEnable 
{ 
	Name = BaseMapEnable;
	Description = "Do we have BaseMap?";  
	AffectedTex = tBaseMap;
	Fallback = true;
	Visible = false;
};
@_EnableReflection 
{
	Name = EnableReflection;
	Description = "EnableReflection?";
	AffectedTex = tMixMap;
	Fallback = true;
	Visible = false;
	Default = false;
};
@_EnableIBL
{
	Name = EnableIBL;
	Description = "Enable Image based lighting?";
	Default = false;
	Visible = true;	
};
@_NormalMapEnable
{
	Name = NormalMapEnable;
	Description = "Do we have NormalMap?"; 
	AffectedTex = tNormalMap;
	Fallback = "@_TANGENT";
	Visible = false;
};
@_LightMapEnable
{
	Name = LightMapEnable;
	Description = "Do we have LightMap?";
	AffectedTex = tLightMap;
	Fallback = "@_LIGHT_MAP";
	Visible = false;
};
@_EmissionMapEnable
{
	Name = EmissionMapEnable;
	Description = "Do we have EmissionMap?";
	AffectedTex = tEmissionMap; 
	Fallback = true;
	Visible = false;
};
@_AnisotropicEnable
{
	Name = AnisotropicEnable;
	Description = "Do we need calc anisotropic lighting?";
	Visible = true;
};
@_LightmapConstEnable
{
	Name = LightmapConstEnable;
	Default = false;
	Visible = false;
};
// VAT Part
@_ShadowMapRefresh
{
	Name = ShadowMapRefresh;
	Description = "Do we need shadow map real time refresh?"; 
	Default = false;
	Visible = true;
}
@_VatNormalMapEnable
{ 
	Name = VatNormalMapEnable;
	Description = "Do we have VatNormalMap?";  
	AffectedTex = tVatNormalMap;
	Fallback = true;
	Visible = true;
};
@_ScriptCtrol
{
	Name = ScriptCtrol;
	Description = "is Controlled by Script ?";  
	Visible = true;
	Default = false;
}
//VAT Part End
//////////////////////////////////Constant buffer////////////////////////////////////////
cbuffer Shader
{
	float3 cBaseColor 				 < Widget = "LinearColor3"; > = {1, 1, 1};
	float cMetallic					 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; > = 0;	//金属度[0:1] 

	float cAliasingFactor			 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; > = 0.2;//抗锯齿因子
	float cEnvStrength				 < Widget = "FloatSlider"; Min = "0"; Max = "10"; Step = "0.01"; Precision = "2"; > = 1;	//环境强度[0:8]
	float cRoughnessLow				 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; > = 0;	//粗糙度下界
	float cRoughnessHigh			 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; > = 1;	//粗糙度上界
	
	float4 cLightMapScale			 = {1, 1, 1, 1};
	float4 cLightMapUVTransform		 = {1, 1, 0, 0};

	float  cSmoothness				 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; > = 0;
	float  cBloomScale				 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; > = 0.5;
	float  cBaseMapBias				 < Widget = "FloatSlider"; Min = "-2"; Max = "2"; Step = "0.01"; Precision = "2"; > = -1;
	float  cNormalMapBias			 < Widget = "FloatSlider"; Min = "-2"; Max = "2"; Step = "0.01"; Precision = "2"; > = -0.5;

	float4 cEmissionScale			 = {1, 1, 1, 0};
	float4 cEmissionScrolling		 = {1, 1, 0, 0};

	float cRoughnessX				 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.001"; Precision = "2"; > = 0.1;
	float cRoughnessY				 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.001"; Precision = "2"; > = 1;
	float cAnisotropicScale			 < Widget = "FloatSlider"; Min = "0"; Max = "10"; Step = "0.01"; Precision = "2"; > = 0;
	float cFogDistance				 < Widget = "FloatSlider"; Min = "0"; Max = "1000"; Step = "0.1"; Precision = "2"; > = 100;

	float cBumpIns      			 < Widget = "FloatSlider"; Min = "0"; Max = "10"; Step = "0.1"; Precision = "2"; > = 1;
	float cAlpha	      			 < Widget = "FloatSlider"; Min = "0"; Max = "10"; Step = "0.1"; Precision = "2"; > = 1.0;
	float cDepthOffset     			 < Widget = "FloatSlider"; Min = "-20"; Max = "20"; Step = "0.1"; Precision = "2"; > = 0;
	float cDepthBias	  			 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.1"; Precision = "2"; > = 0;
	float cSnowHeight	  			 < Widget = "FloatSlider"; Min = "-2"; Max = "2"; Step = "0.1"; Precision = "2"; > = 0.6;
	float cSnowDetail	  			 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.1"; Precision = "2"; > = 1;

	//VAT Part
	float cVAT_BoundingBoxMax		 = 0;
	float cVAT_BoundingBoxMin		 = 0;
	uint cVAT_NumberOfFrames		 = 24;
	float cVAT_Speed				 = 24;
	uint cVAT_SrcTextureWidth 		 = 128;
	uint cVAT_SrcTextureHeight 		 = 128;
	uint cVAT_TextureSize 			 = 128;
	float2 cPlayControl				 = {0,0}; //X -> StartTime  Y -> LoopTimes
	float4 cPlayFade				 = {0,0,1,0};// X->FadeInStart Y->FadeInDuration Z->FadeOutStart W->FadeOutDuration 
	// Vat Part End
};

//////////////////////////////////Input Texture////////////////////////////////////////
texture2D tBaseMap : layout(t0) = "White";
sampler sBaseSampler : layout(s0, s1)
{
	Texture = tBaseMap;
	Filter = Linear;
	Address = FromTexture;
	SRGB = false;
};

texture2D tMixMap : layout(t2) = "Reflection";
sampler sMixSampler : layout(s2)
{
	Texture = tMixMap;
	Filter = Linear;
	Address = Wrap;
	SRGB = false;
};

texture2D tEnvMap : EnvMap : layout(t3) = "White";
sampler sEnvSampler : layout(s3)
{
	Texture = tEnvMap;
	Filter = Linear;
	Address = Clamp;
	SRGB = false; 
};

texture2D tNormalMap : layout(t4) = "NormalMap";
sampler sNormalSampler : layout(s4)
{
	Texture = tNormalMap;
	Filter = Linear;
	Address = Wrap;
	SRGB = false;
};

// Light map
texture2D tLightMap : layout(t5);
sampler sLightMapSampler : layout(s5)
{
	Texture = tLightMap;
	Filter = Linear;
	Address = Clamp;
	SRGB = false;
	MaxMipLevel = 0;
};

texture2D tShadowMask : ShadowMask : layout(t6) = "White";
sampler sShadowMaskSampler : layout(s6)
{
	Texture = tShadowMask; 
	Filter = Point; 
	Address = Clamp;
	SRGB = false;
	MaxMipLevel = 0;
};
// ShadowMap 
texture2D tShadowMap : ShadowMap : layout(t6) = "White";
SamplerComparisonState sShadowMapSampler : layout(s6)
{
	Texture = tShadowMap;
	Filter = Linear;
	Address = Clamp;
	ComparisonFunc = Greater;
	SRGB = false;
	MaxMipLevel = 0;
};

// Emission map
texture2D tEmissionMap : layout(t7) = "Transparent";
sampler sEmissionMapSampler : layout(s7)
{
	Texture = tEmissionMap;
	Filter = Linear; 
	Address = Wrap;
	SRGB = false;
};

texture2D tRainMap : RainMap: layout(t8) = "NormalMap";
sampler sRainSampler : layout(s8)
{
	Texture = tRainMap;
	Filter = Linear;
	Address = Wrap;
	SRGB = false;
};

texture2D tSkeletonMap : SkeletonMap : layout(t3) = "Black";
sampler sSkeletonSampler : layout(s3)
{
	Texture = tSkeletonMap;
	Filter = Point;
	Address = Clamp;
	SRGB = false;
};

// VAT Part
texture2D tVatPosMap : layout(t10) = "Black";
sampler sVatPosSampler : layout(s10)
{
	Texture = tVatPosMap;
	Filter = Point;
	Address = Wrap;
	SRGB = false;
};
texture2D tVatNormalMap : layout(t11) = "Black";
sampler sVatNormalSampler : layout(s11)
{
	Texture = tVatNormalMap;
	Filter = Point;
	Address = Wrap;
	SRGB = false;
};
// VAT Part End



//////////////////////////////////VS////////////////////////////////////////
#include "PBR_VS.fxh"
#include "Lighting.fxh"
void GetLocalPositionOffset(in VertexAssemble IN, out float3 offset, out float Overtime, out float Alpha)
{	
	// Called in PBR_VAT_Soft.fx for Vertex Position;
	// Called in PBR_PS.fxh for Getting Dynamic Shadow;
	// Controlled by #NEED_SHADOWMAP_REFRESH #VAT_HAS_POSITION_CHANGED;
	if(@_LIGHT_MAP)
	{
		half2 ScaledSize = half2(cVAT_SrcTextureWidth,cVAT_SrcTextureHeight) / cVAT_TextureSize;
		half DiscreteTime = 0;
		half isOvertime = 1;
		half alphaControl = 1;	
		half duration = cVAT_NumberOfFrames / cVAT_Speed;
		if(@_ScriptCtrol)
		{
			half4 FadeControl = saturate(cPlayFade);
			isOvertime = step(GameTime , cPlayControl.x + (cPlayControl.y - 1 + FadeControl.z + FadeControl.w) * duration);
			half isPlay = step(GameTime , cPlayControl.x + cPlayControl.y * duration - 1 / cVAT_Speed);

			DiscreteTime = frac((GameTime - cPlayControl.x) / duration);
			DiscreteTime = lerp(1-1.0/cVAT_NumberOfFrames,DiscreteTime,isPlay);
			half DiscreteSrcTime2 = frac((GameTime - cPlayControl.x) / duration - FadeControl.z);

			half State = step(DiscreteTime,FadeControl.z);
			
			half AnimFadeIn = smoothstep(FadeControl.x,FadeControl.x+FadeControl.y,DiscreteTime);
			half AnimFadeOut = 1-smoothstep(0,FadeControl.w, DiscreteSrcTime2);
			
			[@_TRANSPARENT]
			alphaControl = saturate(State * AnimFadeIn + (1-State) * AnimFadeOut);
		}
		else
		{
			DiscreteTime = frac(GameTime / duration);
		}
		
		half timeInFrames = ((floor(DiscreteTime * cVAT_NumberOfFrames)) / cVAT_NumberOfFrames);
		half timeInFrames2 = timeInFrames + 1.0 / (half)cVAT_NumberOfFrames;

		half4 texturePos1 = tVatPosMap.SampleLevel(sVatPosSampler ,half2(IN.TexCoord2.x * ScaledSize.x,(timeInFrames + IN.TexCoord2.y)*ScaledSize.y),0); // Work But Scale
		half4 texturePos = texturePos1;

		if(ENABLE_ANIMATION_LERP)
		{
			half4 texturePos2 = tVatPosMap.SampleLevel(sVatPosSampler ,half2(IN.TexCoord2.x * ScaledSize.x,frac(timeInFrames2 + IN.TexCoord2.y)*ScaledSize.y),0); 
			half LerpValue = (DiscreteTime - timeInFrames) / (timeInFrames2 - timeInFrames);
			texturePos = lerp(texturePos1, texturePos2, LerpValue);
		}
		
		//Transform To LocalSpace
		half expand = cVAT_BoundingBoxMax - cVAT_BoundingBoxMin;
		texturePos.xyz  *= (expand / 1000) ;
		texturePos.xyz += cVAT_BoundingBoxMin / 1000;
		texturePos.xy *= -1;
		texturePos.xyz = texturePos.xzy;


		//output Local Position Offset
		offset = texturePos.xyz;
		Alpha = alphaControl;
		Overtime = isOvertime;

	}
	else
	{
		offset = float3(0,0,0);
		Alpha = 1;
		Overtime = 0;
	}
}

//Called with HAS_WORLD_POSITION_OFFSET
float3 WorldPositionOffset(in VertexAssemble IN, in float3 pos, in float3 normal)
{
	if(@_ShadowMapRefresh)
	{	
		float3 localPositionOffset = float3(0,0,0);
		float alpha = 0;
		float Overtime = 0;
		float3 worldPosition = float3(0,0,0);
		GetLocalPositionOffset(IN,localPositionOffset,Overtime,alpha);

		if(@_INSTANCED)
			worldPosition = Matrix4x3TransformP(IN.Transform0, IN.Transform1, IN.Transform2, IN.Position.xyz + localPositionOffset.xyz);
		else
			worldPosition = MulMat3x4(World, float4(IN.Position.xyz + localPositionOffset.xyz, 1)).xyz;

		return worldPosition.xyz-pos.xyz;
	}
	else
		return float3(0,0,0);
}
float3 GetWorldNormal(in VertexAssemble IN,in float3 srcNormal)
{
	if(@_LIGHT_MAP && @_VatNormalMapEnable)
	{
		half2 ScaledSize = half2(cVAT_SrcTextureWidth,cVAT_SrcTextureHeight) / cVAT_TextureSize;
		half DiscreteTime = 0;
		float duration = cVAT_NumberOfFrames / cVAT_Speed;
		if(@_ScriptCtrol)
		{
			float4 FadeControl = cPlayFade;
			FadeControl = saturate(FadeControl);
			half isPlay = step(GameTime , cPlayControl.x + cPlayControl.y * duration - 1 / cVAT_Speed);
			DiscreteTime = frac((GameTime - cPlayControl.x) / duration);
			DiscreteTime = lerp(1-2.0/cVAT_NumberOfFrames,DiscreteTime,isPlay);
		}
		else
			DiscreteTime = frac(GameTime / duration);

		half timeInFrames = ((floor(DiscreteTime * cVAT_NumberOfFrames)) / cVAT_NumberOfFrames);
		half timeInFrames2 = timeInFrames + 1.0 / (half)cVAT_NumberOfFrames;

		half3 textureN1 =  tVatNormalMap.SampleLevel(sVatNormalSampler ,half2(IN.TexCoord2.x * ScaledSize.x,(timeInFrames + IN.TexCoord2.y)* ScaledSize.y),0).xyz; 
		half3 textureN = textureN1;
		
		// Double sample for better effect
		if(ENABLE_ANIMATION_LERP)
		{
			half3 textureN2 =  tVatNormalMap.SampleLevel(sVatNormalSampler ,half2(IN.TexCoord2.x * ScaledSize.x,frac(timeInFrames2 + IN.TexCoord2.y) * ScaledSize.y),0).xyz; 
			half LerpValue = (DiscreteTime - timeInFrames) / (timeInFrames2 - timeInFrames);
			textureN = lerp(textureN1, textureN2, LerpValue);
		}
		
		//Transform from textureInfo To LocalSpace then WorldSpace
		textureN = textureN * 2 - 1;
		textureN.xy *= -1;
		textureN.xyz = textureN.xzy;
		textureN = normalize(MulMat3x4((float3x3)World,textureN).xyz);

		return textureN.xyz;
	}
	else
	{
		//VAT Asset Must Have UV2(@_LIGHT_MAP)
		float3 LocalNormal = (float3)Expand((half3)IN.Normal.xyz);
		return normalize(MulMat3x4((float3x3)World,LocalNormal).xyz);

	}
}

void VS_DIY_OUTPUT(in VertexAssemble IN, in InterMediateVertex INTM, inout VertexShadingOutput OUT)
{
	
	// 1. init tint color
	InitTintColorCommon(IN, OUT); 

	// 2. for snow height calc
	OUT.WorldPosition.w = IN.Position.y;

	// 3. init emmision uv; if not need emmision uv
	InitEmissionUVCommon(IN, OUT);

	// 4. hposition calc
	//Modified from InitHPositionCommon()
	float3 localPositionOffset = float3(0,0,0);
	half alpha = 0;
	half Overtime = 0;
	GetLocalPositionOffset(IN,localPositionOffset,Overtime,alpha);
	OUT.TintColor.x = alpha;
	OUT.WorldNormal.xyz = GetWorldNormal(IN,OUT.WorldNormal.xyz);

	if(@_INSTANCED)
	{
		OUT.WorldPosition = float4(Matrix4x3TransformP(IN.Transform0, IN.Transform1, IN.Transform2, INTM.LocalPosition.xyz + localPositionOffset.xyz), 1);
		OUT.HPosition = MulMat4x4(ViewProj, float4(OUT.WorldPosition.xyz, 1.0)) * Overtime;
	}
	else
	{
		//world * VP leads to jitter issues(>2000), we use local * WVP instead.	 <-Src PBR.fx
		OUT.HPosition = MulMat4x4(WorldViewProj, float4((INTM.LocalPosition.xyz + localPositionOffset.xyz), 1)) * Overtime;
	}

	if (@_NoNearPlaneClip)
	{
		OUT.HPosition.w = max(OUT.HPosition.w, EPSILON);
		OUT.HPosition.z = min(OUT.HPosition.z, (1-OUT.HPosition.w*CameraInfo.z)*OUT.HPosition.w);
	}

	if(@_NoFarPlaneClip)
	{
		OUT.HPosition.z = max(OUT.HPosition.z, EPSILON*OUT.HPosition.w);
		
		//overwrite Fog T
		OUT.DiffLighting.w = FogTransmittance(normalize(OUT.ViewDirection.xyz) * cFogDistance);
	}

}

#include "PBR_Common.fxh"

//////////////////////////////////PS////////////////////////////////////////
void PS_GetParameters(in VertexShadingOutput IN, out MaterialShadingParameters MaterialParameters)
{
	float Alpha = IN.TintColor.x;
	IN.TintColor.x = 1;
	
	// 1. init MaterialParameters (always need)
	InitShadingParameters(MaterialParameters);

	// 2. init MaterialParameters.BaseColor and MaterialParameters.Alpha by sample basemap
	InitBaseColorCommon(IN, MaterialParameters);
	
	// 3. init smoothness/metal/ao by sample mixmap
	InitSmoothnessMetalAO(IN, MaterialParameters);
	
	// 4. init MaterialParameters.WorldNormal by sample normalmap
	InitWorldNormal(IN, MaterialParameters);

	// 5. init MaterialParameters.Emission by sample emissinMap (if need or not)
	InitEmission(IN, MaterialParameters);
	
	// 6. init anisotropic by use cRoughnessX/cRoughnessY/cAnisotropicScale (if need or not)
	InitAnisotropic(IN, MaterialParameters);

	MaterialParameters.Alpha = Alpha;


}
#include "PBR_PS.fxh"


