#pragma shader material

///////////////choice define start///////////////////////////
#define MATERIAL_SHADINGMODEL_DEFAULT_LIT 	1 // for deferred
#define USE_LIGHTMAP						1
#define USE_LIGHTMAP_CONST					1
#define USE_CLIPPING						1
#define USE_WIREFRAME						1
#define USE_FROZEN							1
#define USE_BURNT							1
#define USE_HIGHLIGHT						1
#define USE_XRAY							1
#define USE_EDGELINE						1
#define USE_PLANAR_SHADOW					0
#define USE_VBufferGen						1
#define VIRTUAL_LIT 						0
#pragma shader predict("@_TANGENT", "true")
#pragma shader predict("@_CLIPPING", "false")
#pragma shader predict("@_TRANSPARENT", "false")
#pragma shader predict("@_VERTEXCOLOR", "true")
#pragma shader predict("@_INSTANCED", "false")
#pragma shader predict("@_DF_SKIN", "0")

#define HAS_2UV								(@_LIGHT_MAP)
#define ENABLE_MIXMAP						(@_EnableReflection)
#define ENABLE_ANISOTROPIC 					(@_AnisotropicEnable)
#define ENABLE_RIPPLE 						(@_RIPPLE)
#define ENABLE_SCREEN_SHADOWMAP				(@_CSM && @_CastSunShadow && @_LOD_LEVEL <= LOD_Level_2 && !@_TRANSPARENT)
#define ENABLE_HIGHLIGHT					(@_HighlightEnable) // deferred
#define ENABLE_BURNT						(@_BurntEnable) // deferred
#define USE_SHADOWMAP_SAMPLE				((@_LOD_LEVEL <= LOD_Level_2 && @_CastSunShadow) && (@_TRANSPARENT || (!@_CSM && @_REC_SHADOW)))
#define DEFERRED_PRE_AO						1 // 是否走ao
#define USE_PLAYER_SHADOWMAP				1 // 全是在开csm下有效的
///////////////choice define end//////////////////////////

#include "PBR_Definitions.fxh"
#include "Constants.fxh"
#include "Common.fxh"
//////////////////////////////////Properties////////////////////////////////////////
@_BaseMapEnable 
{ 
	Name = BaseMapEnable;
	Description = "Do we have BaseMap?";  
	AffectedTex = tBaseMap;
	Fallback = true;
	Visible = false;
};
@_EnableReflection 
{
	Name = EnableReflection;
	Description = "EnableReflection?";
	AffectedTex = tMixMap;
	Fallback = true;
	Visible = false;
	Default = false;
};
@_EnableIBL
{
	Name = EnableIBL;
	Description = "Enable Image based lighting?";
	Default = false;
	Visible = true;	
};
@_NormalMapEnable
{
	Name = NormalMapEnable;
	Description = "Do we have NormalMap?"; 
	AffectedTex = tNormalMap;
	Fallback = "@_TANGENT";
	Visible = false;
};
@_LightMapEnable
{
	Name = LightMapEnable;
	Description = "Do we have LightMap?";
	AffectedTex = tLightMap;
	Fallback = "@_LIGHT_MAP";
	Visible = false;
	Predict = true;
};
@_EmissionMapEnable
{
	Name = EmissionMapEnable;
	Description = "Do we have EmissionMap?";
	AffectedTex = tEmissionMap; 
	Fallback = true;
	Visible = false;
};
@_AnisotropicEnable
{
	Name = AnisotropicEnable;
	Description = "Do we need calc anisotropic lighting?";
	Visible = true;
	Predict = false;
	Default = false;
};
@_LightmapConstEnable
{
	Name = LightmapConstEnable;
	Default = false;
	Visible = false;
	Predict = false;
};
@_IsFootprint
{
	Name = IsFootprint;
	Description = "Footprint material has fade out effect";
	Default = false;
	Visible = true;
	Predict = false;
};
@_HighlightEnable
{
	Name = HighlightEnable;
	Description = "for deferred pipeline change highlight pass";
	Default = false;
	Predict = false;
};
@_FrozenEnable
{
	Name = FrozenEnable;
	Description = "for deferred pipeline change frozen pass";
	Default = false;
	Predict = false;
};
@_BurntEnable
{
	Name = BurntEnable;
	Description = "for deferred pipeline change burnt pass";
	Default = false;
	Predict = false;
};
@_WeaponHighLight
{
	Name = WeaponHighLight;
	Description = "for WeaponHighlight";
	Default = false;
	Predict = false;
};
@_WeaponPreview
{
	Name = WeaponPreview;
	Description = "for WeaponPreview";
	Default = false;
	Predict = false;
};
//////////////////////////////////Constant buffer////////////////////////////////////////
cbuffer Shader
{
	float3 cBaseColor 				: layout(c0.x) < Widget = "LinearColor3"; > = {1, 1, 1};
	float cMetallic					: layout(c0.w) < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; > = 0;	//金属度[0:1] 

	float cAliasingFactor			: layout(c1.x) < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; > = 0.2;//抗锯齿因子
	float cEnvStrength				: layout(c1.y) < Widget = "FloatSlider"; Min = "0"; Max = "10"; Step = "0.01"; Precision = "2"; > = 1;	//环境强度[0:8]
	float cRoughnessLow				: layout(c1.z) < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; > = 0;	//粗糙度下界
	float cRoughnessHigh			: layout(c1.w) < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; > = 1;	//粗糙度上界
	
	float4 cLightMapScale			: layout(c2) = {1, 1, 1, 1};
	float4 cLightMapUVTransform		: layout(c3) = {1, 1, 0, 0};

	float  cSmoothness				: layout(c4.x) < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; > = 0;
	float  cBloomScale				: layout(c4.y) < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; > = 0.5;
	float  cBaseMapBias				: layout(c4.z) < Widget = "FloatSlider"; Min = "-2"; Max = "2"; Step = "0.01"; Precision = "2"; > = -1;
	float  cNormalMapBias			: layout(c4.w) < Widget = "FloatSlider"; Min = "-2"; Max = "2"; Step = "0.01"; Precision = "2"; > = -0.5;

	float4 cEmissionScale			: layout(c5) = {1, 1, 1, 0};
	float4 cEmissionScrolling		: layout(c6) = {1, 1, 0, 0};

	float cRoughnessX				: layout(c7.x) < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.001"; Precision = "2"; > = 0.1;
	float cRoughnessY				: layout(c7.y) < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.001"; Precision = "2"; > = 1;
	float cAnisotropicScale			: layout(c7.z) < Widget = "FloatSlider"; Min = "0"; Max = "10"; Step = "0.01"; Precision = "2"; > = 0;
	float cFogDistance				: layout(c7.w) < Widget = "FloatSlider"; Min = "0"; Max = "1000"; Step = "0.1"; Precision = "2"; > = 100;

	float cBumpIns      			: layout(c8.x) < Widget = "FloatSlider"; Min = "0"; Max = "10"; Step = "0.1"; Precision = "2"; > = 1;
	float cAlpha	      			: layout(c8.y) < Widget = "FloatSlider"; Min = "0"; Max = "10"; Step = "0.1"; Precision = "2"; > = 1.0;
	float cDepthOffset     			: layout(c8.z) < Widget = "FloatSlider"; Min = "-20"; Max = "20"; Step = "0.1"; Precision = "2"; > = 0;
	float cDepthBias	  			: layout(c8.w) < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.1"; Precision = "2"; > = 0;
	float cSnowHeight	  			: layout(c9.x) < Widget = "FloatSlider"; Min = "-2"; Max = "2"; Step = "0.1"; Precision = "2"; > = 0.6;
	float cSnowDetail	  			: layout(c9.y) < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.1"; Precision = "2"; > = 1;
	float cBiasFarAwayShadow		: layout(c9.z) < Widget = "FloatSlider"; Min = "0"; Max = "10"; Step = "0.1"; Precision = "3"; > = 0.01;
	float cWeaponAnimation			: layout(c9.w) = {0};
	float3 cWaterColor				: layout(c10.x)  < Widget = "LinearColor3"; > = {0.1, 0.07, 0.05};
	float cBlendColorAdjustment		: layout(c10.w) ={2};
	float c2stUVScale				: layout(c11.x) ={1};	
	float cUVScale					: layout(c11.y) ={1};	
	float cWaterDeep				: layout(c11.z) ={1};	
};

//////////////////////////////////Input Texture////////////////////////////////////////
texture2D tBaseMap : layout(t0) = "White";
sampler sBaseSampler : layout(s0)
{
	Texture = tBaseMap;
	Filter = Linear;
	Address = FromTexture;
	SRGB = false;
};

texture2D tMixMap : layout(t1) = "Reflection";
sampler sMixSampler : layout(s1)
{
	Texture = tMixMap;
	Filter = Linear;
	Address = Wrap;
	SRGB = false;
};

texture2D tEnvMap : EnvMap : layout(t2) = "White";
sampler sEnvSampler : layout(s2)
{
	Texture = tEnvMap;
	Filter = Linear;
	Address = Clamp;
	SRGB = false; 
};

texture2D tNormalMap : layout(t3) = "NormalMap";
sampler sNormalSampler : layout(s3)
{
	Texture = tNormalMap;
	Filter = Linear;
	Address = Wrap;
	SRGB = false;
};

// Light map
texture2D tLightMap : layout(t4);
sampler sLightMapSampler : layout(s4)
{
	Texture = tLightMap;
	Filter = Linear;
	Address = Clamp;
	SRGB = false;
	MaxMipLevel = 0;
};

texture2D tShadowMask : ShadowMask : layout(t5) = "White";
sampler sShadowMaskSampler : layout(s5)
{
	Texture = tShadowMask; 
	Filter = Point; 
	Address = Clamp;
	SRGB = false;
	MaxMipLevel = 0;
};
// ShadowMap 
texture2D tShadowMap : ShadowMap : layout(t6) = "White";
SamplerComparisonState sShadowMapSampler : layout(s6)
{
	Texture = tShadowMap;
	Filter = Linear;
	Address = Clamp;
	ComparisonFunc = Greater;
	SRGB = false;
	MaxMipLevel = 0;
};

// Emission map
texture2D tEmissionMap : layout(t7) = "Transparent";
sampler sEmissionMapSampler : layout(s7)
{
	Texture = tEmissionMap;
	Filter = Linear; 
	Address = Wrap;
	SRGB = false;
};

texture2D tRainMap : RainMap: layout(t8) = "NormalMap";
sampler sRainSampler : layout(s8)
{
	Texture = tRainMap;
	Filter = Linear;
	Address = Wrap;
	SRGB = false;
};
texture2D t2stBaseMap : layout(t9) = "BaseColor";
sampler s2stBaseSampler : layout(s9)
{
	Texture = t2stBaseMap;
	Filter = Linear;
	Address = Wrap;
	SRGB = false;
};
texture2D t2stMixMap : layout(t11) = "BaseColor";
sampler s2stMixSampler : layout(s11)
{
	Texture = t2stMixMap;
	Filter = Linear;
	Address = Wrap;
	SRGB = false;
};
texture2D t2stNormalMap : layout(t10) = "NormalMap";
sampler s2stNormalSampler : layout(s10)
{
	Texture = t2stNormalMap;
	Filter = Linear;
	Address = Wrap;
	SRGB = false;
};

texture2D tSkeletonMap : SkeletonMap : layout(t3) = "Black";
sampler sSkeletonSampler : layout(s3)
{
	Texture = tSkeletonMap;
	Filter = Point;
	Address = Clamp;
	SRGB = false;
};
texture2D tGTAOMap : GIMap : layout(t5) = "White";
sampler sGTAOSampler : layout(s5)
{
	Texture = tGTAOMap;
	Filter = Point;
	Address = Clamp;
	SRGB = false;
};
#include "PBR_VS.fxh"
//////////////////////////////////VS////////////////////////////////////////
void VS_DIY_OUTPUT(in VertexAssemble IN, in InterMediateVertex INTM, inout VertexShadingOutput OUT)
{
	// 1. init tint color
	InitTintColorCommon(IN, OUT); 

	// 2. for snow height calc
	OUT.WorldPosition.w = IN.Position.y;

	// 3. init emmision uv; if not need emmision uv
	InitEmissionUVCommon(IN, OUT);

	// 4. hposition calc
	InitHPositionCommon(INTM, OUT); // init hposition calc

	if(@_CastSunShadow && @_TRANSPARENT)
	{
		// for player's shadow		
		OUT.LitUVZ2 = MulMat4x4(ShadowViewProjTexs0, float4(OUT.WorldPosition.xyz + 
		OUT.WorldNormal.xyz * cBiasFarAwayShadow,1));
	}
}
#include "PBR_Common.fxh"
//////////////////////////////////PS////////////////////////////////////////


void PS_GetParameters(in VertexShadingOutput IN, out MaterialShadingParameters MaterialParameters)
{
	// 1. init MaterialParameters (always need)
	InitShadingParameters(MaterialParameters);
	
	half2 baseUVScale = IN.TexCoord*cUVScale;
	half2 blendUVScale = IN.TexCoord*c2stUVScale;
	// 2. init MaterialParameters.BaseColor and MaterialParameters.Alpha by sample basemap
	half4 samplerBase;
	samplerBase = tBaseMap.SampleBias(sBaseSampler, BaseMapUV(baseUVScale), cBaseMapBias);
	samplerBase.rgb = DecodeGamma(samplerBase.rgb);
	
	half4 blendColor = t2stBaseMap.SampleBias(s2stBaseSampler, blendUVScale, cBaseMapBias);
	blendColor.rgb *=blendColor.rgb;
	// footprint fade out effect
	if (@_IsFootprint && @_INSTANCED)
	{
		MaterialParameters.Alpha *= saturate((IN.LightMapScale.x - GameTime) / IN.LightMapScale.y);
	}
	half3 blendVale = half3(0,0,0);

	if(@_VERTEXCOLOR )
	{
		blendVale = IN.TintColor*2;
		blendVale= saturate(max(samplerBase.a,blendColor.a)+1 -blendVale) ;
	}
	// 3. init smoothness/metal/ao by sample mixmap
	if (@_EnableReflection && @_LOD_LEVEL <= LOD_Level_2)
	{
		
		half3 samplerMis = tMixMap.Sample(sMixSampler, BaseMapUV(baseUVScale)).rgb;

		if(@_LOD_LEVEL <= LOD_Level_1)
		{
		half3 blendMix = t2stMixMap.SampleBias(s2stMixSampler, blendUVScale, cBaseMapBias);
		half3 waterMix = half3(1,0,1);
		samplerMis = lerp(samplerMis,blendMix,blendVale.r);
		samplerMis = lerp(waterMix,samplerMis,blendVale.g);
		}

		half Smoothness = samplerMis.r;
		MaterialParameters.Metallic = samplerMis.g;
		MaterialParameters.AO = samplerMis.b;
		if (@_LOD_LEVEL == LOD_Level_2)
		{
			MaterialParameters.Metallic = lerp(cMetallic, MaterialParameters.Metallic, LOD_RATE);
			Smoothness = lerp(cSmoothness, Smoothness, LOD_RATE);
		}
		MaterialParameters.Roughness = lerp(cRoughnessHigh, cRoughnessLow, Smoothness);
	}
	else	
	{
		MaterialParameters.Metallic = cMetallic;
		if(ENABLE_MIXMAP || @_DEFERRED_SHADING)
			MaterialParameters.Roughness = lerp(cRoughnessHigh, cRoughnessLow, cSmoothness);
	}
	
	


	// 4. init MaterialParameters.WorldNormal by sample normalmap
	// InitWorldNormal(IN, MaterialParameters);
	
		
	if(@_TANGENT && @_NormalMapEnable && @_LOD_LEVEL <= LOD_Level_1)
	{
		half3 tangentNormal = tNormalMap.SampleBias(sNormalSampler, BaseMapUV(baseUVScale), cNormalMapBias).xyz;
		half3 blendNormal = half3(0.5,0.5,1);
	
		
		[@_DIRECTX]//always use bc5 for pc
		tangentNormal.z = 1;
	
	
			blendNormal =t2stNormalMap.SampleBias(s2stNormalSampler, blendUVScale, cNormalMapBias).xyz;
			tangentNormal =lerp(half3(0.5,0.5,1),lerp(tangentNormal,blendNormal,blendVale.r),blendVale.g) ;
		

		tangentNormal = (2 * tangentNormal) - 1;

			if (ENABLE_RIPPLE)
		{
			
			Ripple(IN, MaterialParameters, tangentNormal, 1);
		}
		if (@_LOD_LEVEL == LOD_Level_1)
			tangentNormal.xy *= LOD_RATE;
		//tangentNormal.xy *= cBumpIns;
		MaterialParameters.WorldNormal = tangentNormal.x * IN.WorldTangent + tangentNormal.y * IN.WorldBinormal + tangentNormal.z * IN.WorldNormal.xyz;
		MaterialParameters.WorldNormal = normalize(MaterialParameters.WorldNormal);

	}
	else
	{
		if (@_LOD_LEVEL <= LOD_Level_2)
			MaterialParameters.WorldNormal = normalize(IN.WorldNormal.xyz);
		else
			MaterialParameters.WorldNormal = IN.WorldNormal.xyz;
	}
		half fresnel  = saturate(dot(IN.WorldNormal, normalize(-IN.ViewDirection) ));
	fresnel = (1-fresnel)+0.2;
	
	fresnel = pow(fresnel,1-cWaterDeep);
	
	MaterialParameters.BaseColor  = lerp(lerp(samplerBase.rgb,blendColor.rgb,blendVale.r),cWaterColor, saturate((1-blendVale.g)*fresnel) ) ;

	// MaterialParameters.BaseColor  =blendVale.rgb;



	

	// 5. init MaterialParameters.Emission by sample emissinMap (if need or not)
	InitEmission(IN, MaterialParameters);
	
	// 6. init anisotropic by use cRoughnessX/cRoughnessY/cAnisotropicScale (if need or not)
	InitAnisotropic(IN, MaterialParameters);
	InitRain(IN, MaterialParameters);
}
#include "PBR_PS.fxh"


