#pragma shader material

///////////////choice define start///////////////////////////
#define MATERIAL_SHADINGMODEL_DEFAULT_LIT 	1 // for deferred
#define USE_LIGHTMAP						1
#define USE_LIGHTMAP_CONST					0
#define USE_CLIPPING						1
#define USE_WIREFRAME						1
#define USE_FROZEN							1
#define USE_BURNT							1
#define USE_HIGHLIGHT						1
#define USE_XRAY							1
#define USE_EDGELINE						1
#define USE_PLANAR_SHADOW					0
#define USE_VBufferGen						1
#define VIRTUAL_LIT 						1
#pragma shader predict("@_TANGENT", "true")
#pragma shader predict("@_CLIPPING", "false")
#pragma shader predict("@_TRANSPARENT", "false")
#pragma shader predict("@_VERTEXCOLOR", "true")
#pragma shader predict("@_INSTANCED", "false")
#pragma shader predict("@_DF_SKIN", "0")
#define HAS_2UV								(@_LIGHT_MAP)
#define ENABLE_MIXMAP						(@_EnableReflection)
#define ENABLE_ANISOTROPIC 					(@_AnisotropicEnable)
#define ENABLE_RIPPLE 						0
#define ENABLE_SCREEN_SHADOWMAP				(@_CSM && @_CastSunShadow && @_LOD_LEVEL <= LOD_Level_2 && !@_TRANSPARENT)
#define ENABLE_HIGHLIGHT					(@_HighlightEnable) // deferred
#define ENABLE_BURNT						(@_BurntEnable) // deferred
#define USE_SHADOWMAP_SAMPLE				((@_LOD_LEVEL <= LOD_Level_2 && @_CastSunShadow) && (@_TRANSPARENT || (!@_CSM && @_REC_SHADOW)))
#define DEFERRED_PRE_AO						1 // 是否走ao
#define USE_PLAYER_SHADOWMAP				1 // 全是在开csm下有效的
///////////////choice define end//////////////////////////

#include "PBR_Definitions.fxh"
#include "Constants.fxh"
#include "Common.fxh"
//////////////////////////////////Properties////////////////////////////////////////
@_BaseMapEnable 
{ 
	Name = BaseMapEnable;
	Description = "Do we have BaseMap?";  
	AffectedTex = tBaseMap;
	Fallback = true;
	Visible = false;
};
@_EnableReflection 
{
	Name = EnableReflection;
	Description = "EnableReflection?";
	AffectedTex = tWaterMixMask;
	Fallback = true;
	Visible = false;
	Default = false;
};
@_EnableIBL
{
	Name = EnableIBL;
	Description = "Enable Image based lighting?";
	Default = false;
	Visible = true;	
};
@_NormalMapEnable
{
	Name = NormalMapEnable;
	Description = "Do we have NormalMap?"; 
	AffectedTex = tNormalMap;
	Fallback = "@_TANGENT";
	Visible = false;
};
@_LightMapEnable
{
	Name = LightMapEnable;
	Description = "Do we have LightMap?";
	AffectedTex = tLightMap;
	Fallback = "@_LIGHT_MAP";
	Visible = false;
};
@_EmissionMapEnable
{
	Name = EmissionMapEnable;
	Description = "Do we have EmissionMap?";
	AffectedTex = tEmissionMap; 
	Fallback = true;
	Visible = false;
};
@_AnisotropicEnable
{
	Name = AnisotropicEnable;
	Description = "Do we need calc anisotropic lighting?";
	Visible = true;
};
@_LightmapConstEnable
{
	Name = LightmapConstEnable;
	Default = false;
	Visible = false;
};
@_IsFootprint
{
	Name = IsFootprint;
	Description = "Footprint material has fade out effect";
	Default = false;
	Visible = true;
};
@_HighlightEnable
{
	Name = HighlightEnable;
	Description = "for deferred pipeline change highlight pass";
	Default = false;
};
@_FrozenEnable
{
	Name = FrozenEnable;
	Description = "for deferred pipeline change frozen pass";
	Default = false;
};
@_BurntEnable
{
	Name = BurntEnable;
	Description = "for deferred pipeline change burnt pass";
	Default = false;
};
@_WithMaskMap
{
	Name = WithMaskMap;
	Description = "WithMaskMap?";
	AffectedTex = tWaterMixMask;
	Default = true;
	Visible = false;
};
@_WithWaterNormal
{
	Name = WithWaterNormal;
	Description = "WithWaterNormal?";
	AffectedTex = tWaterNormal;
	Default = true;
	Visible = false;
};
@_WithWaterFallFoam02
{
	Name = WithWaterFallFoam02;
	Description = "WithWaterFallFoam02?";
	AffectedTex = tWaterFallFoam02;
	Default = false;
	Visible = false;
};
//////////////////////////////////Constant buffer////////////////////////////////////////
cbuffer Shader
{
	float cAliasingFactor			 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; > = 0.2;//抗锯齿因子
	float cEnvStrength				 < Widget = "FloatSlider"; Min = "0"; Max = "10"; Step = "0.01"; Precision = "2"; > = 1;	//环境强度[0:8]
	float cRoughnessLow				 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; > = 0;	//粗糙度下界
	float cRoughnessHigh			 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; > = 1;	//粗糙度上界	
	float4 cLightMapScale			 = {1, 1, 1, 1};
	float4 cLightMapUVTransform		 = {1, 1, 0, 0};
	float  cSmoothness				 < Widget = "FloatSlider"; Min = "0"; Max = "100"; Step = "0.01"; Precision = "2"; > = 0;
	float  cBloomScale				 < Widget = "FloatSlider"; Min = "0"; Max = "100"; Step = "0.01"; Precision = "2"; > = 0.5;
	float  cBaseMapBias				 < Widget = "FloatSlider"; Min = "-2"; Max = "200"; Step = "0.01"; Precision = "2"; > = -1;
	float  cNormalMapBias			 < Widget = "FloatSlider"; Min = "-2"; Max = "200"; Step = "0.01"; Precision = "2"; > = -0.5;
	// float cLinkWithWater			 < Widget = "FloatSlider"; Min = "0"; Max = "2"; Step = "0.01"; Precision = "2"; > = 1;
	float cWaterFallNormalInt		 < Widget = "FloatSlider"; Min = "0"; Max = "100"; Step = "0.001"; Precision = "2"; > = 1;
	float cWaterNormalInt			 < Widget = "FloatSlider"; Min = "0"; Max = "100"; Step = "0.01"; Precision = "2"; > = 0.25;
	float cWaterNormalUVx			 < Widget = "FloatSlider"; Min = "0"; Max = "100"; Step = "0.01"; Precision = "2"; > = 0;
	float cWaterNormalUVy			 < Widget = "FloatSlider"; Min = "0"; Max = "100"; Step = "0.01"; Precision = "2"; > = 0;
	float4 cBaseColor 				 < Widget = "LinearColor"; > = {1, 1, 1, 1};
	float4 cWaterColor				 < Widget = "LinearColor"; > = {1, 1, 1, 1};
	float cFoamFalloff				 < Widget = "FloatSlider"; Min = "0"; Max = "200"; Step = "0.01"; Precision = "2"; > = 0.1;
	float cEdgeMaskTilingX			 < Widget = "FloatSlider"; Min = "0"; Max = "300"; Step = "0.01"; Precision = "2"; > = 0.5;
	float cEdgeMaskTilingY			 < Widget = "FloatSlider"; Min = "0"; Max = "300"; Step = "0.01"; Precision = "2"; > = 0.5;
	float cEdgeMaskSpeed			 < Widget = "FloatSlider"; Min = "0"; Max = "100"; Step = "0.01"; Precision = "2"; > = 2;
	float cDirectionalFoam1TilingX	 < Widget = "FloatSlider"; Min = "0"; Max = "300"; Step = "0.01"; Precision = "2"; > = 0.75;
	float cDirectionalFoam1TilingY	 < Widget = "FloatSlider"; Min = "0"; Max = "300"; Step = "0.01"; Precision = "2"; > = 0.75;
	float cDirectionalFoamSpeed		 < Widget = "FloatSlider"; Min = "0"; Max = "100"; Step = "0.01"; Precision = "2"; > = 6;
	float cDirectionalFoam1Intensity < Widget = "FloatSlider"; Min = "0"; Max = "800"; Step = "0.01"; Precision = "2"; > = 2;
	float cDirectionalFoam2Intensity < Widget = "FloatSlider"; Min = "0"; Max = "800"; Step = "0.01"; Precision = "2"; > = 2;
	float cVolumeOfWater			 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.01"; Precision = "2"; > = 1;
	float cFogDistance				 < Widget = "FloatSlider"; Min = "0"; Max = "1000"; Step = "0.1"; Precision = "2"; > = 100;
	float cBumpIns      			 < Widget = "FloatSlider"; Min = "0"; Max = "10"; Step = "0.1"; Precision = "2"; > = 1;
	float cAlpha	      			 < Widget = "FloatSlider"; Min = "0"; Max = "10"; Step = "0.1"; Precision = "2"; > = 1.0;
	float cDepthOffset     			 < Widget = "FloatSlider"; Min = "-20"; Max = "20"; Step = "0.1"; Precision = "2"; > = 0;
	float cDepthBias	  			 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.1"; Precision = "2"; > = 0;
	float cSnowHeight	  			 < Widget = "FloatSlider"; Min = "-2"; Max = "2"; Step = "0.1"; Precision = "2"; > = 0.6;
	float cSnowDetail	  			 < Widget = "FloatSlider"; Min = "0"; Max = "1"; Step = "0.1"; Precision = "2"; > = 1;
	float cBiasFarAwayShadow		 < Widget = "FloatSlider"; Min = "0"; Max = "10"; Step = "0.1"; Precision = "3"; > = 0.01;
	float4 cEmissionScrolling		 = {1, 1, 0, 0};
};

//////////////////////////////////Input Texture////////////////////////////////////////
texture2D tBaseMap : layout(t0) = "White";
sampler sBaseSampler : layout(s0)
{
	Texture = tBaseMap;
	Filter = Linear;
	Address = FromTexture;
	SRGB = false;
};

// texture2D tMixMap : layout(t1) = "Reflection";

texture2D tEnvMap : EnvMap : layout(t2) = "White";
sampler sEnvSampler : layout(s2)
{
	Texture = tEnvMap;
	Filter = Linear;
	Address = Clamp;
	SRGB = false; 
};

texture2D tNormalMap : layout(t3) = "NormalMap";
sampler sNormalSampler : layout(s3)
{
	Texture = tNormalMap;
	Filter = Linear;
	Address = Wrap;
	SRGB = false;
};

// Light map
texture2D tLightMap : layout(t4);
sampler sLightMapSampler : layout(s4)
{
	Texture = tLightMap;
	Filter = Linear;
	Address = Clamp;
	SRGB = false;
	MaxMipLevel = 0;
};

texture2D tShadowMask : ShadowMask : layout(t5) = "White";
sampler sShadowMaskSampler : layout(s5)
{
	Texture = tShadowMask; 
	Filter = Point; 
	Address = Clamp;
	SRGB = false;
	MaxMipLevel = 0;
};
// ShadowMap 
texture2D tShadowMap : ShadowMap : layout(t6) = "White";
SamplerComparisonState sShadowMapSampler : layout(s6)
{
	Texture = tShadowMap;
	Filter = Linear;
	Address = Clamp;
	ComparisonFunc = Greater;
	SRGB = false;
	MaxMipLevel = 0;
};
texture2D tRainMap : RainMap: layout(t8) = "NormalMap";
sampler sRainSampler : layout(s8)
{
	Texture = tRainMap;
	Filter = Linear;
	Address = Wrap;
	SRGB = false;
};
//about waterfall
texture2D tWaterMixMask  : layout(t1) = "Reflection";
sampler sWaterMixMaskSampler : layout(s1)
{
	Texture = tWaterMixMask;
	Filter = Linear;
	Address = Wrap;
	SRGB = false; 
	Precision = Medium;
};
texture2D tWaterFallFoam01  : layout(t0) = "White";
sampler sWaterFallFoam01Sampler : layout(s0)
{
	Texture = tWaterFallFoam01;
	Filter = Linear;
	Address = Wrap;
	SRGB = false; 
	Precision = Medium;
};
texture2D tWaterFallFoam02  : layout(t7) = "Black";
sampler sWaterFallFoam02Sampler : layout(s7)
{
	Texture = tWaterFallFoam02;
	Filter = Linear;
	Address = Wrap;
	SRGB = false; 
	Precision = Medium;
};
texture2D tWaterNormal  : layout(t9) = "Black";
sampler sWaterNormalSampler : layout(s9)
{
	Texture = tWaterNormal;
	Filter = Linear;
	Address = Wrap;
	SRGB = false; 
	Precision = Medium;
};

texture2D tSkeletonMap : SkeletonMap : layout(t3) = "Black";
sampler sSkeletonSampler : layout(s3)
{
	Texture = tSkeletonMap;
	Filter = Point;
	Address = Clamp;
	SRGB = false;
};
#include "PBR_VS.fxh"
//////////////////////////////////Function////////////////////////////////////////
half PositiveClampedPow( half X, half Y) //from UE4
{
	return pow( max(X,0),Y );
}

float2 Panner( half2 CoordinateIn,float TimeIn,half2 SpeedIn ) //from UE4
{
	float2 PannerOut = float2 (TimeIn*SpeedIn.r,TimeIn*SpeedIn.g) + CoordinateIn;
	return PannerOut;
}
//////////////////////////////////VS////////////////////////////////////////
void VS_DIY_OUTPUT(in VertexAssemble IN, in InterMediateVertex INTM, inout VertexShadingOutput OUT)
{
	// 1. init tint color
	InitTintColorCommon(IN, OUT); 

	// 2. for snow height calc
	OUT.WorldPosition.w = IN.Position.y;

	// 3. init emmision uv; if not need emmision uv
	InitEmissionUVCommon(IN, OUT);

	// 4. hposition calc
	InitHPositionCommon(INTM, OUT); // init hposition calc

	if(@_CastSunShadow && @_TRANSPARENT)
	{
		// for player's shadow		
		OUT.LitUVZ2 = MulMat4x4(ShadowViewProjTexs0, float4(OUT.WorldPosition.xyz + 
		OUT.WorldNormal.xyz * cBiasFarAwayShadow,1));
	}
}
#include "PBR_Common.fxh"
//////////////////////////////////PS////////////////////////////////////////
void PS_GetParameters(in VertexShadingOutput IN, out MaterialShadingParameters MaterialParameters)
{
	// 1. init MaterialParameters (always need)
	InitShadingParameters(MaterialParameters);
	half X = 1;
	half Y = 1; 
	half2 CoordinateIn = 1;
	float TimeIn = 1;
	half2 SpeedIn = 1;
	half FoamMixColor =1;
	half3 WatertangentNormal =half3(0,1,0);
	half Smoothness = 0.99;

	// 2. init MaterialParameters.BaseColor and MaterialParameters.Alpha by sample basemap
	MaterialParameters.BaseColor = half3(0.095307,0.155926,0.068478);
	half3 Watercolor = cWaterColor;//half3(0.095307,0.155926,0.068478);
	half3 Foamcolor = cBaseColor;//half3(1,0.819944,0.588542);
	half4 WaterMixMaskmap = half4(1,0,0.5,1);
	if(@_WithMaskMap)
	{
		//MixMask	
		WaterMixMaskmap = tWaterMixMask.Sample( sWaterMixMaskSampler, BaseMapUV(IN.TexCoord) );
		half reversedB = lerp((1-WaterMixMaskmap.b),WaterMixMaskmap.b,cVolumeOfWater);
		half DetailChannel = lerp(reversedB,WaterMixMaskmap.b+0.5,cVolumeOfWater*2-1);	
		//half MixMask = WaterMixMaskmap.g*2 + WaterMixMaskmap.r*DetailChannel;
		half MixMask = (WaterMixMaskmap.r+WaterMixMaskmap.g);
		//CoordinateMask
		X = IN.TexCoord.g;
		Y = cVolumeOfWater+cFoamFalloff;
		half CoordMask = PositiveClampedPow(X,Y);
		// Y = cLinkWithWater;
		// half LinkWithWaterOutput = PositiveClampedPow(X,Y);
		half MaskInput = MixMask*IN.TexCoord.g;
		//Panning
		float TimeWithVariation = (IN.WorldPosition.r+IN.WorldPosition.g)/4096+GameTime;
		CoordinateIn = IN.TexCoord.xy * half2(cEdgeMaskTilingX,cEdgeMaskTilingY);
		TimeIn = TimeWithVariation*cEdgeMaskSpeed;
		SpeedIn = half2(0.0,-0.1);
		float2 Foam1Panner =Panner(  CoordinateIn, TimeIn, SpeedIn );
		half4 WaterFallFoam01map = tWaterFallFoam01.Sample( sWaterFallFoam01Sampler,fmod(1-Foam1Panner,1) );
		half4 WaterFallFoam02map =1;
		float2 Foam2Panner =float2(1,1);
		if (@_LOD_LEVEL<=2 && @_WithWaterFallFoam02)
		{
			CoordinateIn = IN.TexCoord.xy * float2(cDirectionalFoam1TilingX,cDirectionalFoam1TilingY);
			TimeIn = TimeWithVariation*cDirectionalFoamSpeed;
			SpeedIn = half2(0.0,-0.125);
			Foam2Panner =Panner(  CoordinateIn, TimeIn, SpeedIn );
			WaterFallFoam02map = tWaterFallFoam02.Sample( sWaterFallFoam02Sampler,fmod(1-Foam2Panner,1) );
		}	
		//Color	
		half WaterFallRimMask = WaterFallFoam01map.r;
		half DirectionalFoam01 =cDirectionalFoam1Intensity*WaterFallFoam01map.a + 0.25;
		half DirectionalFoam02Mask = WaterFallFoam01map.b + 0.5;
		X=WaterFallFoam01map.g;
		if (@_LOD_LEVEL<=2 && @_WithWaterFallFoam02)	
		{
			WaterFallRimMask = WaterFallFoam01map.r*WaterFallFoam02map.r;
			DirectionalFoam01 = cDirectionalFoam1Intensity*WaterFallFoam01map.a + cDirectionalFoam1Intensity*WaterFallFoam02map.a;
			DirectionalFoam02Mask = WaterFallFoam01map.b+WaterFallFoam02map.b;
			X=WaterFallFoam02map.g;
		}
		half FoamIntensity = PositiveClampedPow(X,3)*(cVolumeOfWater+0.2);
		half DirectionalFoam02 = WaterFallFoam01map.g + DirectionalFoam02Mask*cDirectionalFoam2Intensity*(cVolumeOfWater+0.2);
		half FoamMix = lerp( (DirectionalFoam01+FoamIntensity),DirectionalFoam02,CoordMask );
		half FoamColorMask = saturate( FoamMix*(WaterMixMaskmap.g+WaterMixMaskmap.b) );
		half FoamMixColor = FoamMix*(cVolumeOfWater+0.5);
		FoamMixColor =lerp(0.5, 1, FoamMixColor);
		MaterialParameters.BaseColor = lerp(Watercolor,Foamcolor,FoamColorMask);
		//MaterialParameters.BaseColor.r = frac(GameTime);
		//Opacity
		half FoamOpacity = lerp(2,WaterFallFoam01map.g,CoordMask);
		half WaterFallOpacity = FoamOpacity*MaskInput;
		half OpacityOut = WaterMixMaskmap.a*saturate(WaterFallOpacity)*FoamMixColor;
		MaterialParameters.Alpha = saturate(OpacityOut);//min(cAlpha,OpacityOut);
		//to Smoothness&WorldNormal Part
		Smoothness = lerp(0.99,0.5,FoamColorMask);
		WatertangentNormal = tWaterNormal.SampleBias(sWaterNormalSampler, fmod(1-Foam2Panner,1), cNormalMapBias).xyz;
		WatertangentNormal = WatertangentNormal*2-1;
	}
	else
	{
		MaterialParameters.Alpha = cAlpha;
	}

	// footprint fade out effect
	
	// 3. init smoothness/metal/ao by sample mixmap
	if (@_EnableReflection && @_LOD_LEVEL <= LOD_Level_2)
	{
		//half Smoothness = 0.99;
		MaterialParameters.Metallic = 0;
		MaterialParameters.AO = 1;
		if (@_LOD_LEVEL == LOD_Level_2)
		{
			MaterialParameters.Metallic = lerp(0, MaterialParameters.Metallic, LOD_RATE);
			Smoothness = lerp(0.99, Smoothness, LOD_RATE);
		}
		MaterialParameters.Roughness = lerp(cRoughnessHigh, cRoughnessLow, Smoothness);
	}
	else	
	{
		MaterialParameters.Metallic = 0;
		if(ENABLE_MIXMAP || @_DEFERRED_SHADING)
			MaterialParameters.Roughness = lerp(cRoughnessHigh, cRoughnessLow, 0.99);
	}	

	// 4. init MaterialParameters.WorldNormal by sample normalmap
	if(@_TANGENT && @_NormalMapEnable && @_LOD_LEVEL <= LOD_Level_1)
	{
		half3 tangentNormal = tNormalMap.SampleBias(sNormalSampler, BaseMapUV(IN.TexCoord), cNormalMapBias).xyz;
		[@_DIRECTX]//always use bc5 for pc
		tangentNormal.z = 1;
		tangentNormal = (2 * tangentNormal) - 1;
		if (@_LOD_LEVEL == LOD_Level_1)
			tangentNormal.xy *= LOD_RATE;
		//tangentNormal.xy *= cBumpIns;
		half3 WaterfallNormal =	tangentNormal.x * IN.WorldTangent + tangentNormal.y * IN.WorldBinormal + tangentNormal.z * IN.WorldNormal.xyz;
		WaterfallNormal = normalize(WaterfallNormal);
		half3 WaterNormal = WatertangentNormal.x * IN.WorldTangent + WatertangentNormal.y * IN.WorldBinormal + WatertangentNormal.z * IN.WorldNormal.xyz;
		WaterNormal = normalize(WaterNormal);
		half WaterNormalMask = saturate(FoamMixColor + cWaterNormalInt);
		half3 Normalmix = lerp(WaterfallNormal,WaterNormal,WaterNormalMask);
		MaterialParameters.WorldNormal = half3(Normalmix.xy+WaterfallNormal.xy*cWaterFallNormalInt,WaterfallNormal.z);
		MaterialParameters.WorldNormal = normalize(MaterialParameters.WorldNormal);
	}
	else
	{
		if (@_LOD_LEVEL <= LOD_Level_2)
			MaterialParameters.WorldNormal = normalize(IN.WorldNormal.xyz);
		else
			MaterialParameters.WorldNormal = IN.WorldNormal.xyz;
	}

	
	// 5. init MaterialParameters.Emission by sample emissinMap (if need or not)
	//InitEmission(IN, MaterialParameters);
	
	// 6. init anisotropic by use cRoughnessX/cRoughnessY/cAnisotropicScale (if need or not)
	//InitAnisotropic(IN, MaterialParameters);
}
#include "PBR_PS.fxh"


