///	@file	<UIBasic.fx>
///	@path	~/Shader/UI/

#pragma shader draw
#pragma shader category("UI")

#include "Constants.fxh"
#include "Common.fxh"

cbuffer Batch
{
	float4x4 WorldViewProj		 	;
};

texture2D MainTexture				: layout(t0) = "Black";
sampler_state MainTexture_Sampler	: layout(s0)
{
	Texture = MainTexture;
	Filter = Point;
	Address = Clamp;
	MaxMipLevel = 0;
};

struct VertexAssemble
{
	float4		Position 				: POSITION;
	[@_VERTEXCOLOR]
	float3		Color					: COLOR;
	float2		TexCoord				: TEXCOORDN;
	[@_LIGHT_MAP]
	float2		TexCoord2				: TEXCOORDN;
};

struct VertexOutput
{
	float4		HPosition				: SV_Position;
	float2		TexCoord				: TEXCOORD0;
};

////////////////////////////////////////////////////////////////////////
// Translucent  UI draw.

VertexOutput UICustomMaskDrawVS(in VertexAssemble IN)
{
	VertexOutput OUT;

	[@_HLSL]
	OUT = (VertexOutput)0;

	OUT.HPosition = MulMat4x4(WorldViewProj, IN.Position);
	OUT.TexCoord = IN.TexCoord;

	return OUT;
}

float4 UICustomMaskDrawPS(in VertexOutput IN) : SV_Target
{
	float4 fragColor = float4(0,0,0,1);
	fragColor = MainTexture.Sample(MainTexture_Sampler, IN.TexCoord);
	return fragColor;
}

technique Shading
{
	VertexShader = UICustomMaskDrawVS();
	PixelShader = UICustomMaskDrawPS();
}
